#if !defined(_BIORITMVIEW_H)
#define _BIORITMVIEW_H

#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <unistd.h>

#include <qwidget.h>
#include <qpainter.h>
#include <qfont.h>
#include <qfontmetrics.h>
#include <qcolor.h>
#include <qrect.h>
#include <qevent.h>
#include <qpixmap.h>

#include "Typedef.h"
#include "Dynacolect.h"
#include "DoraClassObject.h"
#include "DoraBaseView.h"
#include "DoraPushButton.h"
#include "DoraEditString.h"
#include "CompareDate.h"
#include "DoraCheckHGroup.h"
#include "DateDialog.h"

class BioritmView : public DoraBaseView
{
public:
  struct strPoint {
    Str35 bDate;
    Str35 mDate;
    Str35 caption;
    bool  isRed;
    double xPointP, yPointP, xPointS, yPointS, xPointC, yPointC;
    uint countDay;
    strPoint(strPoint *x = NULL) {
      bDate = "";
      mDate = "";
      caption = "";
      xPointP = yPointP = countDay = 0;
      xPointS = yPointS = xPointC = yPointC = 0;
      isRed = false;
    }
    strPoint(const strPoint &x) {
      bDate = x.bDate;
      mDate = x.mDate;
      caption = x.caption;
      xPointP = x.xPointP;
      yPointP = x.yPointP;
      xPointS = x.xPointS;
      yPointS = x.yPointS;
      xPointC = x.xPointC;
      yPointC = x.yPointC;
      countDay = x.countDay;
      isRed = x.isRed;
    }
    strPoint &operator=(strPoint x) {
      bDate = x.bDate;
      mDate = x.mDate;
      caption = x.caption;
      xPointP = x.xPointP;
      yPointP = x.yPointP;
      xPointS = x.xPointS;
      yPointS = x.yPointS;
      xPointC = x.xPointC;
      yPointC = x.yPointC;
      countDay = x.countDay;
      isRed = x.isRed;
      return *this;
    }
  };
  typedef DoraArray<strPoint> TypeStrPoint;
      
public:
  DoraRuntimeClass *GetRuntimeClass() const {
    return &classBioritmView;
  }
  static DoraRuntimeClass classBioritmView;
  static DoraClassObject *CreateView(QWidget *parent);
  static DoraClassObject *CreateDocument();

public:
  BioritmView(QWidget *parent, const char *name = 0) : DoraBaseView(parent, name) {
    printf("   BioritmView\n");
    caption = "";
    strCurentMonth = "";
    itemPoint.removeAllElement();
    m_pCheckHGroup = NULL;
    m_pDateDialog = NULL;
    m_pPushButton = NULL;
    indexCicle = ID_CHECKBUTTON_ALLCICLE;
  }
  ~BioritmView() {
    printf("   BioritmView\n");
  }

public:
  DoraClassObject *m_pObject;
  DoraBaseView    *m_pView;
  DoraPushButton  *m_pPushButton;
  DoraCheckHGroup *m_pCheckHGroup;
  DateDialog      *m_pDateDialog;

public:
  DoraCentralDocument *GetDocument();

public:
  void OnCreate(DoraClassObject *pObject, DoraBaseView *pView);

public:
  void OnDraw(QPainter *p);
  void OnSize(int cx, int cy);
  void DestroyView();

public:
  void PostMouseMessage(int ctrl, int index);
  void setPixmap();

public:
  QRect       clientRect;
  QPixmap     pixmap;
  int         maxDay;
  Str80       caption;
  Str35       bDate;
  Str35       strCurentMonth;
  CompareDate compDate;
  int         indexCicle;

public:
  TypeStrPoint itemPoint;

protected:
  void sortPoint();
  void setNewBDate();
  void calcPoint();

};

#endif
