#include "DoraCentralDocument.h"
#include "CalcMonthDay.h"

DoraRuntimeClass CalcMonthDay::classCalcMonthDay={"CalcMonthDay", NULL, CalcMonthDay::CreateDocument};

DoraClassObject *CalcMonthDay::CreateView(QWidget *parent)
{
  return NULL;
}

DoraClassObject *CalcMonthDay::CreateDocument()
{
  return new CalcMonthDay();
}

void CalcMonthDay::runThread()
{
  printf(" runThread   CalcMonthDay\n");
  DoraCentralDocument *pDoc = dynamic_cast<DoraCentralDocument *>(m_pDocument);
  Str35 localDir;
  localDir = "";localDir = "/Calendar";
  fs.setDefaultDir();
  fs.createLocalDir();
  fs.setWorkDir(localDir);

  pDoc->m_pCriticalSection->lock();
  calDay = redDay = blcDay = 0;
  
  CompareDate dateMin(minDate);
  CompareDate dateMax(maxDate);

  int minDay   = dateMin.getDay();
  int minMonth = dateMin.getMonth();
  int minYear  = dateMin.getYear();

  int maxDay   = dateMax.getDay();
  int maxMonth = dateMax.getMonth();
  int maxYear  = dateMax.getYear();

  int year  = minYear;
  int month = minMonth;
  do {
    Str35 yearDir, str1, str2, strYear, strMonth, monthFile;
    str1 = "";sprintf(str1.p, "%4d\0", year);str2 = "";str2 = spaceNull(4, str1);
    strYear = "";strYear = str2;
    yearDir = "";yearDir = yearDir + "/Year" + strYear;
    fs.createDir(yearDir);
    int xYear;
    do {
      str1 = "";sprintf(str1.p, "%2d\0", month);str2 = "";str2 = spaceNull(2, str1);
      strMonth = "";strMonth = str2;
      monthFile = "";monthFile = monthFile + yearDir + "/MONTH" + strMonth + strYear;
      int maxrec = fs.maxRecord(monthFile);
      if(maxrec >= 1) {
	int rec = 1;
	DataRecord data;
	do {
	  fs.initDataRecord(0, 19, &data);fs.loadRecord(monthFile, rec, maxrec, &data);
	  Str35 s, r;
	  s = "";s = "1";r = "";r = "1";
	  if(data.Pole[5] == s) {
	    CompareDate d(data.Pole[3]);
	    if((d >= dateMin) && (d <= dateMax)) {
	      if(data.Pole[6] == r)
		redDay++;
	      else
		blcDay++;
	      calDay++;
	    }
	    xYear = d.getYear();
	  }
	  rec++;
	} while(rec <= maxrec);
      }
      month++;
      printf("month = %4d, year = %4d\n", month, year);
      if(month > 13)
	month = 13;
      if((month > maxMonth) && (year >= maxYear))
	month = 13;
    } while(month < 13);
    year++;month = 1;
  } while(year <= maxYear);
  printf("minDate = %s\n", minDate.p);
  printf("maxDate = %s\n", maxDate.p);
  printf("calDay = %4d\n", calDay);
  printf("redDay = %4d\n", redDay);
  printf("blcDay = %4d\n", blcDay);
  m_pDocument->updateDocument();
  m_pView->updateView();
  pDoc->m_pCriticalSection->unlock();
}

void CalcMonthDay::setDocument(DoraBaseDocument *pDocument)
{
  m_pDocument = pDocument;
}

void CalcMonthDay::setView(DoraBaseView *pView)
{
  m_pView = pView;
}
