#if !defined(_CALCMONTHDAY_H)
#define _CALCMONTHDAY_H

#include <qwidget.h>

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <ctype.h>
#include <typeinfo>
#include <limits.h>
#include <pthread.h>

#include "Typedef.h"
#include "Dynacolect.h"
#include "CompareDate.h"
#include "DoraFileSystem.h"
#include "DoraClassObject.h"
#include "DoraBaseThread.h"
#include "DoraBaseDocument.h"
#include "DoraBaseView.h"

class CalcMonthDay : public DoraBaseThread
{
public:
  DoraRuntimeClass *GetRuntimeClass() const {
    return &classCalcMonthDay;
  }
  static DoraRuntimeClass classCalcMonthDay;
  static DoraClassObject *CreateView(QWidget *parent);
  static DoraClassObject *CreateDocument();

public:
  CalcMonthDay() : DoraBaseThread() {
    printf("   CalcMonthDay\n");
    calDay = redDay = blcDay = 0;
  }
  ~CalcMonthDay() {
    printf("   CalcMonthDay\n");
  }

public:
  void runThread();

public:
  Str35 minDate;
  Str35 maxDate;
  int calDay, redDay, blcDay;

public:
  DoraFileSystem   fs;
  DoraClassObject  *m_pObject;
  DoraBaseView     *m_pView;
  DoraBaseDocument *m_pDocument;

public:
  void setView(DoraBaseView *pView);
  void setDocument(DoraBaseDocument *pDocument);

};

#endif
