#include "DoraCentralDocument.h"
#include "CalcNewYear.h"

DoraRuntimeClass CalcNewYear::classCalcNewYear={"CalcNewYear", NULL, CalcNewYear::CreateDocument};

DoraClassObject *CalcNewYear::CreateView(QWidget *parent)
{
  return NULL;
}

DoraClassObject *CalcNewYear::CreateDocument()
{
  return new CalcNewYear();
}

CalcNewYear::CalcNewYear() : DoraBaseThread() {
    printf("   CalcNewYear\n");
    itemMonth.removeAllElement();
}

CalcNewYear::~CalcNewYear() {
    printf("   CalcNewYear\n");
}

void CalcNewYear::runThread()
{
  DoraCentralDocument *pDoc = dynamic_cast<DoraCentralDocument *>(m_pDocument);
  Str35 localDir;
  localDir = "";localDir = "/Calendar";
  fs.setDefaultDir();
  fs.createLocalDir();
  fs.setWorkDir(localDir);
  saveYear(curentYear);
}

void CalcNewYear::setView(DoraBaseView *pView)
{
  m_pView = pView;
}

void CalcNewYear::setDocument(DoraBaseDocument *pDocument)
{
  m_pDocument = pDocument;
}

void CalcNewYear::saveYear(int year)
{
  DoraCentralDocument *pDoc = dynamic_cast<DoraCentralDocument *>(m_pDocument);
  pDoc->m_pCriticalSection->lock();
  saveMonth(curentMonth, year);
  pDoc->m_pCriticalSection->unlock();
  sleep(1);
  pDoc->m_pCriticalSection->lock();
  for(int i = 1; i <= 12; i++) {
    if(i != curentMonth) {
      saveMonth(i, year);
    }
  }
  pDoc->m_pCriticalSection->unlock();
}

void CalcNewYear::saveMonth(int month, int year)
{
  DoraCentralDocument *pDoc = dynamic_cast<DoraCentralDocument *>(m_pDocument);
  printf("month = %4d, year = %4d\n", month, year);
  Str35 str1, str2, strMonth, strYear, yearDir, monthFile;
  str1 = "";sprintf(str1.p, "%2d\0", month);str2 = "";str2 = spaceNull(2, str1);
  strMonth = "";strMonth = str2;
  str1 = "";sprintf(str1.p, "%4d\0", year);str2 = "";str2 = spaceNull(4, str1);
  strYear = "";strYear = str2;
  yearDir = "";yearDir = yearDir + "/Year" + strYear;
  fs.createDir(yearDir);
  monthFile = "";monthFile = monthFile + yearDir + "/MONTH" + strMonth + strYear;
  DataRecord data;
  int rec;
  int maxrec = fs.maxRecord(monthFile);
  if(maxrec <= 0) {
    rec = 1;maxrec = 0;
    generateMonth(month, year);
    int maxElement = itemMonth.maxElement();
    for(int i = 0; i <= maxElement - 1; i++) {
      fs.initDataRecord(0, 19, &data);
      Str35 str1, str2;
      str1 = "";sprintf(str1.p, "%4d\0", itemMonth[i].index);str2 = "";str2 = spaceNull(4, str1);
      data.Pole[0] = str2;
      data.Pole[1] = itemMonth[i].caption;
      data.Pole[2] = itemMonth[i].infoStr;
      data.Pole[3] = itemMonth[i].dateStr;
      str1 = "";sprintf(str1.p, "%4d\0", itemMonth[i].week);str2 = "";str2 = spaceNull(4, str1);
      data.Pole[4] = str2;
      data.Pole[5] = "1";
      if(!itemMonth[i].isValid) {
	data.Pole[5] = "";data.Pole[5] = "0";
      }
      data.Pole[6] = "1";
      if(!itemMonth[i].isRed) {
	data.Pole[6] = "";data.Pole[6] = "0";
      }
      data.Pole[7] = "1";
      if(!itemMonth[i].isCurent) {
	data.Pole[7] = "";data.Pole[7] = "0";
      }
      data.Pole[8] = "";data.Pole[8] = pDoc->bDate;
      fs.saveRecord(monthFile, rec, maxrec, data);
      rec++;maxrec++;
    }
  }
}

void CalcNewYear::generateMonth(int month, int year)
{
  DoraCentralDocument *pDoc = dynamic_cast<DoraCentralDocument *>(m_pDocument);

  int day = 1;
  strMonth item;
  int maxDay = compDate.getMaxDayMonth(month, year);
  CString strDate, strDay, stMonth, strYear;
  for(int i = 0; i <= 34; i++) {
    item.caption = "";
    item.infoStr = "";
    item.dateStr = "";
    item.isRed = false;
    item.isValid = false;
    item.index = i + 1;
    item.week = 0;
    item.isCurent = false;
    itemMonth.setElement(item, i + 1);
  }
  maxDayMonth = maxDay;
  char *sDay = new char[3];
  sDay[0] = '\0';sprintf(sDay, "%2d\0", day);strDay = "";strDay = spaceNull(2, sDay);
  delete sDay;
  char *sMonth = new char[3];
  sMonth[0] = '\0';sprintf(sMonth, "%2d\0", month);stMonth = "";stMonth = spaceNull(2, sMonth);
  delete sMonth;
  char *sYear = new char[5];
  sYear[0] = '\0';sprintf(sYear, "%4d\0", year);strYear = "";strYear = spaceNull(4, sYear);
  delete sYear;
  strDate = "";strDate = strDate + strDay + "/" + stMonth + "/" + strYear;
  int week = compDate.getDayOfWeek(strDate);
  int k = 0;
  for(int i = week - 1; i <= 34; i++) {
    if(day <= maxDay) {
      sDay = new char[3];
      sDay[0] = '\0';sprintf(sDay, "%2d\0", day);strDay = "";strDay = spaceNull(2, sDay);
      delete sDay;
      strDate = "";strDate = strDate + strDay + "/" + stMonth + "/" + strYear;
      int w = compDate.getDayOfWeek(strDate);
      item.caption = "";item.caption = strDay.p;
      item.dateStr = "";item.dateStr = strDate.p;
      item.index = i + 1;
      item.isValid = true;
      item.isRed = false;
      item.week = w;
      if((w == 6) || (w == 7))
	item.isRed = true;
      Str35 monthName;
      monthName = "";monthName = loCase(pDoc->itemMonthName[month-1].name);
      item.infoStr = "";item.infoStr = item.infoStr + pDoc->itemDayName[w-1].name+", "+strDay.p+" "+monthName+" "+strYear.p;
      itemMonth.setElement(item, i + 1);
      k++;day++;
    }
  }
  if(day <= maxDay) {
    int index = 0;
    for(int i = k; i <= maxDay - 1; i++) {
      sDay = new char[3];
      sDay[0] = '\0';sprintf(sDay, "%2d\0", day);strDay = "";strDay = spaceNull(2, sDay);
      delete sDay;
      strDate = "";strDate = strDate + strDay + "/" + stMonth + "/" + strYear;
      int w = compDate.getDayOfWeek(strDate);
      item.caption = "";item.caption = strDay.p;
      item.dateStr = "";item.dateStr = strDate.p;
      item.index = i + 1;
      item.isValid = true;
      item.isRed = false;
      item.week = w;
      if((w == 6) || (w == 7))
	item.isRed = true;
      Str35 monthName;
      monthName = "";monthName = loCase(pDoc->itemMonthName[month-1].name);
      item.infoStr = "";item.infoStr = item.infoStr + pDoc->itemDayName[w-1].name+", "+strDay.p+" "+monthName+" "+strYear.p;
      itemMonth.setElement(item, index + 1);
      index++;day++;
    }
  }
}
