#if !defined(_CALCNEWYEAR_H)
#define _CALCNEWYEAR_H

#include <qwidget.h>

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <ctype.h>
#include <typeinfo>
#include <limits.h>
#include <pthread.h>

#include "Typedef.h"
#include "Dynacolect.h"
#include "CompareDate.h"
#include "DoraFileSystem.h"
#include "DoraClassObject.h"
#include "DoraBaseThread.h"
#include "DoraBaseDocument.h"
#include "DoraBaseView.h"

class CalcNewYear : public DoraBaseThread
{
public:
    struct strMonth {
    Str35 caption;
    int   index;
    int   week;
    Str35 dateStr;
    Str35 infoStr;
    bool  isValid;
    bool  isCurent;
    bool  isRed;

    strMonth(strMonth *x = NULL) {
      caption  = "";
      infoStr  = "";
      dateStr  = "";
      index    = 0;
      week     = 0;
      isValid  = false;
      isCurent = false;
      isRed = false;
    }
    strMonth(const strMonth &x) {
      caption = "";caption = x.caption;
      infoStr = "";infoStr = x.infoStr;
      dateStr = "";dateStr = x.dateStr;
      index = x.index;
      week  = x.week;
      isValid = x.isValid;
      isCurent = x.isCurent;
      isRed = x.isRed;
    }
    strMonth &operator=(strMonth x) {
      caption = "";caption = x.caption;
      infoStr = "";infoStr = x.infoStr;
      dateStr = "";dateStr = x.dateStr;
      index = x.index;
      week  = x.week;
      isValid = x.isValid;
      isCurent = x.isCurent;
      isRed = x.isRed;
      return *this;
    }
  };
  typedef DoraArray<strMonth>      TypeMonth;

public:
  DoraRuntimeClass *GetRuntimeClass() const {
    return &classCalcNewYear;
  }
  static DoraRuntimeClass classCalcNewYear;
  static DoraClassObject *CreateView(QWidget *parent);
  static DoraClassObject *CreateDocument();

public:
  CalcNewYear();
  ~CalcNewYear();

public:
  void runThread();

public:
  DoraFileSystem      fs;
  DoraClassObject     *m_pObject;
  DoraBaseView        *m_pView;
  DoraBaseDocument    *m_pDocument;
  TypeMonth           itemMonth;
  CompareDate         compDate;

public:
  int maxDayMonth;
  int curentDay;
  int curentMonth;
  int curentYear;

public:
  void setView(DoraBaseView *pView);
  void setDocument(DoraBaseDocument *pDocument);
  void saveYear(int year);
  void saveMonth(int month, int year);
  void generateMonth(int month, int year);

};

#endif
