#include "CompareDate.h"

CompareDate::CompareDate()
{
  date = "";
}

CompareDate::CompareDate(const CString newDate)
{
   date = "";date = newDate;
}

CompareDate::CompareDate(Str35 newDate)
{
  date = "";date = newDate;
}
  
CompareDate::CompareDate(const CompareDate &x)
{
  date = "";date = x.date;
}

CompareDate CompareDate::operator=(const CompareDate &x)
{
  date = "";date = x.date;
  return *this;
}

bool CompareDate::operator==(const CompareDate x) 
{
  uint jd1 = greg2jul(date);
  uint jd2 = greg2jul(x.date);
  return jd1 == jd2;
}

bool CompareDate::operator!=(const CompareDate x) 
{
  uint jd1 = greg2jul(date);
  uint jd2 = greg2jul(x.date);
  return jd1 != jd2;
}

bool CompareDate::operator>(const CompareDate x) 
{
  uint jd1 = greg2jul(date);
  uint jd2 = greg2jul(x.date);
  return jd1 > jd2;
}

bool CompareDate::operator>=(const CompareDate x) 
{
  uint jd1 = greg2jul(date);
  uint jd2 = greg2jul(x.date);
  return jd1 >= jd2;
}

bool CompareDate::operator<(const CompareDate x) 
{
  uint jd1 = greg2jul(date);
  uint jd2 = greg2jul(x.date);
  return jd1 < jd2;
}

bool CompareDate::operator<=(const CompareDate x) 
{
  uint jd1 = greg2jul(date);
  uint jd2 = greg2jul(x.date);
  return jd1 <= jd2;
}

uint CompareDate::greg2jul(const CString sDate) 
{
   CString sDay, sMonth, sYear;
   sDay   = "";sDay   = copyStr(sDate, 1, 2);
   sMonth = "";sMonth = copyStr(sDate, 4, 2);
   sYear  = "";sYear  = copyStr(sDate, 7, 4);

   int d = atoi(sDay.p);
   int m = atoi(sMonth.p);
   int y = atoi(sYear.p);

   uint c, ya;
   if ( y <= 99 )
     y += 1900;
   if ( m > 2 ) {
     m -= 3;
    } else {
      m += 9;
      y--;
   }
   c = y;
   c /= 100;
   ya = y - 100*c;
   return 1721119 + d + (146097*c)/4 + (1461*ya)/4 + (153*m+2)/5;
}
  
CString CompareDate::jul2greg(uint jd)
{
  int m, d, y;
  CString resultDate, strDay, strMonth, strYear;
  uint x;
  uint j = jd - 1721119;
  y = (j * 4 - 1) / 146097;
  j = j * 4 - 146097 * y - 1;
  x = j / 4;
  j = (x * 4 + 3) / 1461;
  y = 100 * y + j;
  x = (x * 4) + 3 - 1461 * j;
  x = (x + 4) / 4;
  m = (5 * x - 3) / 153;
  x = 5 * x - 3 - 153 * m;
  d = (x + 5) / 5;
  if ( m < 10 ) {
    m += 3;
  } else {
    m -= 9;
    y++;
  }
  char *s = new char[5];
  s[0] = '\0';sprintf(s, "%2d\0", d);strDay   = "";strDay   = spaceNull(2, s);
  s[0] = '\0';sprintf(s, "%2d\0", m);strMonth = "";strMonth = spaceNull(2, s);
  s[0] = '\0';sprintf(s, "%4d\0", y);strYear  = "";strYear  = spaceNull(4, s);
  resultDate = "";resultDate = resultDate + strDay + "/" + strMonth + "/" + strYear;
  delete s;
  return resultDate;
}

int CompareDate::getIntervalDate(const CString BDate, const CString EDate) 
{
   uint jd1 = greg2jul(BDate);
   uint jd2 = greg2jul(EDate);
   int result = jd2 - jd1;
   return result;
}

int CompareDate::getIntervalDate(const Str35 BDate, const Str35 EDate)
{
  CString strBDate, strEDate;
  strBDate = "";strBDate = BDate;
  strEDate = "";strEDate = EDate;
  uint jd1 = greg2jul(strBDate);
  uint jd2 = greg2jul(strEDate);
  int result = jd2 - jd1;
  return result;
}

CString CompareDate::getPrevDate() 
{
   uint jd = greg2jul(date);
   jd--;
   CString resultDate;
   resultDate = "";resultDate = jul2greg(jd);
   return resultDate;
}

CString CompareDate::getNextDate() 
{
   uint jd = greg2jul(date);
   jd++;
   CString resultDate;
   resultDate = "";resultDate = jul2greg(jd);
   return resultDate;
}

CString CompareDate::getCurentDate() 
{
   time_t ltime;
   time(&ltime);
   tm *t = localtime(&ltime);
   int d = t->tm_mday;
   int m = t->tm_mon + 1;
   int y = t->tm_year + 1900;
   curentDay   = d;
   curentMonth = m;
   curentYear  = y;
   CString date, strDay, strMonth, strYear;
   char *s = new char[4];
   s[0] = '\0';sprintf(s, "%2d\0", d);strDay   = "";strDay   = spaceNull(2, s);
   s[0] = '\0';sprintf(s, "%2d\0", m);strMonth = "";strMonth = spaceNull(2, s);
   s[0] = '\0';sprintf(s, "%4d\0", y);strYear  = "";strYear  = spaceNull(4, s);
   delete s;
   date = "";date = date + strDay + "/" + strMonth + "/" + strYear;
   return date;
}

int CompareDate::getCurrentDay() 
{
   return curentDay;
}

int CompareDate::getCurentMonth() 
{
   return curentMonth;
}

int CompareDate::getCurentYear() 
{
   return curentYear;
}

int CompareDate::getDayOfWeek(const CString date)
{
  uint jd = greg2jul(date);
 
  return (((jd + 1) % 7) + 6) % 7 + 1;
}

int CompareDate::getDayOfWeek(const Str35 date)
{
  CString str;
  str = "";str = str + date;
  uint jd = greg2jul(str);
 
  return (((jd + 1) % 7) + 6) % 7 + 1;
}


CString CompareDate::convertToString(const CString date)
{
  ItemDayName   itemDay;
  ItemMonthName itemMonth;

  dayName.removeAllElement();
  monthName.removeAllElement();

  itemMonth.name = "";itemMonth.name = "";
  setMonthName(itemMonth, 1);
  itemMonth.name = "";itemMonth.name = "";
  setMonthName(itemMonth, 2);
  itemMonth.name = "";itemMonth.name =  "";
  setMonthName(itemMonth, 3);
  itemMonth.name = "";itemMonth.name = "";
  setMonthName(itemMonth, 4);
  itemMonth.name = "";itemMonth.name = "";
  setMonthName(itemMonth, 5);
  itemMonth.name = "";itemMonth.name = "";
  setMonthName(itemMonth, 6);
  itemMonth.name = "";itemMonth.name = "";
  setMonthName(itemMonth, 7);
  itemMonth.name = "";itemMonth.name = "";
  setMonthName(itemMonth, 8);
  itemMonth.name = "";itemMonth.name = "";
  setMonthName(itemMonth, 9);
  itemMonth.name = "";itemMonth.name = "";
  setMonthName(itemMonth, 10);
  itemMonth.name = "";itemMonth.name = "";
  setMonthName(itemMonth, 11);
  itemMonth.name = "";itemMonth.name = "";
  setMonthName(itemMonth, 12);

  itemDay.name = "";itemDay.name = "";
  setDayName(itemDay, 1);
  itemDay.name = "";itemDay.name = "";
  setDayName(itemDay, 2);
  itemDay.name = "";itemDay.name = "";
  setDayName(itemDay, 3);
  itemDay.name = "";itemDay.name = "";
  setDayName(itemDay, 4);
  itemDay.name = "";itemDay.name = "";
  setDayName(itemDay, 5);
  itemDay.name = "";itemDay.name = "";
  setDayName(itemDay, 6);
  itemDay.name = "";itemDay.name = "";
  setDayName(itemDay, 7);

  int d = atoi(copyStr(date, 1, 2).p);
  int m = atoi(copyStr(date, 4, 2).p);
  int y = atoi(copyStr(date, 7, 4).p);

  int w = getDayOfWeek(date);

  CString strDay;
  strDay = "";strDay = strDay + dayName[w-1].name + ", " + copyStr(date, 1, 2) + " " + monthName[m-1].name + " " + copyStr(date, 7, 4);

  return strDay;
}

void CompareDate::setDayName(ItemDayName item, const int index)
{
  ItemDayName itemName;
  itemName = item;
  dayName.setElement(itemName, index);
}

void CompareDate::setMonthName(ItemMonthName item, const int index)
{
  ItemMonthName itemName;
  itemName = item;
  monthName.setElement(itemName, index);
}

int CompareDate::getMaxDayMonth(const int month, const int year)
{
  int day = 1;
  int month1, year1;
  if(month == 12) {
    month1 = 1;year1 = year + 1;
  } else {
    month1 = month + 1;
    year1  = year;
  }
  CString strDay, strMonth, strYear;
  CString sDay1, sMonth1, sYear1, sDay2, sMonth2, sYear2;
  strDay   = "";sprintf(strDay.p, "%2d\0", day);sDay1 = "";sDay1 = spaceNull(2, strDay);
  strMonth = "";sprintf(strMonth.p, "%2d\0", month);sMonth1 = "";sMonth1 = spaceNull(2, strMonth);
  strYear  = "";sprintf(strYear.p, "%4d\0", year);sYear1 = "";sYear1 = spaceNull(4, strYear);
  strDay   = "";sprintf(strDay.p, "%2d\0", day);sDay2 = "";sDay2 = spaceNull(2, strDay);
  strMonth = "";sprintf(strMonth.p, "%2d\0", month1);sMonth2 = "";sMonth2 = spaceNull(2, strMonth);
  strYear  = "";sprintf(strYear.p, "%4d\0", year1);sYear2 = "";sYear2 = spaceNull(4, strYear);
  CString BDate, EDate;
  BDate = "";sprintf(BDate.p, "%s/%s/%s\0", sDay1.p, sMonth1.p, sYear1.p);
  EDate = "";sprintf(EDate.p, "%s/%s/%s\0", sDay2.p, sMonth2.p, sYear2.p);
  int result = getIntervalDate(BDate, EDate);
  return result;
}

int CompareDate::getDay()
{
  int day;
  day = atoi(copyStr(date, 1, 2).p);
  return day;
}

int CompareDate::getMonth()
{
  int month;
  month = atoi(copyStr(date, 4, 2).p);
  return month;
}

int CompareDate::getYear()
{
  int year;
  year = atoi(copyStr(date, 7, 4).p);
  return year;
}
