#if !defined(_COMPAREDATE_H)
#define _COMPAREDATE_H

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <ctype.h>
#include <string.h>
#include <math.h>
#include <time.h>
#include <typeinfo>

#include "Typedef.h"
#include "Dynacolect.h"

class CompareDate
{
private:
  struct ItemDayName {
    Str35 name;

    ItemDayName(ItemDayName *x = NULL) {
      name = "";
    }

    ItemDayName(const ItemDayName &x) {
      name = "";name = x.name;
    }

    ItemDayName &operator=(ItemDayName x) {
      name = "";name = x.name;
      return *this;
    }
  };

  struct ItemMonthName {
    Str35 name;

    ItemMonthName(ItemMonthName *x = NULL) {
      name = "";
    }
  
    ItemMonthName(const ItemMonthName &x) {
      name = "";name = x.name;
    }

    ItemMonthName &operator=(ItemMonthName x) {
      name = "";name = x.name;
      return *this;
    }
  };
  
  typedef DoraArray<ItemDayName>   TypeDayName;
  typedef DoraArray<ItemMonthName> TypeMonthName;

public:
  CompareDate();
  CompareDate(const CString newDate);
  CompareDate(Str35 newDate);
  CompareDate(const CompareDate &x);
  CompareDate operator=(const CompareDate &x);
  bool operator==(const CompareDate x);
  bool operator!=(const CompareDate x);
  bool operator>(const CompareDate x);
  bool operator>=(const CompareDate x);
  bool operator<(const CompareDate x);
  bool operator<=(const CompareDate x);

private:
  int curentDay;
  int curentMonth;
  int curentYear;

private:
  uint    greg2jul(const CString sDate);
  CString jul2greg(uint jd);
  void    setDayName(ItemDayName item, const int index);
  void    setMonthName(ItemMonthName item, const int index);

public:
  int     getIntervalDate(const CString BDate, const CString EDate);
  int     getIntervalDate(const Str35 BDate, const Str35 EDate);
  CString getPrevDate();
  CString getNextDate();
  CString getCurentDate();
  int     getCurrentDay();
  int     getCurentMonth();
  int     getCurentYear();
  int     getDayOfWeek(const CString date);
  int     getDayOfWeek(const Str35   date);
  CString convertToString(const CString date);
  int     getMaxDayMonth(const int month, const int year);
  int     getDay();
  int     getMonth();
  int     getYear();
public:
  CString       date;
  TypeDayName   dayName;
  TypeMonthName monthName;

};

#endif





