#if !defined(_DATEDIALOG_H)
#define _DATEDIALOG_H

#include <qapplication.h>
#include <qwidget.h>
#include <qevent.h>
#include <qfont.h>
#include <qfontmetrics.h>
#include <qpainter.h>
#include <qcolor.h>
#include <qrect.h>
#include <qfontdialog.h>
#include <qpixmap.h>

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <ctype.h>
#include <typeinfo>

#include "Typedef.h"
#include "Dynacolect.h"
#include "DoraClassObject.h"
#include "DoraBaseView.h"
#include "DoraBaseDialog.h"
#include "DoraEditBox.h"

class DateDialog : public DoraBaseDialog
{
public:
  DoraRuntimeClass *GetClassObject() const {
    return &classDateDialog;
  }
  static DoraRuntimeClass classDateDialog;
  static DoraClassObject *CreateView(QWidget *parent);
  static DoraClassObject *CreateDocument();

public:
  DateDialog(QWidget *parent, const char *name = 0) : DoraBaseDialog(parent, name) {
    printf("   DateDialog\n");
    caption = "";
    m_pEditBox = NULL;
  }
  ~DateDialog() {
    printf("   DateDialog\n");
  }

public:
  DoraClassObject *m_pObject;
  DoraBaseView    *m_pView;
  DoraEditBox     *m_pEditBox;

public:
  void OnDraw(QPainter *p);
  void OnSize(int cx, int cy);
  void DestroyDialog();

public:
  void OnCreate(DoraClassObject *pObject, DoraBaseView *pView);
  DoraCentralDocument *GetDocument();

public:
  QPixmap pixmap;
  Str35   caption;

public:
  void setData(DataRecord data);
  void getData(DataRecord *data);
  void setAttr(const int index);

};

#endif
