#if !defined(_DORAABAUTVIEW_H)
#define _DORAABAUTVIEW_H

#include <qapplication.h>
#include <qwidget.h>
#include <qevent.h>
#include <qfont.h>
#include <qfontmetrics.h>
#include <qpainter.h>
#include <qcolor.h>
#include <qrect.h>
#include <qfontdialog.h>

#include "Typedef.h"
#include "Dynacolect.h"
#include "DoraClassObject.h"
#include "DoraBaseView.h"
#include "DoraPushButton.h"

class DoraAbautView : public DoraBaseView
{
public:
  DoraRuntimeClass *GetRuntimeClass() const {
    return &classDoraAbautView;
  }
  static DoraRuntimeClass classDoraAbautView;
  static DoraClassObject *CreateView(QWidget *parent);
  static DoraClassObject *CreateDocument();

public:
  DoraAbautView(QWidget *parent, const char *name = 0) : DoraBaseView(parent, name) {
    printf("   DoraAbautView\n");
  }
  ~DoraAbautView() {
    printf("   DoraAbautView\n");
  }

public:
  void OnDraw(QPainter *p);
  void OnSize(int cx, int cy);

public:
  void OnCreate(DoraClassObject *pObject, DoraBaseView *pView);
  DoraCentralDocument *GetDocument();

public:
  DoraClassObject *m_pObject;
  DoraBaseView    *m_pView;
  DoraPushButton  *m_pPushButton;

public:
  QRect clientRect;
  QRect titleRect;
  QRect textRect;
  QRect buttonRect;
  CString caption;

public:
  void PostMouseMessage(int ctrl, int index);

};

#endif
