#include "DoraBaseCtrl.h"

DoraRuntimeClass DoraBaseCtrl::classDoraBaseCtrl = {"DoraBaseCtrl", DoraBaseCtrl::CreateView, NULL};

DoraClassObject *DoraBaseCtrl::CreateView(QWidget *parent)
{
  return new DoraBaseCtrl(parent);
}

DoraClassObject *DoraBaseCtrl::CreateDocument()
{
  return NULL;
}

void DoraBaseCtrl::paintEvent(QPaintEvent *e)
{
  QPainter p(this);
  OnDraw(&p);
}

void DoraBaseCtrl::resizeEvent(QResizeEvent *e)
{
  QSize size = e->size();
  int cx = size.width();
  int cy = size.height();
  OnSize(cx, cy);
}

void DoraBaseCtrl::hideEvent(QHideEvent *e)
{
  OnHide();
}

void DoraBaseCtrl::showEvent(QShowEvent *e)
{
  OnShow();
}

void DoraBaseCtrl::OnDraw(QPainter *p)
{
}

void DoraBaseCtrl::OnSize(int cx, int cy)
{
}

void DoraBaseCtrl::OnHide()
{
}

void DoraBaseCtrl::OnShow()
{
}

void DoraBaseCtrl::keyPressEvent(QKeyEvent *e)
{
  if((e->state() == ControlButton) || (e->state() == ShiftButton) || (e->state() == AltButton)) {
      KeyStat(e->state(), e->key());
  }
  if((e->ascii() >= 32) && (e->ascii() <= 255) && (e->ascii() != 127))
     KeyChar(e->ascii());
  else {
    if((e->state() != ControlButton) && (e->state() != ShiftButton) && (e->state() != AltButton))
      KeyChar(e->key());
  }
}

void DoraBaseCtrl::mousePressEvent(QMouseEvent *e)
{
  int xpos  = e->x();
  int ypos  = e->y();
  int gXpos = e->globalX();
  int gYpos = e->globalY();

  if(e->button() & LeftButton)
    MouseLeftButton(xpos, ypos, gXpos, gYpos);

  if(e->button() & RightButton)
    MouseRightButton(xpos, ypos, gXpos, gYpos);

  if(e->button() & MidButton)
    MouseMidButton(xpos, ypos, gXpos, gYpos);
}

void DoraBaseCtrl::mouseReleaseEvent(QMouseEvent *e)
{
  MouseRelease();
}

void DoraBaseCtrl::mouseMoveEvent(QMouseEvent *e)
{
  xMovePos = e->x();
  yMovePos = e->y();
  MouseMove();
}

void DoraBaseCtrl::focusInEvent(QFocusEvent *e)
{
  setOnFocus();
}

void DoraBaseCtrl::focusOutEvent(QFocusEvent *e)
{
  setNoFocus();
}

void DoraBaseCtrl::MouseMove()
{
}

void DoraBaseCtrl::MouseRelease()
{
}

void DoraBaseCtrl::MouseLeftButton(int xLocPos, int yLocPos, int xPosGlb, int yPosGlb)
{
}

void DoraBaseCtrl::MouseRightButton(int xLocPos, int yLocPos, int xPosGlb, int yPosGlb)
{
}

void DoraBaseCtrl::MouseMidButton(int xLocPos, int yLocPos, int xPosGlb, int yPosGlb)
{
}

void DoraBaseCtrl::KeyChar(int keyCode)
{
}

void DoraBaseCtrl::KeyStat(int stat, int keyCode)
{
}

void DoraBaseCtrl::setOnFocus()
{
}

void DoraBaseCtrl::setNoFocus()
{
}

void DoraBaseCtrl::setNewCaption(CString newCaption)
{
}

void DoraBaseCtrl::selectNewFont(QFont fn)
{
  font = QFont(fn);
}

void DoraBaseCtrl::UpdateConvChar()
{
}
