#if !defined(_DORABASECTRL_H)
#define _DORABASECTRL_H

#include <qapplication.h>
#include <qwidget.h>
#include <qevent.h>
#include <qrect.h>
#include <qcolor.h>
#include <qbrush.h>
#include <qfont.h>
#include <qfontmetrics.h>
#include <qpainter.h>

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <ctype.h>
#include <typeinfo>

#include "Typedef.h"
#include "Dynacolect.h"
#include "DoraClassObject.h"
#include "DoraConvChar.h"

class DoraBaseCtrl : public QWidget, public DoraClassObject
{
public:
  DoraRuntimeClass *GetRuntimeClass() const {
    return &classDoraBaseCtrl;
  }
  static DoraRuntimeClass classDoraBaseCtrl;
  static DoraClassObject *CreateView(QWidget *parent);
  static DoraClassObject *CreateDocument();

public:
  DoraBaseCtrl(QWidget *parent, const char *name = 0) : QWidget(parent, name), DoraClassObject() {
    printf("   DoraBaseCtrl\n");
  }

  void DestroyObject() {
    delete this;
  }

  virtual ~DoraBaseCtrl() {
    printf("   DoraBaseCtrl\n");
  }

private:
  void paintEvent(QPaintEvent *e);
  void resizeEvent(QResizeEvent *e);
  void keyPressEvent(QKeyEvent *e);
  void mousePressEvent(QMouseEvent *e);
  void mouseReleaseEvent(QMouseEvent *e);
  void mouseMoveEvent(QMouseEvent *e);
  void focusInEvent(QFocusEvent *e);
  void focusOutEvent(QFocusEvent *e);
  void hideEvent(QHideEvent *e);
  void showEvent(QShowEvent *e);

public:
  virtual void OnDraw(QPainter *p);
  virtual void OnSize(int cx, int cy);
  virtual void OnHide();
  virtual void OnShow();

public:
  virtual void MouseMove();
  virtual void MouseRelease();
  virtual void MouseLeftButton(int xLocPos, int yLocPos, int xPosGlb, int yPosGlb);
  virtual void MouseRightButton(int xLocPos, int yLocPos, int xPosGlb, int yPosGlb);
  virtual void MouseMidButton(int xLocPos, int yLocPos, int xPosGlb, int yPosGlb);
  virtual void KeyChar(int keyCode);
  virtual void KeyStat(int stat, int keyCode);
  virtual void setOnFocus();
  virtual void setNoFocus();
  virtual void setNewCaption(CString newCaption);
  virtual void UpdateConvChar();

public:
  QFont        font;
  DoraConvChar convChar;
public:
  void selectNewFont(QFont fn);

public:
  int xMovePos;
  int yMovePos;

};

#endif







