#include "DoraBaseDialog.h"

DoraRuntimeClass DoraBaseDialog::classDoraBaseDialog={"DoraBaseDialog", DoraBaseDialog::CreateView, NULL};

DoraClassObject *DoraBaseDialog::CreateView(QWidget *parent)
{
  return new DoraBaseDialog(parent);
}

DoraClassObject *DoraBaseDialog::CreateDocument()
{
  return NULL;
}

void DoraBaseDialog::paintEvent(QPaintEvent *e)
{
  QPainter p(this);
  OnDraw(&p);
}

void DoraBaseDialog::resizeEvent(QResizeEvent *e)
{
  QSize size = e->size();

  int cx = size.width();
  int cy = size.height();

  OnSize(cx, cy);
}

void DoraBaseDialog::OnDraw(QPainter *p)
{
}

void DoraBaseDialog::OnSize(int cx, int cy)
{
}

void DoraBaseDialog::PostMouseMessage(int ctrl, int index)
{
}

void DoraBaseDialog::DrawRamkaEdit(QPainter *p)
{
  p->setFont(font);
  p->setPen(QPen(QColor(0, 0, 0), 1));
  p->setBrush(QBrush(QColor(192, 192, 192)));
  p->drawRect(clientRect);
  
  int x1 = clientRect.x();
  int y1 = clientRect.y();
  int x2 = clientRect.width() - 1;
  int y2 = clientRect.height() - 1;

  int xr1 = x1 + 1;
  int yr1 = y1 + 1;
  int xr2 = x2 - 1;
  int yr2 = y2 - 1;
  p->setPen(QPen(QColor(255, 255, 255), 1));
  p->drawLine(xr1, yr2, xr1, yr1);
  p->drawLine(xr1, yr1, xr2, yr1);
  p->setPen(QPen(QColor(0, 0, 0), 1));
  p->drawLine(xr1, yr2, xr2, yr2);
  p->drawLine(xr2, yr2, xr2, yr1);

  xr1 = x1 + 3;
  yr1 = y1 + 3;
  xr2 = x2 - 3;
  yr2 = yr1 + titleRect.height() + 2;
  p->setPen(QPen(QColor(0, 0, 0), 1));
  p->drawLine(xr1, yr2, xr1, yr1);
  p->drawLine(xr1, yr1, xr2, yr1);
  p->setPen(QPen(QColor(255, 255, 255), 1));
  p->drawLine(xr1, yr2, xr2, yr2);
  p->drawLine(xr2, yr2, xr2, yr1);

  yr1 = yr2 + 3;
  yr2 = y2 - 29;
  p->setPen(QPen(QColor(0, 0, 0), 1));
  p->drawLine(xr1, yr2, xr1, yr1);
  p->drawLine(xr1, yr1, xr2, yr1);
  p->setPen(QPen(QColor(255, 255, 255), 1));
  p->drawLine(xr1, yr2, xr2, yr2);
  p->drawLine(xr2, yr2, xr2, yr1);

  p->setBrush(QBrush(QColor(0, 0, 255)));
  p->setPen(QPen(QColor(0, 0, 0), 1));
  p->drawRect(titleRect);

  int xm1 = menuRect.x() + 1;
  int ym1 = menuRect.y() + 1;
  int xm2 = xm1 + (menuRect.width() - 2);
  int ym2 = ym1 + (menuRect.height() - 2);

  p->setPen(QPen(QColor(255, 255, 255), 1));
  p->drawLine(xm1, ym2, xm1, ym1);
  p->drawLine(xm1, ym1, xm2, ym1);
  p->setPen(QPen(QColor(0, 0, 0), 1));
  p->drawLine(xm1, ym2, xm2, ym2);
  p->drawLine(xm2, ym2, xm2, ym1);

}

void DoraBaseDialog::DrawRamkaStat(QPainter *p)
{
  p->setFont(font);
  p->setPen(QPen(QColor(0, 0, 0), 1));
  p->setBrush(QBrush(QColor(192, 192, 192)));
  p->drawRect(clientRect);
  
  int x1 = clientRect.x();
  int y1 = clientRect.y();
  int x2 = clientRect.width() - 1;
  int y2 = clientRect.height() - 1;

  int xr1 = x1 + 1;
  int yr1 = y1 + 1;
  int xr2 = x2 - 1;
  int yr2 = y2 - 1;
  p->setPen(QPen(QColor(255, 255, 255), 1));
  p->drawLine(xr1, yr2, xr1, yr1);
  p->drawLine(xr1, yr1, xr2, yr1);
  p->setPen(QPen(QColor(0, 0, 0), 1));
  p->drawLine(xr1, yr2, xr2, yr2);
  p->drawLine(xr2, yr2, xr2, yr1);

  xr1 = x1 + 3;
  yr1 = y1 + 3;
  xr2 = x2 - 3;
  yr2 = yr1 + titleRect.height() + 2;
  p->setPen(QPen(QColor(0, 0, 0), 1));
  p->drawLine(xr1, yr2, xr1, yr1);
  p->drawLine(xr1, yr1, xr2, yr1);
  p->setPen(QPen(QColor(255, 255, 255), 1));
  p->drawLine(xr1, yr2, xr2, yr2);
  p->drawLine(xr2, yr2, xr2, yr1);

  yr1 = yr2 + 3;
  yr2 = y2 - 3;
  p->setPen(QPen(QColor(0, 0, 0), 1));
  p->drawLine(xr1, yr2, xr1, yr1);
  p->drawLine(xr1, yr1, xr2, yr1);
  p->setPen(QPen(QColor(255, 255, 255), 1));
  p->drawLine(xr1, yr2, xr2, yr2);
  p->drawLine(xr2, yr2, xr2, yr1);

  p->setBrush(QBrush(QColor(0, 0, 255)));
  p->setPen(QPen(QColor(0, 0, 0), 1));
  p->drawRect(titleRect);

  int xm1 = menuRect.x() + 1;
  int ym1 = menuRect.y() + 1;
  int xm2 = menuRect.width() - 2;
  int ym2 = menuRect.height() - 2;

  p->setPen(QPen(QColor(0, 0, 0), 1));
  p->drawLine(xm1, ym2, xm1, ym1);
  p->drawLine(xm1, ym1, xm2, ym1);
  p->setPen(QPen(QColor(255, 255, 255), 1));
  p->drawLine(xm1, ym2, xm2, ym2);
  p->drawLine(xm2, ym2, xm2, ym1);
}

void DoraBaseDialog::SizeRamkaEdit(int cx, int cy)
{
  clientRect.setX(0);
  clientRect.setY(0);
  clientRect.setWidth(cx);
  clientRect.setHeight(cy);

  QFontMetrics fm(font);
  QSize sizeFont = fm.size(SingleLine, "H", 1);
  int wf = sizeFont.width();
  int hf = fm.height() - fm.descent();

  int x1 = clientRect.x();
  int y1 = clientRect.y();
  int x2 = clientRect.width() - 1;
  int y2 = clientRect.height() - 1;

  int xt = x1 + 4;
  int yt = y1 + 4;
  int wt = clientRect.width() - 9;
  int ht = hf + 6;

  titleRect.setX(xt);
  titleRect.setY(yt);
  titleRect.setWidth(wt);
  titleRect.setHeight(ht);

  int xm = x1 + 4;
  int ym = (y1 + 4) + (ht + 2) + 3;
  int wm = (wf * 54) - 2;
  int hm = 24; // (clientRect.height() - 33) - (titleRect.height() + 4) - 2;

  menuRect.setX(xm);
  menuRect.setY(ym);
  menuRect.setWidth(wm);
  menuRect.setHeight(hm);

  int xb = x1 + 4;
  int yb = (y1 + 4) + (ht + 2) + 2;
  int wb = wf * 54;
  int hb = (clientRect.height() - 33) - (titleRect.height() + 4) - 3;
  boxRect.setX(xb);
  boxRect.setY(yb + 27);
  boxRect.setWidth(wb);
  boxRect.setHeight(hb - 27);
}

void DoraBaseDialog::SizeRamkaStat(int cx, int cy)
{
  clientRect.setX(0);
  clientRect.setY(0);
  clientRect.setWidth(cx);
  clientRect.setHeight(cy);

  QFontMetrics fm(font);
  QSize sizeFont = fm.size(SingleLine, "H", 1);
  int wf = sizeFont.width();
  int hf = fm.height() - fm.descent();

  int x1 = clientRect.x();
  int y1 = clientRect.y();
  int x2 = clientRect.width() - 1;
  int y2 = clientRect.height() - 1;

  int xt = x1 + 4;
  int yt = y1 + 4;
  int wt = clientRect.width() - 9;
  int ht = hf + 6;

  titleRect.setX(xt);
  titleRect.setY(yt);
  titleRect.setWidth(wt);
  titleRect.setHeight(ht);

  int xm = x1 + 4;
  int ym = (y1 + 4) + (ht + 2) + 3;
  int wm = wf * 54;
  int hm = 24; // (clientRect.height() - 33) - (titleRect.height() + 4) - 2;

  menuRect.setX(xm);
  menuRect.setY(ym);
  menuRect.setWidth(wm);
  menuRect.setHeight(hm);


  int xb = x1 + 4;
  int yb = (y1 + 4) + (ht + 2);
  int wb = clientRect.width() - 9;
  int hb = clientRect.height() - (titleRect.height() + 4);
  boxRect.setX(xb);
  boxRect.setY(yb + 30);
  boxRect.setWidth(wb);
  boxRect.setHeight(hb - 30);
}

void DoraBaseDialog::selectNewFont(QFont fn)
{
  font = QFont(fn);
}

void DoraBaseDialog::PostKeyPressMessage(int index, int keyCode)
{
}

void DoraBaseDialog::PostKeyStatMessage(int stat, int keyCode)
{
}

void DoraBaseDialog::DestroyDialog()
{
}

void DoraBaseDialog::UpdateConvChar()
{
}
