#if !defined(_DORABASEDIALOG_H)
#define _DORABASEDIALOG_H

#include <qapplication.h>
#include <qwidget.h>
#include <qevent.h>
#include <qpainter.h>
#include <qrect.h>
#include <qcolor.h>
#include <qfont.h>
#include <qfontmetrics.h>

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <ctype.h>
#include <typeinfo>

#include "Typedef.h"
#include "Dynacolect.h"
#include "DoraClassObject.h"
#include "DoraConvChar.h"

class DoraBaseDialog : public QWidget, public DoraClassObject
{
public:
  DoraRuntimeClass *GetRuntimeClass() const {
    return &classDoraBaseDialog;
  }
  static DoraRuntimeClass classDoraBaseDialog;
  static DoraClassObject *CreateView(QWidget *parent);
  static DoraClassObject *CreateDocument();

public:
  DoraBaseDialog(QWidget *parent, const char *name = 0) : QWidget(parent, name), DoraClassObject() {
    printf("   DoraBaseDialog\n");
  }
  ~DoraBaseDialog() {
    printf("   DoraBaseDialog\n");
  }

private:
  void paintEvent(QPaintEvent *e);
  void resizeEvent(QResizeEvent *e);

public:
  virtual void OnDraw(QPainter *p);
  virtual void OnSize(int cx, int cy);
  virtual void PostMouseMessage(int ctrl, int index);

public:
  DoraConvChar convChar;
  QFont        font;
  QRect        clientRect;
  QRect        titleRect;
  QRect        boxRect;
  QRect        buttonRect;
  QRect        menuRect;

public:
  void selectNewFont(QFont fn);

public:
  void DrawRamkaEdit(QPainter *p);
  void DrawRamkaStat(QPainter *p);
  void SizeRamkaEdit(int cx, int cy);
  void SizeRamkaStat(int cx, int cy);

public:
  virtual void PostKeyPressMessage(int index, int keyCode);
  virtual void PostKeyStatMessage(int stat, int keyCode);

public:
  virtual void DestroyDialog();
  virtual void UpdateConvChar();

};

#endif
