#include "DoraBaseThread.h"

class DoraThreadClass
{
public:
  pthread_t thread_ID;
  pthread_cond_t cond;
  size_t    stacksize;
  void *args[2];

public:
  DoraThreadClass(size_t ss = 0);
  
public:
  static void start(DoraBaseThread *thread) {
    thread->runThread();
  }
};

DoraThreadClass::DoraThreadClass(size_t ss) : thread_ID(0), stacksize(ss)
{
}

DoraRuntimeClass DoraBaseThread::classDoraBaseThread={"DoraBaseThread", NULL, DoraBaseThread::CreateDocument};

DoraClassObject *DoraBaseThread::CreateView(QWidget *parent)
{
  return NULL;
}

DoraClassObject *DoraBaseThread::CreateDocument()
{
  return new DoraBaseThread();
}

DoraBaseThread::DoraBaseThread() : DoraClassObject() {
  printf("   DoraBaseThread\n");
  thread = new DoraThreadClass();
}

DoraBaseThread::~DoraBaseThread() {
   printf("   DoraBaseThread\n");
   delete thread;
}

void DoraBaseThread::CreateThread()
{
  pthread_attr_init(&attr);
  pthread_attr_setinheritsched(&attr, PTHREAD_INHERIT_SCHED);
  pthread_attr_setdetachstate(&attr, PTHREAD_CREATE_DETACHED);
  thread->args[0] = this;
  thread->args[1] = thread;
  ret = pthread_create(&thread->thread_ID, &attr, DoraBaseThread::start_thread, thread->args);
  pthread_attr_destroy(&attr);
  //  int oldstate, oldtype;
  //  pthread_setcancelstate(PTHREAD_CANCEL_ENABLE, &oldstate);
  //  pthread_setcanceltype(PTHREAD_CANCEL_ASYNCHRONOUS, &oldtype);
}

void *DoraBaseThread::start_thread(void *_arg)
{
  void **arg = (void **) _arg;

  pthread_cleanup_push(DoraBaseThread::finish_thread, arg[1]);
  pthread_testcancel();

  DoraThreadClass::start((DoraBaseThread *)arg[0]);
  
  pthread_cleanup_pop( TRUE );

  return 0;
}

void DoraBaseThread::finish_thread(void *arg)
{
  DoraThreadClass *th = (DoraThreadClass *) arg;
  printf("finish_thread   DoraBaseThread\n");
  if(th != NULL)
    return;

  pthread_cond_broadcast(&th->cond);

  th->thread_ID = 0;
  th->args[0] = th->args[1] = NULL;

  delete th;
}

void DoraBaseThread::runThread()
{
}

void DoraBaseThread::exit()
{
  pthread_exit(0);
}

void DoraBaseThread::terminate()
{
  printf("terminate   DoraBaseThread\n");
  pthread_cancel(thread->thread_ID);
}

void DoraBaseThread::thread_sleep(struct timespec *ti)
{
  pthread_mutex_t mtx;
  pthread_cond_t cnd;

  pthread_mutex_init(&mtx, 0);
  pthread_cond_init(&cnd, 0);

  pthread_mutex_lock(&mtx);
  (void) pthread_cond_timedwait(&cnd, &mtx, ti);
  pthread_mutex_unlock(&mtx);

  pthread_cond_destroy(&cnd);
  pthread_mutex_destroy(&mtx);
}

void DoraBaseThread::sleep(const unsigned long secs)
{
  struct timeval tv;
  gettimeofday(&tv, 0);
  struct timespec ti;
  ti.tv_sec = tv.tv_sec + secs;
  ti.tv_nsec = (tv.tv_usec * 1000);
  thread_sleep(&ti);
}

void DoraBaseThread::initThread(DoraCriticalSection *pCriticalSection)
{
  pthread_cond_init(&thread->cond, NULL);
  pthread_cond_wait(&thread->cond, &pCriticalSection->mtx);
}
