#if !defined(_DORABASETHREAD_H)
#define _DORABASETHREAD_H

#include <qwidget.h>

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <ctype.h>
#include <typeinfo>
#include <limits.h>
#include <pthread.h>
#include <sys/time.h>
#include "Typedef.h"
#include "Dynacolect.h"
#include "DoraClassObject.h"
#include "DoraCriticalSection.h"

class DoraThreadClass;

class DoraBaseThread : public DoraClassObject
{
public:
  DoraRuntimeClass *GetRuntimeClass() const {
    return &classDoraBaseThread;
  }
  static DoraRuntimeClass classDoraBaseThread;
  static DoraClassObject *CreateView(QWidget *parent);
  static DoraClassObject *CreateDocument();

public:
  DoraBaseThread();
 ~DoraBaseThread();

public:
  void CreateThread();
  static void *start_thread(void *_arg);
  static void finish_thread(void *arg);
  static void thread_sleep(struct timespec *ti);
  
public:
  virtual void runThread();
  void exit();
  void terminate();
  void sleep(const unsigned long secs = 1);
  void initThread(DoraCriticalSection *pCriticalSection);

public:
  int ret;
  pthread_attr_t attr;

public:
  DoraThreadClass *thread;
};

#endif
