#include "DoraMainApp.h"
#include "DoraBaseView.h"

DoraRuntimeClass DoraBaseView::classDoraBaseView = {"DoraBaseView", DoraBaseView::CreateView, NULL};

DoraClassObject *DoraBaseView::CreateView(QWidget *parent)
{
  return new DoraBaseView(parent);
}

DoraClassObject *DoraBaseView::CreateDocument()
{
  return NULL;
}

extern DoraMainApp *mainApp;

void DoraBaseView::paintEvent(QPaintEvent *e)
{
  QPainter p(this);
  OnDraw(&p);
}

void DoraBaseView::resizeEvent(QResizeEvent *e)
{
  QSize size = e->size();

  int cx = size.width();
  int cy = size.height();

  OnSize(cx, cy);
}

void DoraBaseView::OnDraw(QPainter *p)
{
}

void DoraBaseView::mousePressEvent(QMouseEvent *e)
{
  xMovePos = xPosView = e->x();
  yMovePos = yPosView = e->y();

  if(e->button() & LeftButton) {
    LeftButtonPush = TRUE;
    RightButtonPush = FALSE;
    MidthButtonPush = FALSE;
  }

  if(e->button() & RightButton) {
    LeftButtonPush = FALSE;
    RightButtonPush = TRUE;
    MidthButtonPush = FALSE;
  }

  if(e->button() & MidButton) {
    LeftButtonPush = TRUE;
    RightButtonPush = FALSE;
    MidthButtonPush = FALSE;
  }
  PostMouseClick(-1);
}

void DoraBaseView::mouseMoveEvent(QMouseEvent *e)
{
  xMovePos = xPosView = e->x();
  yMovePos = yPosView = e->y();
  MouseMove();
}

void DoraBaseView::mouseReleaseEvent(QMouseEvent *e)
{
  MouseRelease();
}

void DoraBaseView::showEvent(QShowEvent *e)
{
  OnShowView();
}

void DoraBaseView::focusInEvent(QFocusEvent *e)
{
  OnFocus();
}

void DoraBaseView::focusOutEvent(QFocusEvent *e)
{
  OffFocus();
}

void DoraBaseView::closeEvent(QCloseEvent *e)
{
  OnCloseView();
}

void DoraBaseView::OnFocus()
{
}

void DoraBaseView::OffFocus()
{
}

void DoraBaseView::hideEvent(QHideEvent *e)
{
  OnHideView();
}

void DoraBaseView::OnSize(int cx, int cy)
{
}

void DoraBaseView::OnInitialUpdate()
{
  printf(" OnInitialUpdate   DoraBaseView\n");
  OnUpdateView();
}

void DoraBaseView::OnUpdateView()
{
  printf(" OnUpdateView   DoraBaseView\n");
}

void DoraBaseView::PostMouseMove(int index)
{
}

void DoraBaseView::PostMouseClick(int index)
{
}

void DoraBaseView::PostMouseRelease(int index)
{
}

void DoraBaseView::PostButtonMessage(int indexButton)
{
}

void DoraBaseView::OnShowView()
{
  printf(" OnShowView   DoraBaseView\n");
}

void DoraBaseView::OnHideView()
{
  printf(" OnHideView   DoraBaseView\n");
}

void DoraBaseView::PostEditMessage(const int indexEdit = 1)
{
}

void DoraBaseView::PostKeyPressMessage(int index, int keyCode)
{
}

void DoraBaseView::PostKeyStatMessage(int stat, int keyCode)
{
}

void DoraBaseView::PostPushButtonMessage(int buttonID)
{
}

void DoraBaseView::PostToolBarButtonMessage(const int ViewMessage, const int idToolBarButton)
{
}

void DoraBaseView::PostMouseMessage()
{
}

void DoraBaseView::PostMouseMessage(int ctrl, int index)
{
}

void DoraBaseView::DestroyView()
{
}

void DoraBaseView::MouseMove()
{
}

void DoraBaseView::MouseRelease()
{
}

void DoraBaseView::selectNewFont(QFont fn)
{
  font = QFont(fn);
}

void DoraBaseView::UpdateTimeView()
{
}

void DoraBaseView::OnCloseView()
{
}

void DoraBaseView::UpdateConvChar()
{
}
