#include "DoraCalendarButton.h"

DoraRuntimeClass DoraCalendarButton::classDoraCalendarButton={"DoraCalendarButton", DoraCalendarButton::CreateView, NULL};

DoraClassObject *DoraCalendarButton::CreateView(QWidget *parent) {
  return new DoraCalendarButton(parent);
}

DoraClassObject *DoraCalendarButton::CreateDocument() {
  return NULL;
}

void DoraCalendarButton::OnCreate(DoraClassObject *pObject, DoraBaseView *pView)
{
  setFont(font);
  m_pObject = pObject;
  m_pView   = pView;
  pushButton = FALSE;
  validButton = FALSE;
  redDay = FALSE;
  captionButton = "";
  viewCaption = "";
  dateCaption = "";
}

void DoraCalendarButton::OnDraw(QPainter *p)
{
  if(!pushButton) {
    p->setPen(QColor(0, 0, 0));
    p->setBrush(QColor(192, 192, 192));
  } else {
    p->setPen(QColor(0, 0, 0));
    p->setBrush(QColor(255, 255, 0));
  }
  p->drawRect(clientRect);
  int x1 = clientRect.x() + 2;
  int y1 = clientRect.y() + 2;
  int x2 = x1 + (clientRect.width() - 4);
  int y2 = y1 + (clientRect.height() - 4);
  
  if(!pushButton) {
    p->setPen(QColor(255, 255, 255));
    p->drawLine(x1, y1, x2, y1);
    p->drawLine(x1, y2, x1, y1);
    p->setPen(QColor(0, 0, 0));
    p->drawLine(x1, y2, x2, y2);
    p->drawLine(x2, y2, x2, y1);
  } else {
    p->setPen(QColor(128, 128, 0));
    p->drawLine(x1, y1, x2, y1);
    p->drawLine(x1, y2, x1, y1);
    p->setPen(QColor(128, 128, 128));
    p->drawLine(x1, y2, x2, y2);
    p->drawLine(x2, y2, x2, y1);
  }
  font.setWeight(QFont::Bold);
  QFontMetrics fm(font);
  QSize sFont = fm.size(Qt::SingleLine, "H", 1);
  p->setFont(font);  
  if(captionButton != "") {
    int xpos = clientRect.x() + (int)(((clientRect.width() - 2) - (2 * sFont.width() - 2)) / 2);
    int ypos = (clientRect.y()+ 2) + (int)(((clientRect.height() - 2) - sFont.height()) / 2);
    int len  = (int)strlen(captionButton.p);
    for(int i = 0; i <= len - 1; i++) {
      char *s = new char[3];
      s[0] = '\0';sprintf(s, "%s\0", copyStr(captionButton, i + 1, 1).p);
      QString qStr;
      qStr = "";qStr = convChar.getCharCodec(s);
      QRect rect;
      rect.setX(xpos);
      rect.setY(ypos);
      rect.setWidth(sFont.width());
      rect.setHeight(sFont.height());
      if(redDay) {
	p->setPen(QColor(255, 0, 0));
	p->drawText(rect, Qt::AlignCenter, qStr);
      } else {
	p->setPen(QColor(0, 0, 0));
	p->drawText(rect, Qt::AlignCenter, qStr);
      }
      xpos += sFont.width();
      delete s;
    }
  }
}

void DoraCalendarButton::OnSize(int cx, int cy)
{
  clientRect.setX(0);
  clientRect.setY(0);
  clientRect.setWidth(cx);
  clientRect.setHeight(cy);
}

void DoraCalendarButton::setCaption(Str35 capButton, Str35 strCaption, Str35 strDate)
{
  captionButton = "";
  captionButton = capButton;
  viewCaption = "";
  viewCaption = strCaption;  
  dateCaption = "";
  dateCaption = strDate;
}

void DoraCalendarButton::setRed(const bool redColor)
{
  redDay = redColor;
}

void DoraCalendarButton::MouseLeftButton(int xLocPos, int yLocPos, int xPosGlb, int yPosGlb)
{
  if(validButton) {
    pushButton = !pushButton;
    repaint();
    m_pView->PostMouseMessage(ctrlID, indexButton);
  }
}

void DoraCalendarButton::setCurent(const bool curentButton)
{
  pushButton = curentButton;
  repaint(false);
}








