#include "DoraCentralDocument.h"
#include "DoraCentralView.h"
#include "DoraMainFrame.h"
#include "DoraCalendarView.h"

DoraRuntimeClass DoraCalendarView::classDoraCalendarView={"DoraCalendarView", DoraCalendarView::CreateView, NULL};

DoraClassObject *DoraCalendarView::CreateView(QWidget *parent)
{
  return new DoraCalendarView(parent);
}

DoraClassObject *DoraCalendarView::CreateDocument()
{
  return NULL;
}

void DoraCalendarView::OnDraw(QPainter *p)
{
  p->setFont(font);
  p->setPen(QPen(QColor(0, 0, 0), 1));
  p->setBrush(QBrush(QColor(192, 192, 192)));
  p->drawRect(clientRect);

  p->setPen(QPen(QColor(0, 0, 0), 1));
  p->setBrush(QBrush(QColor(255, 255, 255)));
  int maxElement = itemButtonRect.maxElement();
  for(int i = 0; i <= 6; i++) {
    p->setPen(QPen(QColor(0, 0, 0), 1));
    p->setBrush(QBrush(QColor(192, 192, 192)));
    p->drawRect(itemButtonRect[i].rect);
    int x1 = itemButtonRect[i].rect.x() + 1;
    int y1 = itemButtonRect[i].rect.y() + 1;
    int x2 = (x1 + itemButtonRect[i].rect.width()) - 3;
    int y2 = (y1 + itemButtonRect[i].rect.height()) - 3;
    p->setPen(QPen(QColor(255, 255, 255), 1));
    p->drawLine(x1, y2, x1, y1);
    p->drawLine(x1, y1, x2, y1);
    p->setPen(QPen(QColor(0, 0, 0), 1));
    p->drawLine(x1, y2, x2, y2);
    p->drawLine(x2, y2, x2, y1);
    if((i == 5) || (i == 6))
      p->setPen(QPen(QColor(255, 0, 0), 1));
    else
      p->setPen(QPen(QColor(0, 0, 0), 1));
    char *s = new char[2];
    s[0] = '\0';
    sprintf(s, "%c\0", itemHeadCalendar[i].name.p[0]);
    p->drawText(itemButtonRect[i].rect, Qt::AlignCenter, convChar.getCharCodec(s));
    delete s;
  }
  p->setPen(QPen(QColor(0, 0, 0), 1));
  p->setBrush(QBrush(QColor(255, 255, 255)));
  for(int i = 7; i <= maxElement - 1; i++) {
     p->drawRect(itemButtonRect[i].rect);
  }
  p->drawRect(comboRect);
  p->drawRect(spinRect);
  p->drawRect(infoRect);
  p->drawRect(groupRect);
  m_pPushButton1->show();
  m_pPushButton2->show();
  m_pSpinBox->show();

  maxElement = itemCalendarButton.maxElement();
  for(int i = 0; i <= maxElement - 1; i++) 
    itemCalendarButton[i].button->show();
  m_pComboBox->show();
  m_pStaticCtrl->show();
  m_pCheckGroup->show();
}

void DoraCalendarView::OnSize(int cx, int cy)
{
  clientRect.setX(0);
  clientRect.setY(0);
  clientRect.setWidth(cx);
  clientRect.setHeight(cy);

  QFontMetrics fm(fontCombo);
  QSize sizeCombo = fm.size(SingleLine, "H", 1);
  int hCombo = (fm.height() - fm.descent()) + 4;
  int wCombo = (sizeCombo.width() * 12) + hCombo + 9;
  comboRect.setX(5);
  comboRect.setY(3);
  comboRect.setWidth(wCombo);
  comboRect.setHeight(hCombo);
  
  int wSpin = (sizeCombo.width() * 4) + (2 * hCombo) + 5;
  spinRect.setX((cx - wSpin) - 6);
  spinRect.setY(3);
  spinRect.setWidth(wSpin);
  spinRect.setHeight(hCombo);

  int w = (int)((cx - 11) / 7);
  int h = w;
  int k = 1;
  strButtonRect item;
  int x = 5;
  int y = 2 + (hCombo + 2);
  for(int i = 1; i <= 6; i++) {
    for(int j = 1;j <= 7; j++) {
      item.rect.setX(x);
      item.rect.setY(y);
      item.rect.setWidth(w);
      item.rect.setHeight(h);
      itemButtonRect.setElement(item, k);
      x += (w + 1);k++;
    }
    x = 5;y += (h + 1);
  }
  QFontMetrics fmInfo(fontInfo);
  QSize infoSize = fmInfo.size(SingleLine, "H", 1);
  y += 2;
  int wInfo = (infoSize.width() * 35) + 6;
  int hInfo = (fmInfo.height() - fmInfo.descent()) + 12;
  infoRect.setX(x);
  infoRect.setY(y);
  infoRect.setWidth(wInfo);
  infoRect.setHeight(hInfo - 7);
  
  y += (hInfo + 3);
  groupRect.setX(x);
  groupRect.setY(y);
  groupRect.setWidth(wInfo);
  groupRect.setHeight(hInfo);

  y += hInfo + 6;
  pushButtonRect1.setX(x);
  pushButtonRect1.setY(y);
  pushButtonRect1.setWidth(wCombo);
  pushButtonRect1.setHeight(hCombo + 4);

  pushButtonRect2.setX((groupRect.width() - wCombo) + 5);
  pushButtonRect2.setY(y);
  pushButtonRect2.setWidth(wCombo);
  pushButtonRect2.setHeight(hCombo + 4);

  m_pPushButton1->setGeometry(pushButtonRect1);
  m_pPushButton1->hide();
  m_pPushButton2->setGeometry(pushButtonRect2);
  m_pPushButton2->hide();

  m_pSpinBox->setGeometry(spinRect);
  m_pSpinBox->hide();

  int maxElement = itemButtonRect.maxElement();
  int j = 0;
  for(int i = 7; i <= maxElement - 1; i++) {
    itemCalendarButton[j].button->setGeometry(itemButtonRect[i].rect);
    itemCalendarButton[j].button->hide();
    j++;
  }

  int xBox = comboRect.x();
  int yBox = comboRect.y() + comboRect.height() + 1;
  int wBox = comboRect.width();
  int hBox = hCombo * 12;
  boxRect.setX(xBox);
  boxRect.setY(yBox);
  boxRect.setWidth(wBox);
  boxRect.setHeight(hBox - 6);
  m_pComboBox->setGeometry(comboRect);
  m_pComboBox->setBoxRect(boxRect);
  m_pComboBox->hide();

  m_pStaticCtrl->setGeometry(infoRect);
  m_pStaticCtrl->hide();

  m_pCheckGroup->setGeometry(groupRect);
  m_pCheckGroup->hide();
}

void DoraCalendarView::OnCreate(DoraClassObject *pObject, DoraBaseView *pView)
{
  setFont(font);
  m_pObject = pObject;
  m_pView   = pView;
  DoraCentralDocument *pDoc = GetDocument();
  fontCombo = QFont(pDoc->getDefaultFont(5));
  fontInfo  = QFont(pDoc->getDefaultFont(4));
  
  for(int i = 0; i <= 34; i++) {
    strButton item;
    DoraRuntimeClass *runtimeCalendarButton = RUNTIME_CLASS(DoraCalendarButton);
    DoraClassObject *objectCalendarButton = runtimeCalendarButton->CreateView(this);
    item.button = dynamic_cast<DoraCalendarButton *>(objectCalendarButton);
    item.button->convChar = pDoc->convChar;
    item.button->selectNewFont(pDoc->getDefaultFont(5));
    item.button->OnCreate(m_pObject, this);
    item.button->indexButton = i + 1;
    item.button->ctrlID = DM_CALENDARBUTTON;
    item.button->hide();
    itemCalendarButton.setElement(item, i + 1);
  }

  int maxElement = pDoc->itemDayName.maxElement();
  for(int i = 0; i <= maxElement - 1; i++) {
    strHeadCalendar item;
    item.name = "";item.name = upCase(copyStr(pDoc->itemDayName[i].name, 1, 1));
    itemHeadCalendar.setElement(item, i + 1);
  }

  DoraRuntimeClass *runtimePushButton1 = RUNTIME_CLASS(DoraPushButton);
  DoraClassObject *objectPushButton1 = runtimePushButton1->CreateView(this);
  m_pPushButton1 = dynamic_cast<DoraPushButton *>(objectPushButton1);
  m_pPushButton1->convChar = pDoc->convChar;
  m_pPushButton1->selectNewFont(font);
  m_pPushButton1->OnCreate(m_pObject, this);
  m_pPushButton1->ctrlID = DM_PUSHBUTTON;
  m_pPushButton1->nID = ID_PUSHBUTTON_SAVE;
  Str35 cap1, cap2;
  cap1 = "";cap2 = "";
  cap1 = pDoc->capCalButton1;;
  m_pPushButton1->setCaption(cap1, cap2);
  m_pPushButton1->hide();

  DoraRuntimeClass *runtimePushButton2 = RUNTIME_CLASS(DoraPushButton);
  DoraClassObject *objectPushButton2 = runtimePushButton2->CreateView(this);
  m_pPushButton2 = dynamic_cast<DoraPushButton *>(objectPushButton2);
  m_pPushButton2->convChar = pDoc->convChar;
  m_pPushButton2->selectNewFont(font);
  m_pPushButton2->OnCreate(m_pObject, this);
  m_pPushButton2->ctrlID = DM_PUSHBUTTON;
  m_pPushButton2->nID = ID_PUSHBUTTON_OK;
  cap1, cap2;
  cap1 = "";cap2 = "";
  cap1 = pDoc->capCalButton2;
  m_pPushButton2->setCaption(cap1, cap2);
  m_pPushButton2->hide();

  DoraRuntimeClass *runtimeSpinBox = RUNTIME_CLASS(DoraSpinBox);
  DoraClassObject *objectSpinBox = runtimeSpinBox->CreateView(this);
  m_pSpinBox = dynamic_cast<DoraSpinBox *>(objectSpinBox);
  m_pSpinBox->convChar = pDoc->convChar;
  m_pSpinBox->selectNewFont(pDoc->getDefaultFont(5));
  m_pSpinBox->OnCreate(m_pObject, this, 4);
  m_pSpinBox->ctrlID = DM_SPINCTRL;
  m_pSpinBox->nID = 0;
  m_pSpinBox->setSpin(1900, 2100, 1);
  m_pSpinBox->hide();

  DoraRuntimeClass *runtimeStaticCtrl = RUNTIME_CLASS(DoraStaticCtrl);
  DoraClassObject *objectStaticCtrl = runtimeStaticCtrl->CreateView(this);
  m_pStaticCtrl = dynamic_cast<DoraStaticCtrl *>(objectStaticCtrl);
  m_pStaticCtrl->selectNewFont(pDoc->getDefaultFont(4));
  m_pStaticCtrl->convChar = pDoc->convChar;
  QColor textColor(0, 0, 0);
  QColor bordColor(0, 0, 0);
  QColor backColor(255, 255, 255);
  m_pStaticCtrl->setColor(textColor, bordColor, backColor);
  m_pStaticCtrl->OnCreate(m_pObject, this);
  m_pStaticCtrl->hide();

  DoraRuntimeClass *runtimeCheckGroup = RUNTIME_CLASS(DoraCheckGroup);
  DoraClassObject *objectCheckGroup = runtimeCheckGroup->CreateView(this);
  m_pCheckGroup = dynamic_cast<DoraCheckGroup *>(objectCheckGroup);
  m_pCheckGroup->convChar = pDoc->convChar;
  m_pCheckGroup->selectNewFont(pDoc->getDefaultFont(5));
  m_pCheckGroup->OnCreate(m_pObject, this);
  cap1 = "";cap1 = pDoc->capCheck1;;
  m_pCheckGroup->createGroup(1, cap1);
  cap1 = "";cap1 = pDoc->capCheck2;;
  m_pCheckGroup->createGroup(2, cap1);
  m_pCheckGroup->capGroup = "";
  m_pCheckGroup->hide();

  DoraRuntimeClass *runtimeComboBox = RUNTIME_CLASS(DoraComboBox);
  DoraClassObject *objectComboBox = runtimeComboBox->CreateView(this);
  m_pComboBox = dynamic_cast<DoraComboBox *>(objectComboBox);
  m_pComboBox->selectNewFont(pDoc->getDefaultFont(5));
  m_pComboBox->convChar = convChar;
  m_pComboBox->okScrollBar = FALSE;
  m_pComboBox->maxLen = 12;
  m_pComboBox->maxRow = 12;
  m_pComboBox->nID = ID_COMBOBOX_CALENDAR;
  m_pComboBox->nScrollID = ID_SCROLLBOX_CALENDAR;
  m_pComboBox->OnCreate(m_pObject, this);
  m_pComboBox->hide();
  setAllMonth();
  updateView();
 
}

DoraCentralDocument *DoraCalendarView::GetDocument()
{
  DoraMainFrame *m_pMainFrame = dynamic_cast<DoraMainFrame *>(m_pObject);
  DoraCentralView *m_pCentralView = m_pMainFrame->GetCentralView();
  DoraCentralDocument *pDoc = m_pCentralView->GetDocument();

  return pDoc;
}

void DoraCalendarView::setHeadCalendar(strHeadCalendar item, const int index)
{
  itemHeadCalendar.setElement(item, index);
}

void DoraCalendarView::setCurentMonth()
{
  DoraCentralDocument *pDoc = GetDocument();
  int maxElement = itemCalendarButton.maxElement();
  if(pDoc->itemCurentMonth.maxElement() >= 1) {
    for(int i = 0; i <= pDoc->itemCurentMonth.maxElement() - 1; i++) {
      strButton item;
      item = itemCalendarButton[i];
      item.button->captionButton = "";
      item.button->captionButton = pDoc->itemCurentMonth[i].caption;
      item.button->dateCaption = "";
      item.button->dateCaption = pDoc->itemCurentMonth[i].dateStr;
      item.button->viewCaption = "";
      item.button->viewCaption = pDoc->itemCurentMonth[i].infoStr;
      item.button->redDay = pDoc->itemCurentMonth[i].isRed;
      item.button->validButton = pDoc->itemCurentMonth[i].isValid;
      item.button->ctrlID = DM_CALENDARBUTTON;
      item.button->indexButton = i + 1;
      item.button->pushButton = pDoc->itemCurentMonth[i].isCurent;
      if(pDoc->itemCurentMonth[i].caption.p[0] == '\0') {
	item.day = 0;
      } else {
	item.day = atoi(pDoc->itemCurentMonth[i].caption.p);
      }
      itemCalendarButton.setElement(item, i + 1); 
      if(itemCalendarButton[i].day == pDoc->curentDay) {
	itemCalendarButton[i].button->setCurent(true);
	oldIndexDate = i + 1;
	pDoc->curentIndex = i + 1;
	setCheckDay();
      }    
    }
    if(itemCalendarButton[oldIndexDate-1].button->redDay)
      m_pCheckGroup->setCheckButton(2);
    else
      m_pCheckGroup->setCheckButton(1);
  }
}

void DoraCalendarView::setNewMonth()
{
}

void DoraCalendarView::PostMouseMessage(int ctrlID, int index)
{
  DoraCentralDocument *pDoc = GetDocument();
  if(ctrlID == DM_CALENDARBUTTON) {
    itemCalendarButton[oldIndexDate-1].button->setCurent(false);
    itemCalendarButton[index-1].button->setCurent(true);
    pDoc->curentDay = itemCalendarButton[index-1].day;
    oldIndexDate = index;
    pDoc->curentIndex = index;
    setCheckDay();
  }
  if(ctrlID == ID_COMBOBOX_CALENDAR) {
    int maxElement = pDoc->itemMonthName.maxElement();
    for(int i = 0; i <= maxElement - 1; i++) {
      m_pComboBox->addItem(pDoc->itemMonthName[i].name, i + 1);
    }
    m_pComboBox->setDefault(pDoc->curentMonth);
    m_pComboBox->m_pScrollView->m_pScrollBox->setRectElement(pDoc->curentMonth);
  }
  if(ctrlID == ID_SCROLLBOX_CALENDAR) {
    int year = atoi(m_pSpinBox->getValue().p);
    int month = index;
    pDoc->loadMonth(month, year);
    if(pDoc->curentDay >= pDoc->maxDayMonth)
      pDoc->curentDay = pDoc->maxDayMonth;
    pDoc->curentMonth = month;
    setCurentMonth();
    int maxElement = itemCalendarButton.maxElement();
    for(int i = 0; i <= maxElement - 1; i++) {
      if(pDoc->curentDay == itemCalendarButton[i].day)
	oldIndexDate = i + 1;
      itemCalendarButton[i].button->repaint(false);
    }      
    setCheckDay();
  }
  if(ctrlID == POST_SPINBOX) {
    int year = index;
    int month = pDoc->curentMonth;
    pDoc->curentYear = year;
    if(pDoc->okYearDir(year))
      pDoc->setNewBDate();
    else
      pDoc->setNewYear(year);
    bool ok = false;
    while(!ok) {
      pDoc->m_pCriticalSection->lock();
      ok = pDoc->loadMonth(month, year);
      pDoc->m_pCriticalSection->unlock();
    }
    pDoc->m_pCriticalSection->lock();
    if(pDoc->curentDay >= pDoc->maxDayMonth)
      pDoc->curentDay = pDoc->maxDayMonth;
    setCurentMonth();
    int maxElement = itemCalendarButton.maxElement();
    for(int i = 0; i <= maxElement - 1; i++) {
      if(pDoc->curentDay == itemCalendarButton[i].day)
	oldIndexDate = i + 1;
      itemCalendarButton[i].button->repaint(false);
    }
    setCheckDay();
    pDoc->m_pCriticalSection->unlock();
  }
  if(ctrlID == POST_CHECK_GROUP) {
    strButton item;
    item = itemCalendarButton[oldIndexDate-1];
    if(index == 1) 
      item.button->redDay = false;
    if(index == 2)
      item.button->redDay = true;
    itemCalendarButton.setElement(item, oldIndexDate);
    setCheckDay();
    pDoc->m_pCriticalSection->unlock();
  }
  if(ctrlID == DM_PUSHBUTTON) {
    if(index == ID_PUSHBUTTON_SAVE) {
      pDoc->getCurentDate();
      setCurentMonth();
      int maxElement = itemCalendarButton.maxElement();
      for(int i = 0; i <= maxElement - 1; i++) {
	if(pDoc->curentDay == itemCalendarButton[i].day)
	  oldIndexDate = i + 1;
	itemCalendarButton[i].button->repaint(false);
      }
      m_pComboBox->setDefault(pDoc->curentMonth);
      m_pSpinBox->setDefaultValue(pDoc->curentYear);
      setCheckDay();
    }
    if(index == ID_PUSHBUTTON_OK) {
      setNewDateTime();
    }
  }
}

void DoraCalendarView::setAllMonth()
{
  DoraCentralDocument *pDoc = GetDocument();
}

void DoraCalendarView::setCheckDay()
{
   DoraCentralDocument *pDoc = GetDocument();
   if(itemCalendarButton[oldIndexDate-1].button->redDay)
      m_pStaticCtrl->setColor(QColor(255, 0, 0), QColor(0, 0, 0), QColor(255, 255, 255));
   else
     m_pStaticCtrl->setColor(QColor(0, 0, 0), QColor(0, 0, 0), QColor(255, 255, 255));
   int day   = pDoc->curentDay;
   int year  = pDoc->curentYear;
   int month = pDoc->curentMonth;
   int week  = pDoc->itemCurentMonth[oldIndexDate-1].week;
   Str35 strDay, strMonth, sDay, sYear, s1, s2;
   s1 = "";sprintf(s1.p, "%2d\0", day);sDay = "";sDay = spaceNull(2, s1);
   s1 = "";sprintf(s1.p, "%4d\0", year);sYear = "";sYear = spaceNull(4, s1);
   strDay = "";strDay = pDoc->itemDayName[week - 1].name;
   strMonth = "";strMonth = loCase(pDoc->itemMonthName[month - 1].name);
   CString caption;
   caption = "";caption = caption + strDay + ", " + sDay + " " + strMonth + " " + sYear;
   m_pStaticCtrl->setCaption(caption.p);
   m_pStaticCtrl->repaint(false);
   itemCalendarButton[oldIndexDate-1].button->repaint(false);
   if(itemCalendarButton[oldIndexDate-1].button->redDay) {
     m_pCheckGroup->setCheckButton(2);
     pDoc->setRed(oldIndexDate, true);
   } else {
     m_pCheckGroup->setCheckButton(1);
     pDoc->setRed(oldIndexDate, false);
   }
}

void DoraCalendarView::updateView()
{
  DoraCentralDocument *pDoc = GetDocument();
  pDoc->m_pCriticalSection->lock();
  pDoc->getCurentDate();
  setCurentMonth();
  int maxElement = itemCalendarButton.maxElement();
  for(int i = 0; i <= maxElement - 1; i++) {
    if(pDoc->curentDay == itemCalendarButton[i].day)
       oldIndexDate = i + 1;
    itemCalendarButton[i].button->repaint(false);
  }
  // m_pComboBox->setDefault(pDoc->curentMonth);
  m_pSpinBox->setDefaultValue(pDoc->curentYear);
  setCheckDay();
  pDoc->m_pCriticalSection->unlock();
}

void DoraCalendarView::setNewDateTime()
{
  DoraCentralDocument *pDoc = GetDocument();
  DoraMainFrame *m_pMainFrame = dynamic_cast<DoraMainFrame *>(m_pObject);
  DoraCentralView *m_pCentralView = m_pMainFrame->GetCentralView();
  pDoc->setNewDateTime();
  m_pCentralView->startClock();
}

void DoraCalendarView::UpdateConvChar()
{
  DoraCentralDocument *pDoc = GetDocument();
  m_pComboBox->convChar = convChar;
  m_pComboBox->setDefault(pDoc->curentMonth);
  m_pComboBox->UpdateConvChar();
  m_pStaticCtrl->convChar = convChar;
  int day   = pDoc->curentDay;
  int year  = pDoc->curentYear;
  int month = pDoc->curentMonth;
  int week  = pDoc->itemCurentMonth[oldIndexDate-1].week;
  Str35 strDay, strMonth, sDay, sYear, s1, s2;
  s1 = "";sprintf(s1.p, "%2d\0", day);sDay = "";sDay = spaceNull(2, s1);
  s1 = "";sprintf(s1.p, "%4d\0", year);sYear = "";sYear = spaceNull(4, s1);
  strDay = "";strDay = pDoc->itemDayName[week - 1].name;
  strMonth = "";strMonth = loCase(pDoc->itemMonthName[month - 1].name);
  CString caption;
  caption = "";caption = caption + strDay + ", " + sDay + " " + strMonth + " " + sYear;
  m_pStaticCtrl->setCaption(caption.p);
  m_pStaticCtrl->repaint(false);
  int maxElement = pDoc->itemDayName.maxElement();
  for(int i = 0; i <= maxElement - 1; i++) {
    strHeadCalendar item;
    item.name = "";item.name = upCase(copyStr(pDoc->itemDayName[i].name, 1, 1));
    itemHeadCalendar.setElement(item, i + 1);
  }
  repaint(false);
  Str35 cap2;
  cap2 = "";
  m_pCheckGroup->convChar = convChar;
  m_pCheckGroup->setCaptions(1, pDoc->capCheck1);
  m_pCheckGroup->setCaptions(2, pDoc->capCheck2);
  m_pCheckGroup->UpdateConvChar();
  m_pPushButton1->convChar = convChar;
  m_pPushButton1->setCaption(pDoc->capCalButton1, cap2);
  m_pPushButton1->repaint(false);
  m_pPushButton2->convChar = convChar;
  m_pPushButton2->setCaption(pDoc->capCalButton2, cap2);
  m_pPushButton2->repaint(false);
}
