#if !defined(_DORACALENDARVIEW_H)
#define _DORACALENDARVIEW_H

#include <qapplication.h>
#include <qwidget.h>
#include <qevent.h>
#include <qfont.h>
#include <qfontmetrics.h>
#include <qpainter.h>
#include <qcolor.h>
#include <qrect.h>
#include <qfontdialog.h>

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <ctype.h>
#include <typeinfo>

#include "Typedef.h"
#include "Dynacolect.h"
#include "DoraClassObject.h"
#include "DoraBaseView.h"
#include "DoraPushButton.h"
#include "DoraSpinBox.h"
#include "DoraCalendarButton.h"
#include "DoraComboBox.h"
#include "DoraStaticCtrl.h"
#include "DoraCheckGroup.h"

class DoraCalendarView : public DoraBaseView
{
public:
  struct strButtonRect {
    QRect rect;
    strButtonRect(strButtonRect *x = NULL) {
      rect.setX(0);
      rect.setY(0);
      rect.setWidth(0);
      rect.setHeight(0);
    }
    strButtonRect(const strButtonRect &x) {
      rect.setX(x.rect.x());
      rect.setY(x.rect.y());
      rect.setWidth(x.rect.width());
      rect.setHeight(x.rect.height());
    }
    strButtonRect &operator=(strButtonRect x) {
      rect.setX(x.rect.x());
      rect.setY(x.rect.y());
      rect.setWidth(x.rect.width());
      rect.setHeight(x.rect.height());
      return *this;
    }
  };
  struct strHeadCalendar {
    Str35 name;
    strHeadCalendar(strHeadCalendar *x = NULL) {
      name = "";
    }
    strHeadCalendar(const strHeadCalendar &x) {
      name = "";name = x.name;
    }
    strHeadCalendar &operator=(strHeadCalendar x) {
      name = "";name = x.name;
    }
  };
  struct strButton {
    DoraCalendarButton *button;
    int day;
    strButton(strButton *x = NULL) {
      button = NULL;
      day = 0;
    }
    strButton(const strButton &x) {
      button = x.button;
      day = x.day;
    }
    strButton &operator=(strButton x) {
      button = x.button;
      day = x.day;
      return *this;
    }
  };
  typedef DoraArray<strButtonRect>   TypeButtonRect;
  typedef DoraArray<strHeadCalendar> TypeHeadCalendar;
  typedef DoraArray<strButton>       TypeCalendarButton;

public:
  DoraRuntimeClass *GetRuntimeClass() const {
    return &classDoraCalendarView;
  }
  static DoraRuntimeClass classDoraCalendarView;
  static DoraClassObject *CreateView(QWidget *parent);
  static DoraClassObject *CreateDocument();

public:
  DoraCalendarView(QWidget *parent, const char *name = 0) : DoraBaseView(parent, name) {
    printf("   DoraCalendarView\n");
    itemButtonRect.removeAllElement();
    itemHeadCalendar.removeAllElement();
    itemCalendarButton.removeAllElement();
    oldIndexDate = 1;
  }
  ~DoraCalendarView() {
    printf("   DoraCalendarView\n");
  }

public:
  void OnDraw(QPainter *p);
  void OnSize(int cx, int cy);

public:
  void OnCreate(DoraClassObject *pObject, DoraBaseView *pView);
  DoraCentralDocument *GetDocument();
  void setHeadCalendar(strHeadCalendar item, const int index);
  void setCurentMonth();
  void setNewMonth();
  void setAllMonth();
  void setCheckDay();
  void setNewDateTime();
  void UpdateConvChar();

public:
  DoraClassObject *m_pObject;
  DoraBaseView    *m_pView;
  DoraPushButton  *m_pPushButton1;
  DoraPushButton  *m_pPushButton2;
  DoraSpinBox     *m_pSpinBox;
  DoraComboBox    *m_pComboBox;
  DoraStaticCtrl  *m_pStaticCtrl;
  DoraCheckGroup  *m_pCheckGroup;

public:
  QRect clientRect;
  QRect comboRect;
  QRect infoRect;
  QRect groupRect;
  QRect pushButtonRect1;
  QRect pushButtonRect2;
  QRect spinRect;
  QRect boxRect;

public:
  TypeButtonRect     itemButtonRect;
  TypeHeadCalendar   itemHeadCalendar;
  TypeCalendarButton itemCalendarButton;
  QFont              fontCombo;
  QFont              fontInfo;
  int                oldIndexDate;

public:
  void PostMouseMessage(int ctrlID, int index);
  void updateView();
};

#endif

