#include "DoraCentralDocument.h"

DoraRuntimeClass DoraCentralDocument::classDoraCentralDocument = {"DoraCentralDocument", NULL, DoraCentralDocument::CreateDocument};

DoraClassObject *DoraCentralDocument::CreateView(QWidget *parent)
{
  return NULL;
}

DoraClassObject *DoraCentralDocument::CreateDocument()
{
  return new DoraCentralDocument();
}

void DoraCentralDocument::addDefaultFont()
{
  strDefineFont item;

  item.encodingName = "";item.encodingName = "CP 1251";
  item.fontName = "";item.fontName = "Courier";
  item.fontSize = 8;
  setDefaultFont(item, 1);

  item.encodingName = "";item.encodingName = "CP 1251";
  item.fontName = "";item.fontName = "Courier";
  item.fontSize = 9;
  setDefaultFont(item, 2);

  item.encodingName = "";item.encodingName = "CP 1251";
  item.fontName = "";item.fontName = "Courier";
  item.fontSize = 10;
  setDefaultFont(item, 3);

  item.encodingName = "";item.encodingName = "CP 1251";
  item.fontName = "";item.fontName = "Courier";
  item.fontSize = 11;
  setDefaultFont(item, 4);

  item.encodingName = "";item.encodingName = "CP 1251";
  item.fontName = "";item.fontName = "Courier";
  item.fontSize = 12;
  setDefaultFont(item, 5);

  item.encodingName = "";item.encodingName = "CP 1251";
  item.fontName = "";item.fontName = "Courier";
  item.fontSize = 14;
  setDefaultFont(item, 6);

  item.encodingName = "";item.encodingName = "CP 1251";
  item.fontName = "";item.fontName = "Courier";
  item.fontSize = 16;
  setDefaultFont(item, 7);
}

void DoraCentralDocument::setNewConvChar(Str35 encodingName)
{
  int maxElement = itemDefineFont.maxElement();
  for(int i = 0; i <= maxElement - 1; i++) {
    strDefineFont item;
    item = itemDefineFont[i];
    item.encodingName = "";item.encodingName = encodingName;
    setDefaultFont(item, i + 1);
  }
  CString encoding;
  encoding = "";encoding = encodingName;
  convChar = DoraConvChar(encoding);
}

void DoraCentralDocument::setDefaultFont(strDefineFont item, const int index)
{
  itemDefineFont.setElement(item, index);
}

CString DoraCentralDocument::getEncodingName(const int index)
{
  CString str;
  str = "";
  sprintf(str.p, "%s\0", itemDefineFont[index - 1].encodingName.p);
  return str;
}

QFont DoraCentralDocument::getDefaultFont(const int index)
{
  QFont font = QFont(itemDefineFont[index-1].fontName.p,
		     itemDefineFont[index-1].fontSize,
		     QFont::Normal, false);
  return font;
}

void DoraCentralDocument::addMonthName()
{
  itemMonthName.removeAllElement();
  Str35 prefix, fileName;
  prefix = "";prefix = itemLangName[curentLang - 1].prefix;
  fileName = "";fileName = "MONTHS";
  loadConfigDir(prefix, fileName);
  int maxElement = itemStrLangCaption.maxElement();
  if(maxElement >= 1) {
    int index = 1;
    for(int i = 0; i <= maxElement - 1; i++) {
      strMonthName item;
      item.name = "";item.name = itemStrLangCaption[i].str.p;
      item.index = index;
      itemMonthName.setElement(item, i + 1);
      index++;
    }
  }
}

void DoraCentralDocument::setMonthName(strMonthName item, const int index)
{
  itemMonthName.setElement(item, index);
}

void DoraCentralDocument::addDayName()
{
  itemDayName.removeAllElement();
  Str35 prefix, fileName;
  prefix = "";prefix = itemLangName[curentLang - 1].prefix;
  fileName = "DAYS";
  loadConfigDir(prefix, fileName);
  int maxElement = itemStrLangCaption.maxElement();
  if(maxElement >= 1) {
    int index = 1;
    for(int i = 0; i <= maxElement - 1; i++) {
      strDayName item;
      item.name = "";item.name = itemStrLangCaption[i].str.p;
      item.index = index;
      itemDayName.setElement(item, i + 1);
      index++;
    }
  }
}

void DoraCentralDocument::setDayName(strDayName item, const int index)
{
  itemDayName.setElement(item, index);
}

void DoraCentralDocument::initDocument()
{
  Str35 localDir;
  localDir = "/Calendar";
  fs.setDefaultDir();
  fs.createLocalDir();
  fs.setWorkDir(localDir);
  addDefaultFont();
  convChar = DoraConvChar();
  itemMonth.removeAllElement();
  itemCurentMonth.removeAllElement();

  DoraRuntimeClass *runtimeCriticalSection = RUNTIME_CLASS(DoraCriticalSection);
  DoraClassObject *objectCriticalSection = runtimeCriticalSection->CreateDocument();
  m_pCriticalSection = dynamic_cast<DoraCriticalSection *>(objectCriticalSection);
  m_pCriticalSection->initSection();
  
  setCurentYear();
  bool ok = false;
  while(!ok) {
    m_pCriticalSection->lock();
    ok = loadMonth(curentMonth, curentYear);
    m_pCriticalSection->unlock();
  }
  addEncodingName();
  CString defaultCodec;
  defaultCodec = "";defaultCodec = convChar.getDefaultCodec();
  int maxElement = itemEncodingName.maxElement();
  curentEncoding = 1;
  for(int i = 0; i <= maxElement; i++) {
    CString str;
    str = "";str = itemEncodingName[i].name;
    if(str == defaultCodec) {
      curentEncoding = i + 1;
      break;
    }
  }
  if(defaultCodec == "CP 1251")
    curentLang = 1;
  if(defaultCodec == "KOI8-R")
    curentLang = 2;
  if((defaultCodec != "CP 1251") && (defaultCodec != "KOI8-R"))
    curentLang = 3;
  addLangName();
  Str35 prefix;
  prefix = "";prefix = itemLangName[curentLang - 1].prefix;
  loadLangFile(prefix);
  addMonthName();
  addDayName();
  loadOtherCaption(prefix);
}

bool DoraCentralDocument::loadMonth(const int month, const int year)
{
  bool ok = false;
  Str35 str1, str2, strMont, strYear, yearDir, monthFile;
  str1 = "";sprintf(str1.p, "%2d\0", month);str2 = "";str2 = spaceNull(2, str1);
  strMont = "";strMont = str2;
  str1 = "";sprintf(str1.p, "%4d\0", year);str2 = "";str2 = spaceNull(4, str1);
  strYear = "";strYear = str2;
  yearDir = "";yearDir = yearDir + "/Year" + strYear;
  monthFile = "";monthFile = monthFile + yearDir + "/MONTH"+strMont+strYear;
  itemCurentMonth.removeAllElement();
  for(int i = 0; i <= 34; i++) {
    strMonth item;
    item.caption = "";
    item.infoStr = "";
    item.dateStr = "";
    item.isRed = false;
    item.isValid = false;
    item.index = i + 1;
    item.week = 0;
    item.isCurent = false;
    itemCurentMonth.setElement(item, i + 1);
  }
  int maxrec = fs.maxRecord(monthFile);
  if(maxrec >= 1) {
    ok = true;
    int rec = 1;
    strMonth item;
    DataRecord data;
    do {
      fs.initDataRecord(0, 19, &data);fs.loadRecord(monthFile, rec, maxrec, &data);
      item.index = atoi(data.Pole[0].p);
      item.week  = atoi(data.Pole[4].p);
      item.caption = "";item.caption = data.Pole[1];
      item.infoStr = "";item.infoStr = data.Pole[2];
      item.dateStr = "";item.dateStr = data.Pole[3];
      if(data.Pole[5] == "1")
	item.isValid = true;
      else
	item.isValid = false;
      if(data.Pole[6] == "1")
	item.isRed = true;
      else
	item.isRed = false;
      if(data.Pole[7] == "1")
	item.isCurent = true;
      else
	item.isCurent = false;
      bDate = "";bDate = data.Pole[8];
      itemCurentMonth.setElement(item, rec);
      rec++;
    } while(rec <= maxrec);
  } else {
    ok = false;
  }
  curentMonth = month;
  curentYear = year;
  maxDayMonth = compDate.getMaxDayMonth(month, year);
  return ok;
}

void DoraCentralDocument::setRed(const int index, const bool red)
{
  int month = curentMonth;
  int year  = curentYear;
  Str35 str1, str2, sMonth, sYear, yearDir, monthFile;
  str1 = "";sprintf(str1.p, "%2d\0", month);str2 = "";str2 = spaceNull(2, str1);
  sMonth = "";sMonth = str2;
  str1 = "";sprintf(str1.p, "%4d\0", year);str2 = "";str2 = spaceNull(4, str1);
  sYear = "";sYear = str2;
  yearDir = "";yearDir = yearDir + "/Year" + sYear;
  fs.createDir(yearDir);
  monthFile = "";monthFile = monthFile + yearDir + "/MONTH" + sMonth + sYear;
  DataRecord data;
  int rec = index;
  int maxrec = fs.maxRecord(monthFile);
  if(maxrec >= 1) {
    strMonth item;
    item = itemCurentMonth[index-1];
    item.isRed = red;
    fs.initDataRecord(0, 19, &data);
    Str35 str1, str2;
    str1 = "";sprintf(str1.p, "%4d\0", item.index);str2 = "";str2 = spaceNull(4, str1);
    data.Pole[0] = str2;
    data.Pole[1] = item.caption;
    data.Pole[2] = item.infoStr;
    data.Pole[3] = item.dateStr;
    str1 = "";sprintf(str1.p, "%4d\0", item.week);str2 = "";str2 = spaceNull(4, str1);
    data.Pole[4] = str2;
    data.Pole[5] = "1";
    if(!item.isValid) {
       data.Pole[5] = "";data.Pole[5] = "0";
    }
    data.Pole[6] = "1";
    if(!red) {
       data.Pole[6] = "";data.Pole[6] = "0";
    }
    data.Pole[7] = "1";
    if(!item.isCurent) {
      data.Pole[7] = "";data.Pole[7] = "0";
    }
    data.Pole[8] = "";data.Pole[8] = bDate;
    fs.saveRecord(monthFile, rec, maxrec, data);
    itemCurentMonth.setElement(item, index);
  }
}

void DoraCentralDocument::calcCalendarDay(DoraBaseView *pView)
{
  if(m_pCalcMonthDay == NULL) {
    DoraRuntimeClass *runtimeCalcMonthDay = RUNTIME_CLASS(CalcMonthDay);
    DoraClassObject *objectCalcMonthDay = runtimeCalcMonthDay->CreateDocument();
    m_pCalcMonthDay = dynamic_cast<CalcMonthDay *>(objectCalcMonthDay);
    m_pCalcMonthDay->setDocument(this);
    m_pCalcMonthDay->setView(pView);
    m_pCalcMonthDay->initThread(m_pCriticalSection);
  }
  m_pCriticalSection->lock();
  m_pCalcMonthDay->calDay = m_pCalcMonthDay->redDay = m_pCalcMonthDay->blcDay = 0;
  m_pCalcMonthDay->minDate = "";m_pCalcMonthDay->minDate = minDate;
  m_pCalcMonthDay->maxDate = "";m_pCalcMonthDay->maxDate = maxDate;
  m_pCriticalSection->unlock();
  m_pCalcMonthDay->CreateThread();
}

void DoraCentralDocument::getCurentTime()
{
   time_t ltime;
   time(&ltime);
   tm *t = localtime(&ltime);

   curentHour = t->tm_hour;
   curentMin  = t->tm_min;
   curentSec  = t->tm_sec;
}

void DoraCentralDocument::setReklamaStr()
{
  CString str1, str2, str3, str4, str5;

  str1 = "";str1 = "***** ()   -  , ***** ";
  str2 = "";str2 = "   , ***** ";
  str3 = "";str3 = "    Linux OS ***** ";
  str4 = "";str4 = " : e - mail: dorasmolyan@yahoo.com, misho1960@yahoo.com, mick_jobs@yahoo.com ***** ";
  str5 = "";str5 = "GSM - +359886470299, +359887780640 ***** ";
  reklamaStr = "";
  reklamaStr = reklamaStr + str1 + str2 + str3 + str4 + str5;

}

void DoraCentralDocument::updateDocument()
{
  m_pCriticalSection->lock();
  calDay = redDay = blcDay = 0;
  blcDay = m_pCalcMonthDay->blcDay;
  redDay = m_pCalcMonthDay->redDay;
  calDay = m_pCalcMonthDay->calDay;
  m_pCriticalSection->unlock();
}

void DoraCentralDocument::getCurentDate()
{
  CString curentDate;
  curentDate = compDate.getCurentDate();
  int year, month, day;;
  year = atoi(copyStr(curentDate, 7, 4).p);
  month = atoi(copyStr(curentDate, 4, 2).p);
  day = atoi(copyStr(curentDate, 1, 2).p);
 
  bool ok = false;
  while(!ok) {
    ok = loadMonth(month, year);
  }
  curentDay = day;
  curentMonth = month;
  curentYear = year;
}

void DoraCentralDocument::setNewYear(const int year)
{
  if(m_pCalcNewYear == NULL) {
    DoraRuntimeClass *runtimeCalcNewYear = RUNTIME_CLASS(CalcNewYear);
    DoraClassObject *objectCalcNewYear = runtimeCalcNewYear->CreateDocument();
    m_pCalcNewYear = dynamic_cast<CalcNewYear *>(objectCalcNewYear);
    m_pCalcNewYear->setDocument(this);
    m_pCalcNewYear->initThread(m_pCriticalSection);
  }
  m_pCriticalSection->lock();
  m_pCalcNewYear->curentDay = curentDay;
  m_pCalcNewYear->curentMonth = curentMonth;
  m_pCalcNewYear->curentYear = year;
  curentYear = year;
  m_pCriticalSection->unlock();
  m_pCalcNewYear->CreateThread();
}

void DoraCentralDocument::setNewBDate()
{
  if(m_pSetNewBDate == NULL) {
    DoraRuntimeClass *runtimeNewBDate = RUNTIME_CLASS(SetNewBDate);
    DoraClassObject *objectNewBDate = runtimeNewBDate->CreateDocument();
    m_pSetNewBDate = dynamic_cast<SetNewBDate *>(objectNewBDate);
    m_pSetNewBDate->setDocument(this);
    m_pSetNewBDate->initThread(m_pCriticalSection);
  }
  m_pSetNewBDate->CreateThread();
}

void DoraCentralDocument::setCurentYear()
{
  CString curentDate;
  curentDate = compDate.getCurentDate();
  int year, month, day;
  year = atoi(copyStr(curentDate, 7, 4).p);
  month = atoi(copyStr(curentDate, 4, 2).p);
  day = atoi(copyStr(curentDate, 1, 2).p);
  curentYear = year;
  curentMonth = month;
  curentDay = day;
  setNewYear(year);
}

void DoraCentralDocument::setNewDateTime()
{
   time_t ltime;
   time(&ltime);
   tm *t = localtime(&ltime);

   t->tm_hour = curentHour;
   t->tm_min  = curentMin;
   t->tm_sec  = curentSec;
   t->tm_mday = curentDay;
   t->tm_mon  = curentMonth - 1;
   t->tm_year = curentYear - 1900;
   
   time_t newTime = mktime(t);
   stime(&newTime);
}

void DoraCentralDocument::setAbautStr(Str35 langPrefix)
{
  itemStrAbaut.removeAllElement();

  if(langPrefix == "BG") {
    strAbaut item;
    item.strItem = "         ";
    itemStrAbaut.setElement(item, 1);
    item.strItem = "                   GPL.";
    itemStrAbaut.setElement(item, 2);
    item.strItem = "(c)   -  .";
    itemStrAbaut.setElement(item, 3);
    item.strItem = "       .";
    itemStrAbaut.setElement(item, 4);
    item.strItem = " :";
    itemStrAbaut.setElement(item, 5);
    item.strItem = "        e-mail : dorasmolyan@yahoo.com";
    itemStrAbaut.setElement(item, 6);
    item.strItem = "                 misho1960@yahoo.com";
    itemStrAbaut.setElement(item, 7);
    item.strItem = "                 mick_jobs@yahoo.com";
    itemStrAbaut.setElement(item, 8);
    item.strItem = "        GSM    : +359886470299 -  ";
    itemStrAbaut.setElement(item, 9);
    item.strItem = "  :";
    itemStrAbaut.setElement(item, 10);
    item.strItem = "    \"\" -  , - \"\"";
    itemStrAbaut.setElement(item, 11);
    item.strItem = " :";
    itemStrAbaut.setElement(item, 12);
    item.strItem = "        e-mail : theodora1968@yahoo.com";
    itemStrAbaut.setElement(item, 13);
    item.strItem = "        GSM    : +359887780640 -  ";
    itemStrAbaut.setElement(item, 14);
  }
  if(langPrefix == "RU") {
    strAbaut item;
    item.strItem = "           ";
    itemStrAbaut.setElement(item, 1);
    item.strItem = "                     GLP ";
    itemStrAbaut.setElement(item, 2);
    item.strItem = "(c)   -  - .";
    itemStrAbaut.setElement(item, 3);
    item.strItem = "      ";
    itemStrAbaut.setElement(item, 4);
    item.strItem = " :";
    itemStrAbaut.setElement(item, 5);
    item.strItem = "        e-mail : dorasmolyan@yahoo.com";
    itemStrAbaut.setElement(item, 6);
    item.strItem = "                 misho1960@yahoo.com";
    itemStrAbaut.setElement(item, 7);
    item.strItem = "                 mick_jobs@yahoo.com";
    itemStrAbaut.setElement(item, 8);
    item.strItem = "        GSM    : +359886470299 - Michael Petrov";
    itemStrAbaut.setElement(item, 9);
    item.strItem = "  :";
    itemStrAbaut.setElement(item, 10);
    item.strItem = "   \"\" -  - ";
    itemStrAbaut.setElement(item, 11);
    item.strItem = " :";
    itemStrAbaut.setElement(item, 12);
    item.strItem = "        e-mail : theodora1968@yahoo.com";
    itemStrAbaut.setElement(item, 13);
    item.strItem = "        GSM    : +359887780640 - Theodora Petrova";
    itemStrAbaut.setElement(item, 14);
  }
  if(langPrefix == "EN") {
    strAbaut item;
    item.strItem = "       This program is distributed the terms";
    itemStrAbaut.setElement(item, 1);
    item.strItem = "                 of the GLP license";
    itemStrAbaut.setElement(item, 2);
    item.strItem = "(c) Michael Petrov - Smolian - Bulgaria.";
    itemStrAbaut.setElement(item, 3);
    item.strItem = "    Free software developer";
    itemStrAbaut.setElement(item, 4);
    item.strItem = "For contacts:";
    itemStrAbaut.setElement(item, 5);
    item.strItem = "        e-mail : dorasmolyan@yahoo.com";
    itemStrAbaut.setElement(item, 6);
    item.strItem = "                 misho1960@yahoo.com";
    itemStrAbaut.setElement(item, 7);
    item.strItem = "                 mick_jobs@yahoo.com";
    itemStrAbaut.setElement(item, 8);
    item.strItem = "        GSM    : +359886470299 - Michael Petrov";
    itemStrAbaut.setElement(item, 9);
    item.strItem = "Sponsored this program:";
    itemStrAbaut.setElement(item, 10);
    item.strItem = "  Hear - dresser salon \"THEDY\" - Smolian - Bulgaria";
    itemStrAbaut.setElement(item, 11);
    item.strItem = "For contacts:";
    itemStrAbaut.setElement(item, 12);
    item.strItem = "        e-mail : theodora1968@yahoo.com";
    itemStrAbaut.setElement(item, 13);
    item.strItem = "        GSM    : +359887780640 - Theodora Petrova";
    itemStrAbaut.setElement(item, 14);
  }
  if(langPrefix == "FR") {
    strAbaut item;
    item.strItem = "  Sette programe est distributer par l`ordre et";
    itemStrAbaut.setElement(item, 1);
    item.strItem = "           les regles de licence GPL";
    itemStrAbaut.setElement(item, 2);
    item.strItem = "(c) Michael Petrov - Smolian - Bulgaria.";
    itemStrAbaut.setElement(item, 3);
    item.strItem = "    Software developper on prive practique";
    itemStrAbaut.setElement(item, 4);
    item.strItem = "Pour des contactes:";
    itemStrAbaut.setElement(item, 5);
    item.strItem = "        e-mail : dorasmolyan@yahoo.com";
    itemStrAbaut.setElement(item, 6);
    item.strItem = "                 misho1960@yahoo.com";
    itemStrAbaut.setElement(item, 7);
    item.strItem = "                 mick_jobs@yahoo.com";
    itemStrAbaut.setElement(item, 8);
    item.strItem = "        GSM    : +359886470299 - Michael Petrov";
    itemStrAbaut.setElement(item, 9);
    item.strItem = "Sponsore de sette programe:";
    itemStrAbaut.setElement(item, 10);
    item.strItem = "  Salon \"THEDY\" - Smolian - Bulgaria";
    itemStrAbaut.setElement(item, 11);
    item.strItem = "Pour des contactes:";
    itemStrAbaut.setElement(item, 12);
    item.strItem = "        e-mail : theodora1968@yahoo.com";
    itemStrAbaut.setElement(item, 13);
    item.strItem = "        GSM    : +359887780640 - Theodora Petrova";
    itemStrAbaut.setElement(item, 14);
  }
}

void DoraCentralDocument::addEncodingName()
{
  strEncoding item;
  item.name = "";item.name = "KOI8-R";
  item.index = 1;
  itemEncodingName.setElement(item, 1);
  item.name = "";item.name = "ISO 8859-1";
  item.index = 2;
  itemEncodingName.setElement(item, 2);
  item.name = "";item.name = "ISO 8859-2";
  item.index = 3;
  itemEncodingName.setElement(item, 3);
  item.name = "";item.name = "ISO 8859-3";
  item.index = 4;
  itemEncodingName.setElement(item, 4);
  item.name = "";item.name = "ISO 8859-4";
  item.index = 5;
  itemEncodingName.setElement(item, 5);
  item.name = "";item.name = "ISO 8859-5";
  item.index = 6;
  itemEncodingName.setElement(item, 6);
  item.name = "";item.name = "ISO 8859-6";
  item.index = 7;
  itemEncodingName.setElement(item, 7);
  item.name = "";item.name = "ISO 8859-7";
  item.index = 8;
  itemEncodingName.setElement(item, 8);
  item.name = "";item.name = "ISO 8859-8";
  item.index = 9;
  itemEncodingName.setElement(item, 9);
  item.name = "";item.name = "ISO 8859-9";
  item.index = 10;
  itemEncodingName.setElement(item, 10);
  item.name = "";item.name = "ISO 8859-10";
  item.index = 11;
  itemEncodingName.setElement(item, 11);
  item.name = "";item.name = "ISO 8859-13";
  item.index = 12;
  itemEncodingName.setElement(item, 12);
  item.name = "";item.name = "ISO 8859-14";
  item.index = 13;
  itemEncodingName.setElement(item, 13);
  item.name = "";item.name = "ISO 8859-15";
  item.index = 14;
  itemEncodingName.setElement(item, 14);
  item.name = "";item.name = "CP 1250";
  item.index = 15;
  itemEncodingName.setElement(item, 15);
  item.name = "";item.name = "CP 1251";
  item.index = 16;
  itemEncodingName.setElement(item, 16);
  item.name = "";item.name = "CP 1252";
  item.index = 17;
  itemEncodingName.setElement(item, 17);
  item.name = "";item.name = "CP 1253";
  item.index = 18;
  itemEncodingName.setElement(item, 18);
  item.name = "";item.name = "CP 1254";
  item.index = 19;
  itemEncodingName.setElement(item, 19);
  item.name = "";item.name = "CP 1255";
  item.index = 20;
  itemEncodingName.setElement(item, 20);
  item.name = "";item.name = "CP 1256";
  item.index = 21;
  itemEncodingName.setElement(item, 21);
  item.name = "";item.name = "CP 1257";
  item.index = 22;
  itemEncodingName.setElement(item, 22);
  item.name = "";item.name = "CP 1258";
  item.index = 23;
  itemEncodingName.setElement(item, 23);
}
		   
void DoraCentralDocument::addLangName()
{
  strLang item;

  item.index = 1;
  item.encoding = "";item.encoding = "CP 1251";
  item.name = "";item.name = "";
  item.prefix = "";item.prefix = "BG";
  itemLangName.setElement(item, 1);

  item.index = 2;
  item.encoding = "";item.encoding = "KOI8-R";
  item.name = "";item.name = "";
  item.prefix = "";item.prefix = "RU";
  itemLangName.setElement(item, 2);

  item.index = 3;
  item.encoding = "";item.encoding = "ISO 8859-1";
  item.name = "";item.name = "";
  item.prefix = "";item.prefix = "EN";
  itemLangName.setElement(item, 3);

  item.index = 4;
  item.encoding = "";item.encoding = "ISO 8859-1";
  item.name = "";item.name = "";
  item.prefix = "";item.prefix = "FR";
  itemLangName.setElement(item, 4);
}

void DoraCentralDocument::setNewLang(Str35 langName)
{
  if(langName != "") {
    int maxElement = itemLangName.maxElement();
    int iLoc = 1;
    Str35 encoding;
    encoding = "";
    for(int i = 0; i <= maxElement - 1; i++) {
      if(langName == itemLangName[i].name) {
	iLoc = i + 1;
	encoding = "";encoding = itemLangName[i].encoding;
	break;
      }
    }
    curentLang = iLoc;
    if(encoding != "") {
      int maxEncoding = itemEncodingName.maxElement();
      for(int i = 0; i <= maxEncoding - 1; i++) {
	if(encoding == itemEncodingName[i].name) {
	  curentEncoding = i + 1;
	  break;
	}
      }
      setNewConvChar(encoding);
    }
  }
}
		  
void DoraCentralDocument::loadConfigDir(Str35 langPrefix, Str35 configFile)
{
  Str35 fileName;
  fileName = "";fileName = fileName + "/Config/" + langPrefix + "/" + configFile+"_BIO";
  Str80 str;
  int offset = 0, index = 1;
  bool ok = true;
  itemStrLangCaption.removeAllElement();
  do {
    str = "";str = fs.loadTextString(fileName, offset);
    int len = strlen(str.p) + 1;
    if(str == "") {
      ok = false;
    } else {
      strLangCaption item;
      item.str = "";item.str = str;
      itemStrLangCaption.setElement(item, index);
      index++;
    }
    offset += len;
  } while(ok != false);
}

void DoraCentralDocument::loadLangFile(Str35 langPrefix)
{
  Str35 fileName;
  Str80 str;
  int offset = 0, index = 1, len = 0;
  bool ok = true;
  fileName = "";fileName = fileName + "/Config/"+langPrefix+"/LANG_BIO";
  int maxElement = itemLangName.maxElement();
  do {
    str = "";str = fs.loadTextString(fileName, offset);
    if(str != "") {
      printf("name = %s\n", str.p);
      strLang item;
      if(index <= maxElement)
	item = itemLangName[index-1];
      item.name = "";item.name = item.name + str.p;
      len = strlen(str.p) + 1;
      offset += len;
      str = "";str = fs.loadTextString(fileName, offset);
      printf("prefix = %s\n", str.p); 
      item.prefix = "";item.prefix = item.prefix + str.p;
      len = strlen(str.p) + 1;
      offset += len;
      str = "";str = fs.loadTextString(fileName, offset);
      printf("encoding = %s\n", str.p);
      item.encoding = "";item.encoding = item.encoding + str.p;
      len = strlen(str.p) + 1;
      offset += len;
      itemLangName.setElement(item, index);
      index++;
    } else {
      ok = false;
    }
  } while(ok != false);
}
    
void DoraCentralDocument::loadOtherCaption(Str35 langPrefix)
{
  Str35 fileName;
  Str80 str;
  int offset = 0, len = 0;
  fileName = "";fileName = fileName + "/Config/" + langPrefix + "/OTHER_BIO";
  if(fs.isFileName(fileName)) {
    str = "";str = fs.loadTextString(fileName, offset);
    capCheck1 = "";capCheck1 = str.p;
    len = strlen(str.p) + 1;offset += len;
    str = "";str = fs.loadTextString(fileName, offset);
    capCheck2 = "";capCheck2 = str.p;
    len = strlen(str.p) + 1;offset += len;
    str = "";str = fs.loadTextString(fileName, offset);
    capCalButton1 = "";capCalButton1 = str.p;
    len = strlen(str.p) + 1;offset += len;
    str = "";str = fs.loadTextString(fileName, offset);
    capCalButton2 = "";capCalButton2 = str.p;
    len = strlen(str.p) + 1;offset += len;
    str = "";str = fs.loadTextString(fileName, offset);
    capSpin1 = "";capSpin1 = str.p;
    len = strlen(str.p) + 1;offset += len;
    str = "";str = fs.loadTextString(fileName, offset);
    capSpin2 = "";capSpin2 = str.p;
    len = strlen(str.p) + 1;offset += len;
    str = "";str = fs.loadTextString(fileName, offset);
    capSpin3 = "";capSpin3 = str.p;
    len = strlen(str.p) + 1;offset += len;
    str = "";str = fs.loadTextString(fileName, offset);
    capIntr1 = "";capIntr1 = str.p;
    len = strlen(str.p) + 1;offset += len;
    str = "";str = fs.loadTextString(fileName, offset);
    capIntr2 = "";capIntr2 = str.p;
    len = strlen(str.p) + 1;offset += len;
    str = "";str = fs.loadTextString(fileName, offset);
    capInfo1 = "";capInfo1 = str.p;
    len = strlen(str.p) + 1;offset += len;
    str = "";str = fs.loadTextString(fileName, offset);
    capInfo2 = "";capInfo2 = str.p;
    len = strlen(str.p) + 1;offset += len;
    str = "";str = fs.loadTextString(fileName, offset);
    capInfo3 = "";capInfo3 = str.p;
    len = strlen(str.p) + 1;offset += len;
    str = "";str = fs.loadTextString(fileName, offset);
    capInfoButton1 = "";capInfoButton1 = str.p;
    len = strlen(str.p) + 1;offset += len;
    str = "";str = fs.loadTextString(fileName, offset);
    capAbautView = "";capAbautView = str.p;
    len = strlen(str.p) + 1;offset += len;
    str = "";str = fs.loadTextString(fileName, offset);
    capReclView = "";capReclView = str.p;
    len = strlen(str.p) + 1;offset += len;
    str = "";str = fs.loadTextString(fileName, offset);
    capExit = "";capExit = str.p;
    len = strlen(str.p) + 1;offset += len;
    str = "";str = fs.loadTextString(fileName, offset);
    capClose = "";capClose = str.p;
    len = strlen(str.p) + 1;offset += len;
    str = "";str = fs.loadTextString(fileName, offset);
    capMenagment = "";capMenagment = str.p;
    len = strlen(str.p) + 1;offset += len;
    str = "";str = fs.loadTextString(fileName, offset);
    capBioritm = "";capBioritm = str.p;
    len = strlen(str.p) + 1;offset += len;
    str = "";str = fs.loadTextString(fileName, offset);
    capBioDialog = "";capBioDialog = str.p;
    printf("capBioDialog = %s\n", capBioDialog.p);
  }
}

bool DoraCentralDocument::okYearDir(const int year)
{
  Str35 s1, s2, yearDir, sYear;
  bool ok = false;
  s1 = "";sprintf(s1.p, "%4d\0", year);s2 = "";s2 = spaceNull(4, s1);
  sYear = "";sYear = s2;
  yearDir = "";yearDir = yearDir + "/Year" + sYear;
  if(fs.isDirName(yearDir))
    ok = true;
  else
    ok = false;
  return ok;
}
