#if !defined(_DORACENTRALDOCUMENT_H)
#define _DORACENTRALDOCUMENT_H

#include <qwidget.h>
#include <qfont.h>
#include <qfontmetrics.h>

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <ctype.h>
#include <typeinfo>

#include "Typedef.h"
#include "Dynacolect.h"
#include "DoraClassObject.h"
#include "DoraBaseDocument.h"
#include "DoraBaseView.h"
#include "CompareDate.h"
#include "DoraConvChar.h"
#include "DoraFileSystem.h"
#include "DoraCriticalSection.h"
#include "CalcMonthDay.h"
#include "CalcNewYear.h"
#include "SetNewBDate.h"

class DoraCentralDocument : public DoraBaseDocument
{
public:
  struct strLangCaption {
    Str80 str;
    strLangCaption(strLangCaption *x = NULL) {
      str = "";
    }
    strLangCaption(const strLangCaption &x) {
      str = "";str = x.str;
    }
    strLangCaption &operator=(strLangCaption x) {
      str = "";str = x.str;
      return *this;
    }
  };

  struct strDefineFont {
    Str35 fontName;
    Str35 encodingName;
    int   fontSize;

    strDefineFont(strDefineFont *x = NULL) {
      fontName = "";
      encodingName = "";
      fontSize = 0;
    }
    strDefineFont(const strDefineFont &x) {
      fontName = "";
      fontName = x.fontName;
      encodingName = "";
      encodingName = x.encodingName;
      fontSize = x.fontSize;
    }
    strDefineFont &operator=(strDefineFont x) {
      fontName = "";
      fontName = x.fontName;
      encodingName = x.encodingName;
      fontSize = x.fontSize;
      return *this;
    }
  };
  
  struct strMonth {
    Str35 caption;
    int   index;
    int   week;
    Str35 dateStr;
    Str35 infoStr;
    bool  isValid;
    bool  isCurent;
    bool  isRed;

    strMonth(strMonth *x = NULL) {
      caption  = "";
      infoStr  = "";
      dateStr  = "";
      index    = 0;
      week     = 0;
      isValid  = false;
      isCurent = false;
      isRed = false;
    }
    strMonth(const strMonth &x) {
      caption = "";caption = x.caption;
      infoStr = "";infoStr = x.infoStr;
      dateStr = "";dateStr = x.dateStr;
      index = x.index;
      week  = x.week;
      isValid = x.isValid;
      isCurent = x.isCurent;
      isRed = x.isRed;
    }
    strMonth &operator=(strMonth x) {
      caption = "";caption = x.caption;
      infoStr = "";infoStr = x.infoStr;
      dateStr = "";dateStr = x.dateStr;
      index = x.index;
      week  = x.week;
      isValid = x.isValid;
      isCurent = x.isCurent;
      isRed = x.isRed;
      return *this;
    }
  };

  struct strMonthName {
    int index;
    Str35 name;
    strMonthName(strMonthName *x = NULL) {
      name = "";
      index = 0;
    }
    strMonthName(const strMonthName &x) {
      name = "";name = x.name;
      index = x.index;
    }
    strMonthName &operator=(strMonthName x) {
      name = "";name = x.name;
      index = x.index;
      return *this;
    }
  };

  struct strDayName {
    int index;
    Str35 name;
    strDayName(strDayName *x = NULL) {
      name = "";
      index = 0;
    }
    strDayName(const strDayName &x) {
      name = "";name = x.name;
      index = x.index;
    }
    strDayName &operator=(strDayName x) {
      name = "";name = x.name;
      index = x.index;
      return *this;
    }
  };

  struct strAbaut {
    String strItem;
    strAbaut(strAbaut *x = NULL) {
      strItem = "";
    }
    strAbaut(const strAbaut &x) {
      strItem = "";strItem = x.strItem;
    }
    strAbaut &operator=(strAbaut x) {
      strItem = "";strItem = x.strItem;
      return *this;
    }
  };

  struct strEncoding {
    int index;
    Str35 name;
    strEncoding(strEncoding *x = NULL) {
      index = 0;
      name = "";
    }
    strEncoding(const strEncoding &x) {
      index = x.index;
      name = "";name = x.name;
    }
    strEncoding &operator=(strEncoding x) {
      index = x.index;
      name = "";name = x.name;
      return *this;
    }
  };

  struct strLang {
    int index;
    Str35 name, prefix, encoding;
    strLang(strLang *x = NULL) {
      index = 0;
      name = "";
      prefix = "";
      encoding = "";
    }
    strLang(const strLang &x) {
      index = x.index;
      name = x.name;
      prefix = x.prefix;
      encoding = x.encoding;
    }
    strLang &operator=(strLang x) {
      index = x.index;
      name = x.name;
      prefix = x.prefix;
      encoding = x.encoding;
      return *this;
    }
  };

  typedef DoraArray<strDefineFont> TypeDefineFont;
  typedef DoraArray<strMonth>      TypeMonth;
  typedef DoraArray<strMonthName>  TypeMonthName;
  typedef DoraArray<strDayName>    TypeDayName;
  typedef DoraArray<strAbaut>      TypeStrAbaut;
  typedef DoraArray<strEncoding>   TypeStrEncoding;
  typedef DoraArray<strLang>       TypeStrLang;
  typedef DoraArray<strLangCaption> TypeStrLangCaption;
public:
  DoraRuntimeClass *GetRuntimeClass() const {
    return &classDoraCentralDocument;
  }
  static DoraRuntimeClass classDoraCentralDocument;
  static DoraClassObject *CreateView(QWidget *parent);
  static DoraClassObject *CreateDocument();

public:
  DoraCentralDocument() : DoraBaseDocument() {
    printf("   DoraCentralDocument\n");
    itemDefineFont.removeAllElement();
    itemMonth.removeAllElement();
    itemMonthName.removeAllElement();
    itemDayName.removeAllElement();    
    itemCurentMonth.removeAllElement();
    itemStrAbaut.removeAllElement();
    itemEncodingName.removeAllElement();
    itemLangName.removeAllElement();
    itemStrLangCaption.removeAllElement();
    minDate = "";
    maxDate = "";
    bDate = "";
    calDay = redDay = blcDay = 0;
    reklamaStr = "";
    m_pCalcMonthDay = NULL;
    m_pCalcNewYear  = NULL;
    m_pSetNewBDate = NULL;
  }
  ~DoraCentralDocument() {
    printf("   DoraCentralDocument\n");
  }

public:
  void addDefaultFont();
  void setDefaultFont(strDefineFont item, const int index);
  void addMonthName();
  void addEncodingName();
  void addLangName();
  void setMonthName(strMonthName item, const int index);
  void addDayName();
  void setDayName(strDayName item, const int index);
  bool loadMonth(const int month, const int year);
  void setRed(const int index, const bool red);
  void calcCalendarDay(DoraBaseView *pView);
  void getCurentTime();
  void getCurentDate();
  void setReklamaStr();
  void setNewYear(const int year);
  void setNewBDate();
  void setCurentYear();
  void setNewDateTime();
  void setAbautStr(Str35 langPrefix);
  void setNewConvChar(Str35 encodingName);
  void setNewLang(Str35 langName);
  bool okYearDir(const int year);

public:
  CString getEncodingName(const int index);
  QFont   getDefaultFont(const int index);
  void    initDocument();
  void    loadLangFile(Str35 langPrefix);
  void    loadConfigDir(Str35 langPrefix, Str35 configFile);
  void    loadOtherCaption(Str35 langPrefix);

public:
  DoraConvChar convChar;
  int          maxDayMonth;
  int          maxCalButton;
  int          curentDay;
  int          curentMonth;
  int          curentYear;
  int          curentHour;
  int          curentMin;
  int          curentSec;
  int          curentIndex;
  int          calDay;
  int          redDay;
  int          blcDay;
  int          curentEncoding;
  int          curentLang;

  DoraFileSystem fs;
  CompareDate    compDate;
  Str35          minDate;
  Str35          maxDate;
  Str35          bDate;
  CString        reklamaStr;

public:
  Str35 capCheck1, capCheck2, capCalButton1, capCalButton2;
  Str35 capSpin1, capSpin2, capSpin3, capIntr1, capIntr2;
  Str35 capInfo1, capInfo2, capInfo3, capInfoButton1;
  Str35 capAbautView, capReclView, capExit, capClose, capMenagment;
  Str35 capBioritm, capBioDialog;

public:
  TypeDefineFont  itemDefineFont;
  TypeMonth       itemMonth, itemCurentMonth;
  TypeMonthName   itemMonthName;
  TypeDayName     itemDayName;
  TypeStrAbaut    itemStrAbaut;
  TypeStrEncoding itemEncodingName;
  TypeStrLang     itemLangName;
  TypeStrLangCaption itemStrLangCaption;
  CalcMonthDay    *m_pCalcMonthDay;
  CalcNewYear     *m_pCalcNewYear;
  SetNewBDate     *m_pSetNewBDate;
  DoraCriticalSection *m_pCriticalSection;

public:
  void updateDocument();

};

#endif






