#if !defined(_DORACENTRALVIEW_H)
#define _DORACENTRALVIEW_H

#include <qapplication.h>
#include <qwidget.h>
#include <qevent.h>
#include <qfont.h>
#include <qfontmetrics.h>
#include <qpainter.h>
#include <qcolor.h>
#include <qrect.h>
#include <qfontdialog.h>

#include "Typedef.h"
#include "Dynacolect.h"
#include "DoraClassObject.h"
#include "DoraBaseView.h"
#include "DoraBaseDocument.h"
#include "DoraCalendarView.h"
#include "DoraLeftView.h"
#include "DoraDialogDoc.h"
#include "BioritmView.h"

class DoraCentralView : public DoraBaseView
{
public:
  DoraRuntimeClass *GetRuntimeClass() const {
    return &classDoraCentralView;
  }
  static DoraRuntimeClass classDoraCentralView;
  static DoraClassObject *CreateView(QWidget *parent);
  static DoraClassObject *CreateDocument();

public:
  DoraCentralView(QWidget *parent, const char *name = 0) : DoraBaseView(parent, name) {
    printf("   DoraCentralView\n");
    m_pCalendarView = NULL;
    m_pLeftView = NULL;
    m_pBioritmView = NULL;
  }
  
  ~DoraCentralView() {
    printf("   DoraCentralView\n");
  }

public:
  void OnDraw(QPainter *p);
  void OnSize(int cx, int cy);
  void OnCreate(DoraClassObject *pObject);
  void DestroyView();
  void UpdateConvChar();

public:
  QRect               clientRect;

public:
  DoraClassObject     *m_pObject;
  DoraCentralDocument *GetDocument();
  DoraDialogDoc       *GetDialogDoc();

public:
  DoraCalendarView *m_pCalendarView;
  DoraLeftView     *m_pLeftView;
  DoraDialogDoc    *m_pDialogDoc;
  BioritmView      *m_pBioritmView;

public:
  void stopClock();
  void startClock();
  void setCurentDate();
  void setBioritms();
  void closeBioritm();

};

#endif
