#include "DoraCheckBmpButton.h"

DoraRuntimeClass DoraCheckBmpButton::classDoraCheckBmpButton={"DoraCheckBmpButton", DoraCheckBmpButton::CreateView, NULL};

DoraClassObject *DoraCheckBmpButton::CreateView(QWidget *parent)
{
  return new DoraCheckBmpButton(parent);
}

DoraClassObject *DoraCheckBmpButton::CreateDocument()
{
  return NULL;
}

void DoraCheckBmpButton::OnCreate(DoraClassObject *pObject, DoraBaseView *pView)
{
  m_pObject = pObject;
  m_pDialog = NULL;
  m_pView   = pView;

  if(nID == ID_CHECKBUTTON_ALLCICLE) {
    QPixmap pm(bmp_button_allcicle);
    setPixmap(pm);
  }
  if(nID == ID_CHECKBUTTON_PHICICLE) {
    QPixmap pm(bmp_button_pcicle);
    setPixmap(pm);
  }
  if(nID == ID_CHECKBUTTON_SENCICLE) {
    QPixmap pm(bmp_button_scicle);
    setPixmap(pm);
  }
  if(nID == ID_CHECKBUTTON_CONCICLE) {
    QPixmap pm(bmp_button_ccicle);
    setPixmap(pm);
  }
}

void DoraCheckBmpButton::OnCreate(DoraClassObject *pObject, DoraBaseDialog *pDialog)
{
  m_pObject = pObject;
  m_pDialog = pDialog;
  m_pView   = NULL;

  if(nID == ID_CHECKBUTTON_ALLCICLE) {
    QPixmap pm(bmp_button_allcicle);
    setPixmap(pm);
  }
  if(nID == ID_CHECKBUTTON_PHICICLE) {
    QPixmap pm(bmp_button_pcicle);
    setPixmap(pm);
  }
  if(nID == ID_CHECKBUTTON_SENCICLE) {
    QPixmap pm(bmp_button_scicle);
    setPixmap(pm);
  }
  if(nID == ID_CHECKBUTTON_CONCICLE) {
    QPixmap pm(bmp_button_ccicle);
    setPixmap(pm);
  }
}

void DoraCheckBmpButton::setPixmap(QPixmap pm)
{
  pixmap = pm;
}

void DoraCheckBmpButton::OnSize(int cx, int cy)
{
  clientRect.setX(0);
  clientRect.setY(0);
  clientRect.setWidth(cx);
  clientRect.setHeight(cy);
  printf("cx = %4d, cy = %4d\n", cx, cy);
}

void DoraCheckBmpButton::OnDraw(QPainter *p)
{
  p->setFont(font);
  p->setPen(QPen(QColor(0, 0, 0), 1));
  p->setBrush(QBrush(QColor(192, 192, 192)));
  p->drawRect(clientRect);

  int x1 = clientRect.x();
  int y1 = clientRect.y();
  int x2 = clientRect.width() - 1;
  int y2 = clientRect.height() - 1;

  int xl1 = x1 + 1;
  int yl1 = y1 + 1;
  int xl2 = x2 - 1;
  int yl2 = y2 - 1;

  int wPmap = pixmap.width();
  int hPmap = pixmap.height();

  int xPmap = x1 + ((int)((clientRect.width() - wPmap) / 2));
  int yPmap = y1 + ((int)((clientRect.height() - hPmap) / 2));

  if(!okPushed) {
    p->setPen(QPen(QColor(255, 255, 255), 1));
    p->drawLine(xl1, yl2, xl1, yl1);
    p->drawLine(xl1, yl1, xl2, yl1);
    p->setPen(QPen(QColor(0, 0, 0), 1));
    p->drawLine(xl1, yl2, xl2, yl2);
    p->drawLine(xl2, yl2, xl2, yl1);
    p->drawPixmap(xPmap, yPmap, pixmap);
  }
  if(okPushed) {
    p->setPen(QPen(QColor(0, 0, 0), 1));
    p->drawLine(xl1, yl2, xl1, yl1);
    p->drawLine(xl1, yl1, xl2, yl1);
    p->setPen(QPen(QColor(255, 255, 255), 1));
    p->drawLine(xl1, yl2, xl2, yl2);
    p->drawLine(xl2, yl2, xl2, yl1);
    p->drawPixmap(xPmap + 1, yPmap + 1, pixmap);
  }
}

void DoraCheckBmpButton::MouseLeftButton(int xLocPos, int yLocPos, int xPosGlb, int yPosGlb)
{
  okPushed = !okPushed;
  repaint(false);
  if(m_pView != NULL)
    m_pView->PostMouseMessage(ctrlID, nID);
  if(m_pDialog != NULL)
    m_pDialog->PostMouseMessage(ctrlID, nID);
}

void DoraCheckBmpButton::setCheck(const bool check)
{
  okCheck = check;
  if(check)
    okPushed = true;
  else
    okPushed = false;
  repaint(false);
}
