#include "DoraCheckButton.h"

DoraRuntimeClass DoraCheckButton::classDoraCheckButton = {"DoraCheckButton", DoraCheckButton::CreateView, NULL};

DoraClassObject *DoraCheckButton::CreateView(QWidget *parent)
{
  return new DoraCheckButton(parent);
}

DoraClassObject *DoraCheckButton::CreateDocument()
{
  return NULL;
}

void DoraCheckButton::OnDraw(QPainter *p)
{
  switch(styleButton) {
    case ID_CHECK_BUTTON_PLUSMINUS :
      OnDrawPlusMinus(p);
      break;
    case ID_CHECK_BUTTON_PUSH      :
      OnDrawPushed(p);
      break;
    case ID_CHECK_BUTTON_CHECKER   :
      OnDrawChecker(p);
      break;
  }
}

void DoraCheckButton::OnDrawPlusMinus(QPainter *p)
{
  p->setPen(QColor(255, 255, 255));
  p->setBrush(QColor(255, 255, 255));
  p->drawRect(clientRect);

  p->setPen(QColor(0, 0, 0));
  p->setBrush(QColor(192, 192, 192));
  p->drawRect(clientRect);

  int x1 = clientRect.x();
  int y1 = clientRect.y();
  int x2 = x1 + clientRect.width();
  int y2 = y1 + clientRect.height();

  
  p->setPen(QColor(255, 255, 255));
  p->drawLine(x1 + 1, y2 - 1, x1 + 1, y1 + 1);
  p->drawLine(x1 + 1, y1 + 1, x2 - 1, y1 + 1);
  p->setPen(QColor(0, 0, 0));
  p->drawLine(x1 + 1, y2 - 1, x2 - 1, y2 - 1);
  p->drawLine(x2 - 1, y2 - 1, x2 - 1, y1 + 1);
  

  int xp1 = x1 + 4;
  int xp2 = x1 + (x2 - 4);
  int yp1 = y1 + 4;
  int yp2 = y1 + (y2 - 4);

  int xc = (int)((xp2 - xp1) / 2);
  int yc = (int)((yp2 - yp1) / 2);

  if(!okCheck) {
    QPointArray point(3);
    point.setPoint(0, xp1, yp2);
    point.setPoint(1, xp1, yp1);
    point.setPoint(2, xp2, yp1);
    p->setPen(QColor(0, 0, 0));
    p->setBrush(QColor(0, 0, 0));
    p->drawPolygon(point);
  } else {
    QPointArray point(3);
    point.setPoint(0, xp1, yp2);
    point.setPoint(1, xp2, yp2);
    point.setPoint(2, xp2, yp1);
    p->setPen(QColor(0, 0, 0));
    p->setBrush(QColor(0, 0, 0));
    p->drawPolygon(point);
  }
}

void DoraCheckButton::OnDrawPushed(QPainter *p)
{
  p->setPen(QColor(0, 0, 0));
  p->setBrush(QColor(192, 192, 192));
  p->drawRect(clientRect);

  int x1 = clientRect.x();
  int y1 = clientRect.y();
  int x2 = x1 + clientRect.width();
  int y2 = y1 + clientRect.height();

  if(!okCheck) {
    p->setPen(QColor(255, 255, 255));
    p->drawLine(x1 + 2, y2 - 2, x1 + 2, y1 + 2);
    p->drawLine(x1 + 2, y1 + 2, x2 - 2, y1 + 2);
    p->setPen(QColor(0, 0, 0));
    p->drawLine(x1 + 2, y2 - 2, x2 - 2, y2 - 2);
    p->drawLine(x2 - 2, y2 - 2, x2 - 2, y1 + 2);
  } else {
    p->setPen(QColor(0, 0, 0));
    p->drawLine(x1 + 2, y2 - 2, x1 + 2, y1 + 2);
    p->drawLine(x1 + 2, y1 + 2, x2 - 2, y1 + 2);
    p->setPen(QColor(255, 255, 255));
    p->drawLine(x1 + 2, y2 - 2, x2 - 2, y2 - 2);
    p->drawLine(x2 - 2, y2 - 2, x2 - 2, y1 + 2);
  }

  int xp1 = x1 + 4;
  int xp2 = x1 + (x2 - 4);
  int yp1 = y1 + 4;
  int yp2 = y1 + (y2 - 4);

  int xc = (int)((xp2 - xp1) / 2);
  int yc = (int)((yp2 - yp1) / 2);

  QRect rect;
  rect.setX(xp1);
  rect.setY(yp1);
  rect.setWidth(xp2 - xp1);
  rect.setHeight(yp2 - yp1);
  if(!okCheck) {
    p->setPen(QColor(0, 0, 0));
    p->setBrush(QColor(255, 0, 0));
  } else {
    p->setPen(QColor(0, 0, 0));
    p->setBrush(QColor(0, 255, 0));
  }
  p->drawRect(rect);
}

void DoraCheckButton::OnDrawChecker(QPainter *p)
{
  p->setPen(QColor(0, 0, 0));
  p->setBrush(QColor(192, 192, 192));
  p->drawRect(clientRect);

  int x1 = clientRect.x();
  int y1 = clientRect.y();
  int x2 = x1 + clientRect.width();
  int y2 = y1 + clientRect.height();

  if(!okCheck) {
    p->setPen(QColor(255, 255, 255));
    p->drawLine(x1 + 2, y2 - 2, x1 + 2, y1 + 2);
    p->drawLine(x1 + 2, y1 + 2, x2 - 2, y1 + 2);
    p->setPen(QColor(0, 0, 0));
    p->drawLine(x1 + 2, y2 - 2, x2 - 2, y2 - 2);
    p->drawLine(x2 - 2, y2 - 2, x2 - 2, y1 + 2);
  } else {
    p->setPen(QColor(0, 0, 0));
    p->drawLine(x1 + 2, y2 - 2, x1 + 2, y1 + 2);
    p->drawLine(x1 + 2, y1 + 2, x2 - 2, y1 + 2);
    p->setPen(QColor(255, 255, 255));
    p->drawLine(x1 + 2, y2 - 2, x2 - 2, y2 - 2);
    p->drawLine(x2 - 2, y2 - 2, x2 - 2, y1 + 2);
  }

  int xp1 = x1 + 4;
  int xp2 = x1 + (x2 - 4);
  int yp1 = y1 + 4;
  int yp2 = y1 + (y2 - 4);

  int xc = (int)((xp2 - xp1) / 2);
  int yc = (int)((yp2 - yp1) / 2);

  QRect rect;
  rect.setX(xp1);
  rect.setY(yp1);
  rect.setWidth(xp2 - xp1);
  rect.setHeight(yp2 - yp1);
  if(!okCheck) {
    p->setPen(QColor(0, 0, 0));
    p->setBrush(QColor(255, 0, 0));
  } else {
    p->setPen(QColor(0, 0, 0));
    p->setBrush(QColor(0, 255, 0));
  }
  p->drawEllipse(rect);
}

void DoraCheckButton::OnSize(int cx, int cy)
{
  clientRect.setX(0);
  clientRect.setY(0);
  clientRect.setWidth(cx);
  clientRect.setHeight(cy);
}

void DoraCheckButton::OnCreate(DoraClassObject *pObject, DoraBaseView *pView, int index, int style)
{
  m_pObject   = pObject;
  m_pView     = pView;
  styleButton = style;
  indexButton = index;
}

void DoraCheckButton::MouseLeftButton(int xLocPos, int yLocPos, int xPosGlb, int yPosGlb)
{
  okCheck = !okCheck;
  repaint(false);
  if(m_pView != NULL)
    m_pView->PostMouseMessage(DM_CHECKBUTTON, indexButton);
}

void DoraCheckButton::setCheck(const bool check)
{
  okCheck = check;
  repaint(false);
}
