#if !defined(_DORACHECKGROUP_H)
#define _DORACHECKGROUP_H

#include <qapplication.h>
#include <qwidget.h>
#include <qpainter.h>
#include <qcolor.h>
#include <qrect.h>
#include <qevent.h>
#include <qfont.h>
#include <qfontmetrics.h>

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <ctype.h>
#include <typeinfo>

#include "Typedef.h"
#include "Dynacolect.h"
#include "DoraClassObject.h"
#include "DoraBaseView.h"
#include "DoraStaticCtrl.h"
#include "DoraCheckButton.h"

struct ItemCheckGroup {
  DoraStaticCtrl  *staticCtrl;
  DoraCheckButton *checkButton;
  
  ItemCheckGroup(ItemCheckGroup *x = NULL) {
    staticCtrl  = NULL;
    checkButton = NULL;
  }

  ItemCheckGroup(const ItemCheckGroup &x) {
    staticCtrl = NULL;
    staticCtrl = x.staticCtrl;
    checkButton = NULL;
    checkButton = x.checkButton;
  }

  ItemCheckGroup &operator=(ItemCheckGroup x) {
    staticCtrl = NULL;
    staticCtrl = x.staticCtrl;
    checkButton = NULL;
    checkButton = x.checkButton;

    return *this;
  }
};

typedef DoraArray<ItemCheckGroup> TypeItemCheckGroup;
  
class DoraCheckGroup : public DoraBaseView
{
public:
  DoraRuntimeClass *GetGetRuntimeClass() const {
    return &classDoraCheckGroup;
  }
  static DoraRuntimeClass classDoraCheckGroup;
  static DoraClassObject *CreateView(QWidget *parent);
  static DoraClassObject *CreateDocument();

public:
  DoraCheckGroup(QWidget *parent, const char *name = 0) : DoraBaseView(parent, name) {
    printf("   DoraCheckGroup\n");
    itemCheckGroup.removeAllElement();
    oldCheck = 1;
    capGroup = "";
  }
  ~DoraCheckGroup() {
    printf("   DoraCheckGroup\n");
  }

public:
  void OnDraw(QPainter *p);
  void OnSize(int cx, int cy);

public:
  void OnCreate(DoraClassObject *pObject, DoraBaseView *pView);
  void setGroupItems(ItemCheckGroup x, const int index);
  void createGroup(const int index, const Str35 caption);
  void setSizeItems(const int index, const int x1, const int y1, const int w, const int h);
  void PostMouseMessage(int ctrl, int index);
  void setCheckButton(const int index );
  void setCaptions(const int index, const Str35 caption);
  void UpdateConvChar();

public:
  DoraClassObject *m_pObject;
  DoraBaseView    *m_pView;
  TypeItemCheckGroup itemCheckGroup;

public:
  QRect   clientRect;
  int     oldCheck;
  CString capGroup;
};

#endif







