#if !defined(_DORACHECKHGROUP_H)
#define _DORACHECKHGROUP_H

#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <unistd.h>

#include <qwidget.h>
#include <qpainter.h>
#include <qfont.h>
#include <qfontmetrics.h>
#include <qcolor.h>
#include <qrect.h>
#include <qevent.h>

#include "Typedef.h"
#include "Dynacolect.h"
#include "DoraClassObject.h"
#include "DoraBaseView.h"
#include "DoraBaseDialog.h"
#include "DoraCheckBmpButton.h"
#include "AttrToolView.h"

class DoraCheckHGroup : public DoraBaseView
{
public:
  struct strButton {
    DoraCheckBmpButton *button;
    Str35 cap1, cap2;
    int xb, yb, wb, hb;
    strButton(strButton *x = NULL) {
      button = NULL;
      xb = yb = wb = hb = 0;
      cap1 = "";cap2 = "";
    }
    strButton(const strButton &x) {
      button = x.button;
      xb = x.xb;
      yb = x.yb;
      wb = x.wb;
      hb = x.hb;
      cap1 = x.cap1;
      cap2 = x.cap2;
    }
    strButton &operator=(strButton x) {
      button = x.button;
      xb = x.xb;
      yb = x.yb;
      wb = x.wb;
      hb = x.hb;
      cap1 = x.cap1;
      cap2 = x.cap2;
      return *this;
    }
  };
  typedef DoraArray<strButton> TypeStrButton;

public:
  DoraRuntimeClass *GetRuntimeClass() const {
    return &classDoraCheckHGroup;
  }
  static DoraRuntimeClass classDoraCheckHGroup;
  static DoraClassObject *CreateView(QWidget *parent);
  static DoraClassObject *CreateDocument();

public:
  DoraCheckHGroup(QWidget *parent, const char *name = 0) : DoraBaseView(parent, name) {
    printf("   DoraCheckHGroup\n");
    itemButton.removeAllElement();
  }
  ~DoraCheckHGroup() {
    printf("   DoraCheckHGroup\n");
  }

public:
  DoraClassObject *m_pObject;
  DoraBaseView    *m_pView;
  DoraBaseDialog  *m_pDialog;
  AttrToolView    attr;
  TypeStrButton   itemButton;
  
public:
  void OnCreate(DoraClassObject *pObject, DoraBaseView *pView);
  void OnCreate(DoraClassObject *pObject, DoraBaseDialog *pDialog);
  void DestroyView();
  DoraCentralDocument *GetDocument();
  void setCheckButton();

public:
  void OnDraw(QPainter *p);
  void OnSize(int cx, int cy);

public:
  QRect clientRect;

public:
  void PostMouseMessage(int ctrl, int index);
  void setCheck(const int nID);

};

#endif
