#if !defined(_DORACLOCKVIEW_H)
#define _DORACLOCKVIEW_H

#include <qapplication.h>
#include <qwidget.h>
#include <qevent.h>
#include <qfont.h>
#include <qfontmetrics.h>
#include <qpainter.h>
#include <qcolor.h>
#include <qrect.h>
#include <qfontdialog.h>

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <ctype.h>
#include <typeinfo>
#include <math.h>

#include "Typedef.h"
#include "Dynacolect.h"
#include "DoraClassObject.h"
#include "DoraBaseView.h"

class DoraClockView : public DoraBaseView
{
public:
  struct pointClock {
    int xPos;
    int yPos;
    pointClock(pointClock *x = NULL) {
      xPos = yPos = 0;
    }
    pointClock(const pointClock &x) {
      xPos = x.xPos;
      yPos = x.yPos;
    }
    pointClock &operator=(pointClock x) {
      xPos = x.xPos;
      yPos = x.yPos;
      return *this;
    }
  };
  struct textRect {
    QRect rect;
    textRect(textRect *x = NULL) {
      rect.setX(0);
      rect.setY(0);
      rect.setWidth(0);
      rect.setHeight(0);
    }
    textRect(const textRect &x) {
      rect.setX(x.rect.x());
      rect.setY(x.rect.y());
      rect.setWidth(x.rect.width());
      rect.setHeight(x.rect.height());
    }
    textRect &operator=(textRect x) {
      rect.setX(x.rect.x());
      rect.setY(x.rect.y());
      rect.setWidth(x.rect.width());
      rect.setHeight(x.rect.height());
      return *this;
    }
  };
  typedef DoraArray<textRect>   TypeTextRect;
  typedef DoraArray<pointClock> TypePointClock;
public:
  DoraRuntimeClass *GetRuntimeClass() const {
    return &classDoraClockView;
  }
  static DoraRuntimeClass classDoraClockView;
  static DoraClassObject *CreateView(QWidget *parent);
  static DoraClassObject *CreateDocument();

public:
  DoraClockView(QWidget *parent, const char *name = 0) : DoraBaseView(parent, name) {
    printf("   DoraClockView\n");
    itemPointClock.removeAllElement();
    itemSmallClock.removeAllElement();
    itemHourClock.removeAllElement();
    itemTextRect.removeAllElement();
    killedTimer = false;
  }
  ~DoraClockView() {
    printf("   DoraClockView\n");
  }

private:
  void timerEvent(QTimerEvent *e);
  
public:
  void OnDraw(QPainter *p);
  void OnSize(int cx, int cy);
  void setPixmap();
  void setCPixmap();
  void setSPixmap();
  void updateView();
  void stopTimer();

public:
  void OnCreate(DoraClassObject *pObject, DoraBaseView *pView);
  DoraCentralDocument *GetDocument();

public:
  DoraClassObject     *m_pObject;
  DoraBaseView        *m_pView;
  QPixmap             pixmap;
  int                 timID;
  bool                killedTimer;

public:
  QRect clientRect;
  QRect digRect;

public:
  TypePointClock itemPointClock;
  TypePointClock itemSmallClock;
  TypePointClock itemHourClock;
  TypeTextRect   itemTextRect;
};

#endif
