#if !defined(_DORACOMBOBOX_H)
#define _DORACOMBOBOX_H

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <ctype.h>
#include <typeinfo>

#include <qapplication.h>
#include <qwidget.h>
#include <qevent.h>
#include <qpainter.h>
#include <qrect.h>
#include <qcolor.h>
#include <qfont.h>
#include <qfontmetrics.h>

#include "Typedef.h"
#include "DoraClassObject.h"
#include "DoraBaseView.h"
#include "DoraBaseDialog.h"
#include "DoraScrollView.h"
#include "DoraScrBarButton.h"
#include "DoraStaticCtrl.h"

class DoraComboBox : public DoraBaseView
{
public:
  DoraRuntimeClass *GetRuntimeClass() const {
    return &classDoraComboBox;
  }
  static DoraRuntimeClass classDoraComboBox;
  static DoraClassObject *CreateView(QWidget *parent);
  static DoraClassObject *CreateDocument();

public:
  DoraComboBox(QWidget *parent, const char *name = 0) : DoraBaseView(parent, name) {
    printf("   DoraComboBox\n");
    isExpand = FALSE;
    m_pScrollView = NULL;
    okScrollBar = FALSE;
  }
  ~DoraComboBox() {
    printf("   DoraComboBox\n");
  }

public:
  void OnDraw(QPainter *p);
  void OnSize(int cx, int cy);

public:
  void OnCreate(DoraClassObject *pObject, DoraBaseView *pView);
  void OnCreate(DoraClassObject *pObject, DoraBaseDialog *pDialog);
  DoraCentralDocument *GetDocument();

public:
  void    addItem(Str35 strName, const int index);
  void    setBoxRect(QRect rect);
  void    setDefault(const int index);
  CString getValue();
  void    DestroyView();
  void    showScrollView();
  void    hideScrollView();
  void    UpdateConvChar();

public:
  void PostMouseMessage(int ctrl, int index);

public:
  DoraClassObject  *m_pObject;
  DoraBaseView     *m_pView;
  DoraBaseDialog   *m_pDialog;
  DoraScrollView   *m_pScrollView;
  DoraStaticCtrl   *m_pStaticCtrl;
  DoraScrBarButton *m_pScrBarButton;

public:
  QRect clientRect;
  QRect editRect;
  QRect scrBarButtonRect;
  QRect boxRect;
  bool  isExpand;
  bool  okScrollBar;
  QFont editFont;
  int   maxLen, maxRow;
  int   nID;
  int   nScrollID;

};

#endif
