#include "DoraDialogDoc.h"

DoraRuntimeClass DoraDialogDoc::classDoraDialogDoc={"DoraDialogDoc", NULL, DoraDialogDoc::CreateDocument};

DoraClassObject *DoraDialogDoc::CreateView(QWidget *parent)
{
  return NULL;
}

DoraClassObject *DoraDialogDoc::CreateDocument()
{
  return new DoraDialogDoc();
}

void DoraDialogDoc::initDocument()
{
  Str35 localDir, reklDir, curentDir;
  localDir = "";localDir = "/Calendar";
  fs.setDefaultDir();
  fs.createLocalDir();
  fs.setWorkDir(localDir);

  reklDir = "";reklDir = "/Reklama";
  fs.createDir(reklDir);

  curentDir = "";sprintf(curentDir.p, "%s\0", get_current_dir_name());
  copyReclams(curentDir, reklDir);

  setDefaultReclStr();
}

void DoraDialogDoc::copyReclams(const Str35 curentDir, const Str35 reclDir)
{
  Str35 fileCurent, fileWork, localDir;
  localDir = "";localDir = "/Calendar";
  fileCurent = "";fileCurent = fileCurent + curentDir + "/RECLAMS.DTA";
  fileWork = "";fileWork = fileWork + reclDir + "/RECLAMS.DTA";
  fs.defaultLocalDir = "";
  fs.defaultDir = "";
  if(fs.isFileName(fileCurent)) {
    fs.setDefaultDir();
    fs.setWorkDir(localDir);
    if(!fs.isFileName(fileWork)) {
      fs.defaultLocalDir = "";
      fs.defaultDir = "";
      int rec = 1;
      int maxr = fs.maxRecord(fileCurent);
      if(maxr >= 1) {
	do {
	  DataRecord data;
	  fs.initDataRecord(0, 19, &data);fs.loadRecord(fileCurent, rec, maxr, &data);
	  fs.setDefaultDir();
	  fs.setWorkDir(localDir);
	  int maxw = fs.maxRecord(fileWork);
	  int recw = maxw + 1;
	  fs.saveRecord(fileWork, recw, maxw, data);
	  fs.defaultLocalDir = "";
	  fs.defaultDir = "";
	  rec++;
	} while(rec <= maxr);
      }
    }
  }
  fs.setDefaultDir();
  fs.setWorkDir(localDir);
}

void DoraDialogDoc::setReklString(Str80 str)
{

}

void DoraDialogDoc::saveReklString(DataReclams data, int rec)
{
  Str35 fileName;
  DataRecord data35;
  fileName = "";fileName = fileName + "/Reklama/RECLAMS.DTA";
  int maxr = fs.maxRecord(fileName), maxl = 35, position = 1;
  String str;
  str = "";
  for(int i = 1; i <= 10; i++) {
    str = str + data.pole[i-1];
  }
  fs.initDataRecord(0, 19, &data35);
  data35.Pole[0] = data.langName;
  data35.Pole[1] = data.encodingName;
  data35.Pole[2] = data.prefix;
  int len = strlen(str.p);
  int j = 3;
  do {
    CString s;
    s = "";s = copyStr(s, position, maxl);
    data35.Pole[j] = "";data35.Pole[j] = s.p;
    position += maxl;j++;
  } while(position <= len);
  fs.saveRecord(fileName, rec, maxr, data35);
}

void DoraDialogDoc::loadReklString(DataReclams *data, int rec)
{
  Str35 fileName;
  DataRecord data35;
  fileName = "";fileName = fileName + "/Reklama/RECLAMS.DTA";
  int maxr = fs.maxRecord(fileName), maxl = 50, position = 1;
  fs.initDataRecord(0, 19, &data35);
  fs.loadRecord(fileName, rec, maxr, &data35);
  String str;
  str = "";
  for(int i = 3; i <= 14; i++) {
    str = str + data35.Pole[i];
  }
  data->langName = data35.Pole[0];
  data->encodingName = data35.Pole[1];
  data->prefix = data35.Pole[2];
  int j = 0;
  int len = strlen(str.p);
  do {
    CString s;
    s = "";s = copyStr(str.p, position, maxl);
    data->pole[j] = "";data->pole[j] = s.p;
    position += maxl;j++;
  } while(position <= len);
}

void DoraDialogDoc::saveReklString()
{

}

void DoraDialogDoc::loadReklString()
{
  Str35 fileName;
  fileName = "";fileName = fileName + "/Reklama/RECLAMS.DTA";
  int rec = 1, maxr = fs.maxRecord(fileName);
  if(maxr >= 1) {
    DataRecord data;
    String str;
    do {
      fs.initDataRecord(0, 19, &data);fs.loadRecord(fileName, rec, maxr, &data);
      str = "";
      for(int i = 3; i <= 14; i++) {
	str = str + data.Pole[i].p;
      }
      int maxElement = itemStrReclams.maxElement() + 1;
      strReclams item;
      item.reclStr = "";item.reclStr = str;
      item.langName = "";item.langName = data.Pole[0];
      item.encodingName = "";item.encodingName = data.Pole[1];
      item.prefix = "";item.prefix = data.Pole[2];
      itemStrReclams.setElement(item, maxElement);
      rec++;
    } while(rec <= maxr);
  }
}

int DoraDialogDoc::maxReclams()
{
  Str35 fileName;
  fileName = "";fileName = fileName + "/Reklama/RECLAMS.DTA";
  int maxr = fs.maxRecord(fileName);
  return maxr;
}

int DoraDialogDoc::deleteRecord(const int rec)
{
  Str35 fileName;
  fileName = "";fileName = fileName + "/Reklama/RECLAMS.DTA";
  int maxr = fs.deleteRecord(fileName, rec);
  return maxr;
}

void DoraDialogDoc::setNewConvChar(Str35 encodingName)
{
  CString encoding;
  encoding = "";encoding = encodingName;
  convChar = DoraConvChar(encoding);
}

void DoraDialogDoc::loadLangFile(Str35 langPrefix)
{
  Str35 fileName;
  Str80 str;
  int offset = 0, index = 1;
  fileName = "";fileName = fileName + "/Config/" + langPrefix + "/LANG" + "_BIO";
  printf("loadLangFile -> langPrefix = %s, fileName = %s\n", langPrefix.p, fileName.p);
  if(fs.isFileName(fileName)) {
    itemLangName.removeAllElement();
    bool ok = true;
    int len = 0;
    do {
      strLangName item;
      str = "";str = fs.loadTextString(fileName, offset);
      if(str != "") {
	item.langName = "";item.langName = str.p;
	len = strlen(str.p) + 1;offset += len;
	str = "";str = fs.loadTextString(fileName, offset);
	item.prefix = "";item.prefix = str.p;
	len = strlen(str.p) + 1;offset += len;
	str = "";str = fs.loadTextString(fileName, offset);
	item.encodingName = "";item.encodingName = str.p;
	len = strlen(str.p) + 1;offset += len;
	itemLangName.setElement(item, index);
	index++;
      } else {
	ok = false;
      }
    } while(ok != false);
  }
}

void DoraDialogDoc::reclStrCopyrightBG()
{
  Str80 str[10];
  for(int i = 0; i <= 9; i++) {
    str[i] = "";
  }
  str[0] = "********** (C)   -  , , ";
  str[1] = "   . ";
  str[2] = "  Linux    . ";
  str[3] = " : e-mail: dorasmolyan@yahoo.com, misho1960@yahoo.com, ";
  str[4] = " mick_jobs@yahoo.com, GSM: +359886470299. **********";
  int index = itemStrReclams.maxElement() + 1;
  strReclams item;
  item.langName = "";item.langName = "Bulgaria";
  item.encodingName = "";item.encodingName = "CP 1251";
  item.prefix = "";item.prefix = "BG";
  item.reclStr = "";
  for(int i = 0; i <= 9; i++) {
    if(str[i] != "")
      item.reclStr = item.reclStr + str[i].p;
    else
      break;
  }
  itemStrReclams.setElement(item, index);
}

void DoraDialogDoc::reclStrCopyrightEN()
{
  Str80 str[10];
  for(int i = 0; i <= 9; i++) {
    str[i] = "";
  }
  str[0] = "********** (C) Michael Petrov - Smolian, Bulgaria  ";
  str[1] = "Free software developper. ";
  str[2] = "Developing in Linux application for your computer. ";
  str[3] = "For contacts: e-mail: dorasmolyan@yahoo.com, misho1960@yahoo.com,";
  str[4] = " mick_jobs@yahoo.com, GSM: +359886470299. **********";
  int index = itemStrReclams.maxElement() + 1;
  strReclams item;
  item.langName = "";item.langName = "English";
  item.encodingName = "";item.encodingName = "ISO 8859-1";
  item.prefix = "";item.prefix = "EN";
  item.reclStr = "";
  for(int i = 0; i <= 9; i++) {
    if(str[i] != "")
      item.reclStr = item.reclStr + str[i].p;
    else
      break;
  }
  itemStrReclams.setElement(item, index);
}

void DoraDialogDoc::reclStrCopyrightRU()
{
 Str80 str[10];
  for(int i = 0; i <= 9; i++) {
    str[i] = "";
  }
  str[0] = "********** (C)   - ,   ";
  str[1] = "  . ";
  str[2] = "   Linux,   . ";
  str[3] = " : e-mail: dorasmolyan@yahoo.com, misho1960@yahoo.com,";
  str[4] = " mick_jobs@yahoo.com, GSM: +359886470299. **********";
  int index = itemStrReclams.maxElement() + 1;
  strReclams item;
  item.langName = "";item.langName = "Rusian";
  item.encodingName = "";item.encodingName = "KOI8-R";
  item.prefix = "";item.prefix = "RU";
  item.reclStr = "";
  for(int i = 0; i <= 9; i++) {
    if(str[i] != "")
      item.reclStr = item.reclStr + str[i].p;
    else
      break;
  }
  itemStrReclams.setElement(item, index);
}

void DoraDialogDoc::reclStrCopyrightFR()
{
  Str255 str[10];
  for(int i = 0; i <= 9; i++) {
    str[i] = "";
  }
  str[0] = "********** (C) Michael Petrov - Smolian, Bulgarie  ";
  str[1] = "Developper on prive practique. ";
  str[2] = "Develope on Linux tous pour votre computere. ";
  str[3] = "Pour de contactes: e-mail: dorasmolyan@yahoo.com, misho1960@yahoo.com,";
  str[4] = " mick_jobs@yahoo.com, GSM: +359886470299. **********";
  int index = itemStrReclams.maxElement() + 1;
  strReclams item;
  item.langName = "";item.langName = "Francais";
  item.encodingName = "";item.encodingName = "ISO 8859-1";
  item.prefix = "";item.prefix = "FR";
  item.reclStr = "";
  for(int i = 0; i <= 9; i++) {
    if(str[i] != "")
      item.reclStr = item.reclStr + str[i].p;
    else
      break;
  }
  itemStrReclams.setElement(item, index);
}

void DoraDialogDoc::reclStrSponsoredBG()
{
  Str80 str[10];
  for(int i = 0; i <= 9; i++) {
    str[i] = "";
  }
  str[0] = "**********        \"\"";
  str[1] = " -  , . ";
  str[2] = "  e-mail: theodora1968@yahoo.com, GSM: +359887780640. ";
  str[3] = "**********";
  int index = itemStrReclams.maxElement() + 1;
  strReclams item;
  item.langName = "";item.langName = "Bulgaria";
  item.encodingName = "";item.encodingName = "CP 1251";
  item.prefix = "";item.prefix = "BG";
  item.reclStr = "";
  for(int i = 0; i <= 9; i++) {
    if(str[i] != "")
      item.reclStr = item.reclStr + str[i].p;
    else
      break;
  }
  itemStrReclams.setElement(item, index);
}

void DoraDialogDoc::reclStrSponsoredEN()
{
  Str80 str[10];
  for(int i = 0; i <= 9; i++) {
    str[i] = "";
  }
  str[0] = "********** Sponsored by hair - dresser salon \"THEDY\" ";
  str[1] = " - Smolian, Bulgaria. ";
  str[2] = "For contacts: e-mail: theodora1968@yahoo.com, GSM: +359887780640. ";
  str[3] = "**********";
  int index = itemStrReclams.maxElement() + 1;
  strReclams item;
  item.langName = "";item.langName = "English";
  item.encodingName = "";item.encodingName = "ISO 8859-1";
  item.prefix = "";item.prefix = "EN";
  item.reclStr = "";
  for(int i = 0; i <= 9; i++) {
    if(str[i] != "")
      item.reclStr = item.reclStr + str[i].p;
    else
      break;
  }
  itemStrReclams.setElement(item, index);
}

void DoraDialogDoc::reclStrSponsoredRU()
{
  Str80 str[10];
  for(int i = 0; i <= 9; i++) {
    str[i] = "";
  }
  str[0] = "**********   -  \"\" ";
  str[1] = " - , . ";
  str[2] = " : e-mail: theodora1968@yahoo.com, GSM: +359887780640. ";
  str[3] = "**********";
  int index = itemStrReclams.maxElement() + 1;
  strReclams item;
  item.langName = "";item.langName = "Rusian";
  item.encodingName = "";item.encodingName = "KOI8-R";
  item.prefix = "";item.prefix = "RU";
  item.reclStr = "";
  for(int i = 0; i <= 9; i++) {
    if(str[i] != "")
      item.reclStr = item.reclStr + str[i].p;
    else
      break;
  }
  itemStrReclams.setElement(item, index);
}

void DoraDialogDoc::reclStrSponsoredFR()
{
  Str80 str[10];
  for(int i = 0; i <= 9; i++) {
    str[i] = "";
  }
  str[0] = "********** Sponsorer par salon \"THEDY\" ";
  str[1] = " - Smolian, Bulgarie. ";
  str[2] = "Pour de contactes: e-mail: theodora1968@yahoo.com, GSM: +359887780640. ";
  str[3] = "**********";
  int index = itemStrReclams.maxElement() + 1;
  strReclams item;
  item.langName = "";item.langName = "Francais";
  item.encodingName = "";item.encodingName = "ISO 8859-1";
  item.prefix = "";item.prefix = "FR";
  item.reclStr = "";
  for(int i = 0; i <= 9; i++) {
    if(str[i] != "")
      item.reclStr = item.reclStr + str[i].p;
    else
      break;
  }
  itemStrReclams.setElement(item, index);
}

void DoraDialogDoc::setDefaultReclStr()
{
  itemStrReclams.removeAllElement();
  reclStrCopyrightBG();
  reclStrCopyrightEN();
  reclStrCopyrightFR();
  reclStrCopyrightRU();
  reclStrSponsoredBG();
  reclStrSponsoredEN();
  reclStrSponsoredFR();
  reclStrSponsoredRU();
  loadReklString();
  sortReclams();
  curentReclams = 0;
}

void DoraDialogDoc::sortReclams()
{
  int maxElement = itemStrReclams.maxElement();
  for(int gap = maxElement/2; gap > 0; gap /= 2) {
    for(int i = gap; i < maxElement; i++) {
      for(int j = i - gap; j >= 0; j -= gap) {
	strReclams temp1;
	strReclams temp2;
	if(itemStrReclams[j].prefix <= itemStrReclams[j+gap].prefix)
	  break;
	temp1 = itemStrReclams[j];
	temp2 = itemStrReclams[j + gap];
	itemStrReclams.setElement(temp1, (j + gap) + 1);
	itemStrReclams.setElement(temp2, j + 1);
      }
    }
  }
}

String DoraDialogDoc::getReclString(const int index)
{
  int oldIndex = index;
  int maxElement = itemStrReclams.maxElement();
  String str;
  if(index >= maxElement)
    oldIndex = 1;
  else 
    oldIndex++;
  str = "";str = itemStrReclams[oldIndex-1].reclStr.p;
  encodingName = "";encodingName = itemStrReclams[oldIndex-1].encodingName;
  curentReclams = oldIndex;
  return str;
}

int DoraDialogDoc::locateTextReclams(const Str35 prefix)
{
  Str35 fileName;
  fileName = "";fileName = fileName + "/Reklama/RECLAMS.DTA";
  int maxr = fs.maxRecord(fileName);
  DataRecord data;
  int lrec = -1;
  if(maxr >= 1) {
    int rec = 1;
    do {
      fs.initDataRecord(0, 19, &data);fs.loadRecord(fileName, rec, maxr, &data);
      if(data.Pole[2] == prefix) {
	lrec = rec;
	break;
      }
      rec++;
    } while(rec <= maxr);
  }
  return lrec;
}
