#if !defined(_DORADIALOGDOC_H)
#define _DORADIALOGDOC_H

#include <qwidget.h>
#include <qfont.h>
#include <qfontmetrics.h>

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <ctype.h>
#include <typeinfo>

#include "Typedef.h"
#include "Dynacolect.h"
#include "DoraClassObject.h"
#include "DoraBaseDocument.h"
#include "DoraBaseView.h"
#include "CompareDate.h"
#include "DoraConvChar.h"
#include "DoraFileSystem.h"
#include "AttrDialog.h"

class DoraDialogDoc : public DoraBaseDocument
{
public:
  struct strReclams {
    Str35 langName, encodingName, prefix;
    String reclStr;
    strReclams(strReclams *x = NULL) {
      reclStr = "";
      langName = "";
      encodingName = "";
      prefix = "";
    }
    strReclams(const strReclams &x) {
      reclStr = x.reclStr;
      langName = x.langName;
      encodingName = x.encodingName;
      prefix = x.prefix;
    }
    strReclams &operator=(strReclams x) {
      reclStr = x.reclStr;
      langName = x.langName;
      encodingName = x.encodingName;
      prefix = x.prefix;
      return *this;
    }
  };
  struct strLangName {
    Str35 langName, encodingName, prefix;
    strLangName(strLangName *x = NULL) {
      langName = "";
      encodingName = "";
      prefix = "";
    }
    strLangName(const strLangName &x) {
      langName = x.langName;
      encodingName = x.encodingName;
      prefix = x.prefix;
    }
    strLangName &operator=(strLangName x) {
      langName = x.langName;
      encodingName = x.encodingName;
      prefix = x.prefix;
      return *this;
    }
  };
  typedef DoraArray<strReclams>  TypeStrReclams;
  typedef DoraArray<strLangName> TypeLangName;
public:
  DoraRuntimeClass *GetRuntimeClass() const {
    return &classDoraDialogDoc;
  }
  static DoraRuntimeClass classDoraDialogDoc;
  static DoraClassObject *CreateView(QWidget *parent);
  static DoraClassObject *CreateDocument();

public:
  DoraDialogDoc() : DoraBaseDocument() {
    printf("   DoraDialogDoc\n");
    reklStr = "";
    itemStrReclams.removeAllElement();
    itemLangName.removeAllElement();
    curentReclams = 0;
  }
  ~DoraDialogDoc() {
    printf("   DoraDialogDoc\n");
  }

public:
  void initDocument();

public:
  DoraFileSystem fs;
  AttrDialog     attr;
  DoraConvChar   convChar;

public:
  void setReklString(Str80 str);
  void saveReklString(DataReclams data, int rec);
  void loadReklString(DataReclams *data, int rec);
  void saveReklString();
  void loadReklString();
  void setNewConvChar(Str35 encodingName);
  void loadLangFile(Str35 langPrefix);
  void setDefaultReclStr();
  int  maxReclams();
  int  deleteRecord(const int rec);
  void copyReclams(const Str35 curentDir, const Str35 reclDir);
  int  locateTextReclams(const Str35 prefix);

public:
  String         reklStr;
  CString        reklFile;
  int            curentLang;
  int            curentEncoding;
  int            curentReclams;
  TypeStrReclams itemStrReclams;
  TypeLangName   itemLangName;
  String         getReclString(const int index);
  Str35          encodingName;

private:
  void reclStrCopyrightBG();
  void reclStrCopyrightEN();
  void reclStrCopyrightRU();
  void reclStrCopyrightFR();

private:
  void reclStrSponsoredBG();
  void reclStrSponsoredEN();
  void reclStrSponsoredRU();
  void reclStrSponsoredFR();

private:
  void sortReclams();

};

#endif
