#if !defined(_DORAEDITBOX_H)
#define _DORAEDITBOX_H

#include <qapplication.h>
#include <qwidget.h>
#include <qevent.h>
#include <qfont.h>
#include <qfontmetrics.h>
#include <qpainter.h>
#include <qcolor.h>
#include <qrect.h>
#include <qfontdialog.h>

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <ctype.h>
#include <typeinfo>

#include "Typedef.h"
#include "Dynacolect.h"
#include "DoraClassObject.h"
#include "DoraBaseView.h"
#include "DoraBaseDialog.h"
#include "DoraEditString.h"
#include "AttrDialog.h"

class DoraEditBox : public DoraBaseView
{
public:
  struct strItemEdit {
    DoraEditString *editString;
    Str35 caption;
    int xPos, yPos, len;

    strItemEdit(strItemEdit *x = NULL) {
      editString = NULL;
      caption = "";
      xPos = yPos = len = 0;
    }
    strItemEdit(const strItemEdit &x) {
      editString = x.editString;
      caption = x.caption;
      xPos = x.xPos;
      yPos = x.yPos;
      len = x.len;
    }
    strItemEdit &operator=(strItemEdit x) {
      editString = x.editString;
      caption = x.caption;
      xPos = x.xPos;
      yPos = x.yPos;
      len = x.len;
      return *this;
    }
  };
  typedef DoraArray<strItemEdit> TypeEditItem;

public:
  DoraRuntimeClass *GetClassObject() const {
    return &classDoraEditBox;
  }
  static DoraRuntimeClass classDoraEditBox;
  static DoraClassObject *CreateView(QWidget *parent);
  static DoraClassObject *CreateDocument();

public:
  DoraEditBox(QWidget *parent, const char *name = 0) : DoraBaseView(parent, name) {
    printf("   DoraEditBox\n");
    editItem.removeAllElement();
    prefix = "";
  }
  ~DoraEditBox() {
    printf("   DoraEditBox\n");
  }

public:
  void OnCreate(DoraClassObject *pObject, DoraBaseView *pView);
  void OnCreate(DoraClassObject *pObject, DoraBaseDialog *pDialog);

public:
  void OnDraw(QPainter *p);
  void OnSize(int cx, int cy);

public:
  DoraClassObject *m_pObject;
  DoraBaseDialog  *m_pDialog;
  DoraBaseView    *m_pView;
  AttrDialog      attr;
  int             nID;
  Str35           prefix;

public:
  QRect        clientRect;
  TypeEditItem editItem;

public:
  void setDialogAttr(const int index);
  void setData(DataRecord data, const int focusIndex);
  void getData(DataRecord *data);
  int  getNextNotReadonly(const int index);
  int  getPrevNotReadonly(const int index);
  void UpdateConvChar();

public:
  void PostEditMessage(const int indexEdit);
  void PostKeyPressMessage(int index, int keyCode);
  void PostKeyStatMessage(int stat, int keyCode);

public:
  Str80 getString(const int index);
  void  setString(const int index, const Str80 str);

};

#endif
