#include "DoraCentralDocument.h"
#include "DoraCentralView.h"
#include "DoraMainFrame.h"
#include "DoraDialogDoc.h"
#include "DoraEditDialog.h"

DoraRuntimeClass DoraEditDialog::classDoraEditDialog={"DoraEditDialog", DoraEditDialog::CreateView, NULL};

DoraClassObject *DoraEditDialog::CreateView(QWidget *parent)
{
  return new DoraEditDialog(parent);
}

DoraClassObject *DoraEditDialog::CreateDocument()
{
  return NULL;
}

void DoraEditDialog::OnCreate(DoraClassObject *pObject, DoraBaseView *pView)
{
  m_pObject = pObject;
  m_pView   = pView;
  m_pDialog = NULL;

  DoraMainFrame *m_pMainFrame = dynamic_cast<DoraMainFrame *>(m_pObject);
  DoraCentralDocument *pCDoc = m_pMainFrame->GetDocument();
  DoraCentralView *m_pCentralView = m_pMainFrame->GetCentralView();
  DoraDialogDoc *pDoc = m_pCentralView->GetDialogDoc();

  DoraRuntimeClass *runtimeEditBox = RUNTIME_CLASS(DoraEditBox);
  DoraClassObject *objectEditBox = runtimeEditBox->CreateView(this);
  m_pEditBox = dynamic_cast<DoraEditBox *>(objectEditBox);
  m_pEditBox->selectNewFont(font);
  m_pEditBox->convChar = convChar;
  m_pEditBox->OnCreate(m_pObject, this);
  m_pEditBox->hide();
  m_pEditBox->setDialogAttr(1);

  DoraRuntimeClass *runtimeToolView = RUNTIME_CLASS(DoraToolView);
  DoraClassObject *objectToolView = runtimeToolView->CreateView(this);
  m_pToolView = dynamic_cast<DoraToolView *>(objectToolView);
  m_pToolView->selectNewFont(pCDoc->getDefaultFont(4));
  m_pToolView->convChar = convChar;
  m_pToolView->wButton = 28;
  m_pToolView->hButton = 28;
  m_pToolView->OnCreate(m_pObject, this);
  m_pToolView->setToolButton(3);
  m_pToolView->caption = pCDoc->capMenagment;
  m_pToolView->nID = ID_TOOLVIEW_DIALOG;
  m_pToolView->hide();

  DoraRuntimeClass *runtimePushButton1 = RUNTIME_CLASS(DoraPushButton);
  DoraClassObject *objectPushButton1 = runtimePushButton1->CreateView(this);
  m_pPushButton1 = dynamic_cast<DoraPushButton *>(objectPushButton1);
  m_pPushButton1->selectNewFont(font);
  m_pPushButton1->convChar = convChar;
  m_pPushButton1->OnCreate(m_pObject, this);
  m_pPushButton1->ctrlID = DM_PUSHBUTTON;
  m_pPushButton1->nID = ID_PUSHBUTTON_OK;
  m_pPushButton1->hide();

  DoraRuntimeClass *runtimePushButton2 = RUNTIME_CLASS(DoraPushButton);
  DoraClassObject *objectPushButton2 = runtimePushButton2->CreateView(this);
  m_pPushButton2 = dynamic_cast<DoraPushButton *>(objectPushButton2);
  m_pPushButton2->selectNewFont(font);
  m_pPushButton2->convChar = convChar;
  m_pPushButton2->OnCreate(m_pObject, this);
  m_pPushButton2->ctrlID = DM_PUSHBUTTON;
  m_pPushButton2->nID = ID_PUSHBUTTON_SAVE;
  m_pPushButton2->hide();

  DoraRuntimeClass *runtimeComboBoxE = RUNTIME_CLASS(DoraComboBox);
  DoraClassObject *objectComboBoxE = runtimeComboBoxE->CreateView(this);
  m_pComboBoxE = dynamic_cast<DoraComboBox *>(objectComboBoxE);
  m_pComboBoxE->selectNewFont(pCDoc->getDefaultFont(5));
  m_pComboBoxE->convChar = convChar;
  m_pComboBoxE->nID = ID_COMBOBOX_DIALOG;
  m_pComboBoxE->nScrollID = ID_SCROLLBOX_ENCODING;
  m_pComboBoxE->maxRow = 12;
  m_pComboBoxE->maxLen = 15;
  m_pComboBoxE->okScrollBar = true;
  m_pComboBoxE->OnCreate(m_pObject, this);
  m_pComboBoxE->hide();

  DoraRuntimeClass *runtimeComboBoxL = RUNTIME_CLASS(DoraComboBox);
  DoraClassObject *objectComboBoxL = runtimeComboBoxL->CreateView(this);
  m_pComboBoxL = dynamic_cast<DoraComboBox *>(objectComboBoxL);
  m_pComboBoxL->selectNewFont(pCDoc->getDefaultFont(5));
  m_pComboBoxL->convChar = convChar;
  m_pComboBoxL->nID = ID_COMBOBOX_DIALOG;
  m_pComboBoxL->nScrollID = ID_SCROLLBOX_LANG;
  m_pComboBoxL->maxRow = 4;
  m_pComboBoxL->maxLen = 15;
  m_pComboBoxL->okScrollBar = true;
  m_pComboBoxL->OnCreate(m_pObject, this);
  m_pComboBoxL->hide();

  pDoc->curentEncoding = pCDoc->curentEncoding;
  pDoc->curentLang = pCDoc->curentLang;
  Str35 prefix;
  prefix = "";prefix = pCDoc->itemLangName[pCDoc->curentLang - 1].prefix;
  pDoc->loadLangFile(prefix);
  rec = 1;
  setDataReclams();
}

void DoraEditDialog::OnCreate(DoraClassObject *pObject, DoraBaseDialog *pDialog)
{
  m_pObject = pObject;
  m_pView   = NULL;
  m_pDialog = pDialog;

  DoraMainFrame *m_pMainFrame = dynamic_cast<DoraMainFrame *>(m_pObject);
  DoraCentralDocument *pCDoc = m_pMainFrame->GetDocument();
  DoraCentralView *m_pCentralView = m_pMainFrame->GetCentralView();
  DoraDialogDoc *pDoc = m_pCentralView->GetDialogDoc();

  DoraRuntimeClass *runtimeEditBox = RUNTIME_CLASS(DoraEditBox);
  DoraClassObject *objectEditBox = runtimeEditBox->CreateView(this);
  m_pEditBox = dynamic_cast<DoraEditBox *>(objectEditBox);
  m_pEditBox->selectNewFont(font);
  m_pEditBox->convChar = convChar;
  m_pEditBox->OnCreate(m_pObject, this);
  m_pEditBox->hide();
  m_pEditBox->setDialogAttr(1);

  DoraRuntimeClass *runtimeToolView = RUNTIME_CLASS(DoraToolView);
  DoraClassObject *objectToolView = runtimeToolView->CreateView(this);
  m_pToolView = dynamic_cast<DoraToolView *>(objectToolView);
  m_pToolView->selectNewFont(pCDoc->getDefaultFont(4));
  m_pToolView->convChar = convChar;
  m_pToolView->wButton = 28;
  m_pToolView->hButton = 28;
  m_pToolView->setToolButton(3);
  m_pToolView->OnCreate(m_pObject, this);
  m_pToolView->caption = "";
  m_pToolView->nID = ID_TOOLVIEW_DIALOG;
  m_pToolView->hide();

  DoraRuntimeClass *runtimePushButton1 = RUNTIME_CLASS(DoraPushButton);
  DoraClassObject *objectPushButton1 = runtimePushButton1->CreateView(this);
  m_pPushButton1 = dynamic_cast<DoraPushButton *>(objectPushButton1);
  m_pPushButton1->selectNewFont(font);
  m_pPushButton1->convChar = convChar;
  m_pPushButton1->OnCreate(m_pObject, this);
  m_pPushButton1->ctrlID = DM_PUSHBUTTON;
  m_pPushButton1->nID = ID_PUSHBUTTON_OK;
  m_pPushButton1->hide();

  DoraRuntimeClass *runtimePushButton2 = RUNTIME_CLASS(DoraPushButton);
  DoraClassObject *objectPushButton2 = runtimePushButton2->CreateView(this);
  m_pPushButton2 = dynamic_cast<DoraPushButton *>(objectPushButton2);
  m_pPushButton2->selectNewFont(font);
  m_pPushButton2->convChar = convChar;
  m_pPushButton2->OnCreate(m_pObject, this);
  m_pPushButton2->ctrlID = DM_PUSHBUTTON;
  m_pPushButton2->nID = ID_PUSHBUTTON_SAVE;
  m_pPushButton2->hide();

  DoraRuntimeClass *runtimeComboBoxE = RUNTIME_CLASS(DoraComboBox);
  DoraClassObject *objectComboBoxE = runtimeComboBoxE->CreateView(this);
  m_pComboBoxE = dynamic_cast<DoraComboBox *>(objectComboBoxE);
  m_pComboBoxE->hide();

  DoraRuntimeClass *runtimeComboBoxL = RUNTIME_CLASS(DoraComboBox);
  DoraClassObject *objectComboBoxL = runtimeComboBoxL->CreateView(this);
  m_pComboBoxL = dynamic_cast<DoraComboBox *>(objectComboBoxL);
  m_pComboBoxL->hide();
}

void DoraEditDialog::OnDraw(QPainter *p)
{
  DrawRamkaEdit(p);

  QFontMetrics fm(font);
  QSize sizeFont = fm.size(SingleLine, "H", 1);
  int wf = sizeFont.width();
  int hf = fm.height() - fm.descent();
  
  if(enablePushButton1)
    m_pPushButton1->show();
  if(enablePushButton2)
    m_pPushButton2->show();

  if(caption != "") {
    int x = titleRect.x() + 2;
    int y = (titleRect.y() + 2) + hf;
    int len = strlen(caption.p);
    for(int i = 0; i <= len - 1; i++ ) {
      char *s = new char[2];
      s[0] = '\0';
      sprintf(s, "%c\0", caption.p[i]);
      QString qStr;
      qStr = "";qStr = convChar.getCharCodec(s);
      p->setPen(QPen(QColor(255, 255, 255), 1));
      p->setBrush(QBrush(QColor(0, 0, 255)));
      p->drawText(x, y, qStr);
      x += wf;
      delete s;
    }
  }
  m_pEditBox->show();
  m_pToolView->show();
  m_pComboBoxE->show();
  m_pComboBoxL->show();
}

void DoraEditDialog::OnSize(int cx, int cy)
{
  SizeRamkaEdit(cx, cy);

  QFontMetrics fm(font);
  QSize sizeFont = fm.size(SingleLine, "H", 1);
  int wf = sizeFont.width();
  int hf = fm.height() - fm.descent();

  int wPushButton = (9 * wf) + 4;
  int hPushButton = hf + 6;
  int xPushButton = cx - (wPushButton + 5);
  int yPushButton = (cy - hPushButton) - 4;
  QRect pushRect1;
  pushRect1.setX(xPushButton);
  pushRect1.setY(yPushButton);
  pushRect1.setWidth(wPushButton);
  pushRect1.setHeight(hPushButton);
  m_pPushButton1->setGeometry(pushRect1);
  m_pPushButton1->hide();

  QRect pushRect2;
  xPushButton = 4;
  pushRect2.setX(xPushButton);
  pushRect2.setY(yPushButton);
  pushRect2.setWidth(wPushButton);
  pushRect2.setHeight(hPushButton);
  m_pPushButton2->setGeometry(pushRect2);
  m_pPushButton2->hide();
  
  m_pEditBox->setGeometry(boxRect);
  m_pEditBox->hide();

  int xToolView = clientRect.x() + boxRect.width() + 3;
  int yToolView = boxRect.y() - 30;
  int wToolView = (clientRect.width() - 6) - (boxRect.width() - 2);
  int hToolView = boxRect.height() + 30;
  QRect toolRect;
  toolRect.setX(xToolView);
  toolRect.setY(yToolView);
  toolRect.setWidth(wToolView);
  toolRect.setHeight(hToolView);
  m_pToolView->setGeometry(toolRect);
  m_pToolView->hide();

  DoraCentralDocument *pCDoc = GetCentralDocument();
  QFont comboFont;
  comboFont = pCDoc->getDefaultFont(5);
  QFontMetrics fmCombo(comboFont);
  QSize sizeFCombo = fmCombo.size(SingleLine, "H", 1);
  int hfc = fmCombo.height() - fmCombo.descent();
  int wfc = sizeFCombo.width();
  int xCombo = menuRect.x() + 5;
  int yCombo = menuRect.y() + 5;
  int hCombo = (fmCombo.height() - fmCombo.descent()) + 4;
  int wCombo = (15 * wfc) + hCombo + 8;
  QRect comboRectE;
  comboRectE.setX(xCombo);
  comboRectE.setY(yCombo);
  comboRectE.setWidth(wCombo);
  comboRectE.setHeight(hCombo);
  m_pComboBoxE->setGeometry(comboRectE);
  int xBoxComboE = comboRectE.x();
  int yBoxComboE = comboRectE.y() + comboRectE.height() + 1;
  int wBoxComboE = comboRectE.width();
  int hBoxComboE = hCombo * 12;
  QRect boxRectE;
  boxRectE.setX(xBoxComboE);
  boxRectE.setY(yBoxComboE);
  boxRectE.setWidth(wBoxComboE);
  boxRectE.setHeight(hBoxComboE - 6);
  m_pComboBoxE->setBoxRect(boxRectE);
  m_pComboBoxE->hide();

  xCombo += (wCombo + 4);
  QRect comboRectL;
  comboRectL.setX(xCombo);
  comboRectL.setY(yCombo);
  comboRectL.setWidth(wCombo);
  comboRectL.setHeight(hCombo);
  m_pComboBoxL->setGeometry(comboRectL);
  int xBoxComboL = comboRectL.x();
  int yBoxComboL = comboRectL.y() + comboRectL.height() + 1;
  int wBoxComboL = comboRectL.width();
  int hBoxComboL = hCombo * 4;
  QRect boxRectL;
  boxRectL.setX(xBoxComboL);
  boxRectL.setY(yBoxComboL);
  boxRectL.setWidth(wBoxComboL);
  boxRectL.setHeight(hBoxComboL - 2);
  m_pComboBoxL->setBoxRect(boxRectL);
  m_pComboBoxL->hide();
  
}

void DoraEditDialog::PostMouseMessage(int ctrl, int index)
{
  DoraMainFrame *m_pMainFrame = dynamic_cast<DoraMainFrame *>(m_pObject);
  DoraCentralView *m_pCentralView = m_pMainFrame->GetCentralView();
  DoraCentralDocument *pCDoc = m_pMainFrame->GetDocument();
  DoraDialogDoc *pDoc = m_pCentralView->GetDialogDoc();
  int nID;

  switch(ctrl) {
  case DM_PUSHBUTTON :
    actionPushButton(index);
    break;
  case ID_TOOLVIEW_DIALOG :
    nID = index;
    pushedToolButton(nID);
    break;
  default:
    if(ctrl == ID_COMBOBOX_DIALOG) {
      if(index == ID_SCROLLBOX_ENCODING) {
	int maxElement = pCDoc->itemEncodingName.maxElement();
	for(int i = 0; i <= maxElement - 1; i++) {
	  m_pComboBoxE->addItem(pCDoc->itemEncodingName[i].name, i + 1);
	}
        m_pComboBoxE->setDefault(pDoc->curentEncoding);
	m_pComboBoxE->m_pScrollView->m_pScrollBox->setRectElement(pDoc->curentEncoding);
      }
      if(index == ID_SCROLLBOX_LANG) {
	int maxElement = pDoc->itemLangName.maxElement();
	for(int i = 0; i <= maxElement - 1; i++) {
	  m_pComboBoxL->addItem(pDoc->itemLangName[i].langName, i + 1);
	}
	m_pComboBoxL->setDefault(pDoc->curentLang);
	m_pComboBoxL->m_pStaticCtrl->setCaption(pDoc->itemLangName[pDoc->curentLang-1].langName);
	m_pComboBoxL->m_pStaticCtrl->repaint(false);
	m_pComboBoxL->m_pScrollView->m_pScrollBox->setRectElement(pDoc->curentLang);
      }
    }
    if(ctrl == ID_SCROLLBOX_ENCODING) {
      Str35 encodingName;
      encodingName = "";encodingName = pCDoc->itemEncodingName[index-1].name;
      pDoc->setNewConvChar(encodingName);
      convChar = pDoc->convChar;
      pDoc->curentEncoding = index;
      UpdateConvChar();
    }
    if(ctrl == ID_SCROLLBOX_LANG) {
      pDoc->curentLang = index;
      Str35 langName, encodingName, prefix;
      prefix = "";prefix = pDoc->itemLangName[index - 1].prefix;
      pDoc->loadLangFile(prefix);
      langName = "";langName = pDoc->itemLangName[index - 1].langName;
      int eIndex = getIndexEncoding(prefix);
      pDoc->curentEncoding = eIndex;
      encodingName = "";encodingName = pCDoc->itemEncodingName[eIndex - 1].name;
      pDoc->setNewConvChar(encodingName);
      convChar = pDoc->convChar;
      m_pComboBoxE->convChar = convChar;
      m_pComboBoxE->UpdateConvChar();
      m_pComboBoxE->setDefault(pDoc->curentEncoding);
      m_pComboBoxL->convChar = convChar;
      m_pComboBoxL->UpdateConvChar();
      m_pComboBoxL->setDefault(pDoc->curentLang);
      m_pComboBoxL->m_pStaticCtrl->setCaption(langName);
      m_pComboBoxL->m_pStaticCtrl->repaint(false);
      UpdateConvChar();
      searchReclam(prefix);
    }
  }
}

void DoraEditDialog::setAttrDialog(const int index)
{
  if(m_pEditBox != NULL) {
    m_pEditBox->setDialogAttr(index);
    nID = m_pEditBox->nID;
  }
}

void DoraEditDialog::DestroyDialog()
{
  if(m_pEditBox != NULL) {
    m_pEditBox->DestroyView();
    m_pEditBox->hide();
    delete m_pEditBox;
    m_pEditBox = NULL;
  }
  if(m_pToolView != NULL) {
    m_pToolView->DestroyView();
    m_pToolView->hide();
    delete m_pToolView;
    m_pToolView = NULL;
  }
}

void DoraEditDialog::PostKeyPressMessage(int index, int keyCode)
{
  switch(keyCode) {
  case Key_F1       :
    OnNewRecord();
    break;
  case Key_F2       :
    OnSaveRecord();
    break;
  case Key_F3       :
    OnDeleteRecord();
    break;
  case Key_F4 :
    OnEditRecord();
    break;
  case Key_PageUp   :
    OnPrevRecord();
    break;
  case Key_PageDown :
    OnNextRecord();
    break;
  case Key_Return   :
  case Key_Enter    :
    OnSaveNextRecord();
    break;
  }
}

void DoraEditDialog::PostKeyStatMessage(int stat, int keyCode)
{
  switch(keyCode) {
  case Key_PageUp   :
    OnFirstRecord();
    break;
  case Key_PageDown :
    OnLastRecord();
    break;
  }
}

void DoraEditDialog::OnNewRecord()
{
  for(int i = 0; i <= 9; i++) {
    Str80 str;
    str = "";data.pole[i] = "";
    m_pEditBox->setString(i + 1, str);
  }
  rec = maxr + 1;
}

void DoraEditDialog::OnSaveRecord()
{
  DoraMainFrame *m_pMainFrame = dynamic_cast<DoraMainFrame *>(m_pObject);
  DoraCentralView *m_pCentralView = m_pMainFrame->GetCentralView();
  DoraDialogDoc *pDoc = m_pCentralView->GetDialogDoc();
  data.langName = "";data.encodingName = "";data.prefix = "";
  for(int i = 0; i <= 9; i++)
    data.pole[i] = "";
  CString str;
  str = "";str = m_pComboBoxE->getValue();
  data.encodingName = str.p;
  data.langName = pDoc->itemLangName[pDoc->curentLang-1].langName;
  data.prefix = pDoc->itemLangName[pDoc->curentLang-1].prefix;
  for(int i = 0; i <= 9; i++) {
    Str80 s;
    s = "";s = m_pEditBox->getString(i + 1);
    data.pole[i] = "";data.pole[i] = s.p;
  }
  pDoc->saveReklString(data, rec);
  maxr = pDoc->maxReclams();
}

void DoraEditDialog::OnDeleteRecord()
{
  DoraMainFrame *m_pMainFrame = dynamic_cast<DoraMainFrame *>(m_pObject);
  DoraCentralView *m_pCentralView = m_pMainFrame->GetCentralView();
  DoraDialogDoc *pDoc = m_pCentralView->GetDialogDoc();
  if((rec >= 1) && (rec <= maxr)) {
    maxr = pDoc->deleteRecord(rec);
    if((rec >= maxr) && (maxr >= 1)) {
      rec = maxr;
    }
    if((rec >= 1) && (rec <= maxr)) {
      setDataReclams();
    }
    if(maxr <= 0) {
      for(int i = 0; i <= 9; i++) {
	Str80 str;
	str = "";data.pole[i] = "";
	m_pEditBox->setString(i + 1, str);
      }
      m_pEditBox->editItem[0].editString->setOnFocus();
      m_pEditBox->editItem[0].editString->setFocus();
      rec = maxr + 1;
    }
  }
}

void DoraEditDialog::OnNextRecord()
{
  DoraMainFrame *m_pMainFrame = dynamic_cast<DoraMainFrame *>(m_pObject);
  DoraCentralView *m_pCentralView = m_pMainFrame->GetCentralView();
  DoraDialogDoc *pDoc = m_pCentralView->GetDialogDoc();
  rec++;
  if(rec >= maxr)
    rec = maxr;
  setDataReclams();
}

void DoraEditDialog::OnPrevRecord()
{
  DoraMainFrame *m_pMainFrame = dynamic_cast<DoraMainFrame *>(m_pObject);
  DoraCentralView *m_pCentralView = m_pMainFrame->GetCentralView();
  DoraDialogDoc *pDoc = m_pCentralView->GetDialogDoc();
  rec--;
  if(rec <= 1)
    rec = 1;
  setDataReclams();
}

void DoraEditDialog::OnFirstRecord()
{
  DoraMainFrame *m_pMainFrame = dynamic_cast<DoraMainFrame *>(m_pObject);
  DoraCentralView *m_pCentralView = m_pMainFrame->GetCentralView();
  DoraDialogDoc *pDoc = m_pCentralView->GetDialogDoc();
  rec = 1;
  setDataReclams();
}

void DoraEditDialog::OnLastRecord()
{
  DoraMainFrame *m_pMainFrame = dynamic_cast<DoraMainFrame *>(m_pObject);
  DoraCentralView *m_pCentralView = m_pMainFrame->GetCentralView();
  DoraDialogDoc *pDoc = m_pCentralView->GetDialogDoc();
  rec = maxr;
  setDataReclams();
}

void DoraEditDialog::OnSaveNextRecord()
{

}

void DoraEditDialog::getData(DataRecord *data)
{
  m_pEditBox->getData(data);
}

void DoraEditDialog::setData(DataRecord data, const int focusIndex)
{
  m_pEditBox->setData(data, focusIndex);
}

void DoraEditDialog::pushedToolButton(const int index)
{
  switch(index) {
  case ID_TOOLBUTTON_NEW :
    OnNewRecord();
    break;
  case ID_TOOLBUTTON_SAVE :
    OnSaveRecord();
    break;
  case ID_TOOLBUTTON_DELETE :
    OnDeleteRecord();
    break;
  case ID_TOOLBUTTON_SEARCH :
    break;
  case ID_TOOLBUTTON_PREV :
    OnPrevRecord();
    break;
  case ID_TOOLBUTTON_NEXT :
    OnNextRecord();
    break;
  case ID_TOOLBUTTON_RECTOP :
    OnFirstRecord();
    break;
  case ID_TOOLBUTTON_RECEND :
    OnLastRecord();
    break;
  }
}


void DoraEditDialog::actionPushButton(const int nID)
{
  DoraMainFrame *m_pMainFrame = dynamic_cast<DoraMainFrame *>(m_pObject);
  DoraCentralView *m_pCentralView = m_pMainFrame->GetCentralView();

  switch(nID) {
  case ID_PUSHBUTTON_OK :
    m_pMainFrame->PostMouseMessage(ID_PUSHBUTTON_OK, nID);
    break;
  case ID_PUSHBUTTON_SAVE :
    break;
  }
}

void DoraEditDialog::enablePushButton(const int buttonID, const bool enable)
{
  DoraMainFrame *m_pMainFrame = dynamic_cast<DoraMainFrame *>(m_pObject);
  DoraCentralDocument *pDoc = m_pMainFrame->GetDocument();
  Str35 cap1, cap2;
  cap1 = "";cap2 = "";
  if(m_pPushButton1->nID == buttonID) {
    cap1 = pDoc->capClose;;
    m_pPushButton1->setCaption(cap1, cap2);
    enablePushButton1 = enable;
  }
  if(m_pPushButton2->nID == buttonID) {
    enablePushButton2 = enable;
  }
}

DoraDialogDoc *DoraEditDialog::GetDialogDoc()
{
  DoraMainFrame *m_pMainFrame = dynamic_cast<DoraMainFrame *>(m_pObject);
  DoraCentralView *m_pCentralView = m_pMainFrame->GetCentralView();
  DoraDialogDoc *pDoc = m_pCentralView->GetDialogDoc();;
  return pDoc;
}

DoraCentralDocument *DoraEditDialog::GetCentralDocument()
{
  DoraMainFrame *m_pMainFrame = dynamic_cast<DoraMainFrame *>(m_pObject);
  DoraCentralDocument *pDoc = m_pMainFrame->GetDocument();

  return pDoc;
}

void DoraEditDialog::getReklString()
{
  Str80 str;
  int maxElement = m_pEditBox->attr.getMaxItem();
  DoraDialogDoc *pDoc = GetDialogDoc();
  for(int i = 0; i <= maxElement - 1; i++) {
    str = "";
    str = m_pEditBox->getString(i + 1);
    pDoc->setReklString(str);
  }
  pDoc->saveReklString();
}

void DoraEditDialog::setReklString()
{
  String str;
  DoraDialogDoc *pDoc = GetDialogDoc();
  str = "";
  pDoc->loadReklString();
  str = pDoc->reklStr;
}

void DoraEditDialog::OnEditRecord()
{
  setReklString();
}

void DoraEditDialog::UpdateConvChar()
{
  DoraCentralDocument *pCDoc = GetCentralDocument();
  DoraDialogDoc *pDoc = GetDialogDoc();
  convChar = pDoc->convChar;
  if(m_pEditBox != NULL) {
    m_pEditBox->convChar = convChar;
    m_pEditBox->UpdateConvChar();
  }
}

int DoraEditDialog::getIndexEncoding(Str35 langName)
{
  DoraCentralDocument *pCDoc = GetCentralDocument();
  DoraDialogDoc *pDoc = GetDialogDoc();
  int maxElement = pDoc->itemLangName.maxElement();
  int lIndex = 1;
  Str35 encoding;
  encoding = "";
  for(int i = 0; i <= maxElement - 1; i++) {
    if(langName == pDoc->itemLangName[i].prefix) {
      encoding = "";encoding = pDoc->itemLangName[i].encodingName;
      pDoc->curentLang = i + 1;
      break;
    }
  }
  if(encoding != "") {
    int maxEncoding = pCDoc->itemEncodingName.maxElement();
    for(int i = 0; i <= maxEncoding - 1; i++) {
      if(encoding == pCDoc->itemEncodingName[i].name) {
	lIndex = i + 1;
	break;
      }
    }
  }
  return lIndex;
}

void DoraEditDialog::setDataReclams()
{
  DoraMainFrame *m_pMainFrame = dynamic_cast<DoraMainFrame *>(m_pObject);
  DoraCentralView *m_pCentralView = m_pMainFrame->GetCentralView();
  DoraDialogDoc *pDoc = m_pCentralView->GetDialogDoc();
  maxr = pDoc->maxReclams();
  if(maxr >= 1) {
    if((rec >= 1) && (rec <= maxr)) {
      pDoc->loadReklString(&data, rec);
      Str35 langName, encodingName, prefix;
      int nEncoding, nLang;
      langName = "";langName = data.langName;
      encodingName = "";encodingName = data.encodingName;
      prefix = "";prefix = data.prefix;
      printf("prefix = %s\n", prefix.p);
      pDoc->loadLangFile(prefix);
      nEncoding = getIndexEncoding(prefix);
      nLang = pDoc->curentLang;
      printf("nLang = %4d, nEncoding = %4d, lang = %s, encoding = %s\n", nLang, nEncoding, langName.p, encodingName.p);
      DoraConvChar rEncoding = DoraConvChar(encodingName.p);
      m_pEditBox->convChar = rEncoding;
      m_pEditBox->UpdateConvChar();
      for(int i = 0; i <= 9; i++) {
	Str80 s;
	s = "";s = data.pole[i].p;
	m_pEditBox->setString(i + 1, s);
      }
      langName = "";langName = pDoc->itemLangName[nLang - 1].langName;
      m_pEditBox->editItem[0].editString->setOnFocus();
      m_pEditBox->editItem[0].editString->setFocus();
      m_pComboBoxE->convChar = rEncoding;
      m_pComboBoxE->UpdateConvChar();
      m_pComboBoxE->setDefault(nEncoding);
      m_pComboBoxL->convChar = rEncoding;
      m_pComboBoxL->UpdateConvChar();
      m_pComboBoxL->setDefault(nLang);
      m_pComboBoxL->m_pStaticCtrl->setCaption(langName);
      m_pComboBoxL->m_pStaticCtrl->repaint(false);
    }
  }  
}

void DoraEditDialog::searchReclam(const Str35 prefix)
{
  DoraMainFrame *m_pMainFrame = dynamic_cast<DoraMainFrame *>(m_pObject);
  DoraCentralView *m_pCentralView = m_pMainFrame->GetCentralView();
  DoraDialogDoc *pDoc = m_pCentralView->GetDialogDoc();
  int oldrec = rec;
  rec = pDoc->locateTextReclams(prefix);
  if(rec >= 1) {
    setDataReclams();
  } else {
    rec = oldrec;
  }
}
