#if !defined(_DORAEDITDIALOG_H)
#define _DORAEDITDIALOG_H

#include <qapplication.h>
#include <qwidget.h>
#include <qevent.h>
#include <qfont.h>
#include <qfontmetrics.h>
#include <qpainter.h>
#include <qcolor.h>
#include <qrect.h>
#include <qfontdialog.h>

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <ctype.h>
#include <typeinfo>

#include "Typedef.h"
#include "Dynacolect.h"
#include "DoraClassObject.h"
#include "DoraBaseView.h"
#include "DoraBaseDialog.h"
#include "DoraEditBox.h"
#include "DoraToolButton.h"
#include "DoraPushButton.h"
#include "DoraToolView.h"
#include "DoraComboBox.h"

class DoraEditDialog : public DoraBaseDialog
{
public:
  DoraRuntimeClass *GetClassObject() const {
    return &classDoraEditDialog;
  }
  static DoraRuntimeClass classDoraEditDialog;
  static DoraClassObject *CreateView(QWidget *parent);
  static DoraClassObject *CreateDocument();

public:
  DoraEditDialog(QWidget *parent, const char *name = 0) : DoraBaseDialog(parent, name) {
    printf("   DoraEditDialog\n");
    m_pEditBox = NULL;
    caption = "";
    enablePushButton1 = true;
    enablePushButton2 = true;
  }
  ~DoraEditDialog() {
    printf("   DoraEditDialog\n");
  }

public:
  void OnCreate(DoraClassObject *pObject, DoraBaseView *pView);
  void OnCreate(DoraClassObject *pObject, DoraBaseDialog *pDialog);

public:
  DoraClassObject *m_pObject;
  DoraBaseView    *m_pView;
  DoraBaseDialog  *m_pDialog;
  DoraEditBox     *m_pEditBox;
  DoraPushButton  *m_pPushButton1;
  DoraPushButton  *m_pPushButton2;
  DoraToolView    *m_pToolView;
  DoraComboBox    *m_pComboBoxL;
  DoraComboBox    *m_pComboBoxE;
  DataReclams     data;

public:
  void OnDraw(QPainter *p);
  void OnSize(int cx, int cy);

public:
  CString       caption;
  int           nID, rec, maxr;
  bool          enablePushButton1, enablePushButton2;

public:
  void setAttrDialog(const int index);
  void DestroyDialog();
  void getData(DataRecord *data);
  void setData(DataRecord data, const int focusIndex);
  void pushedToolButton(const int index);
  void actionPushButton(const int nID);
  void enablePushButton(const int buttonID, const bool enable);
  DoraDialogDoc *GetDialogDoc();
  DoraCentralDocument *GetCentralDocument();

public:
  void getReklString();
  void setReklString();

public:
  void PostMouseMessage(int ctrl, int index);
  void PostKeyPressMessage(int index, int keyCode);
  void PostKeyStatMessage(int stat, int keyCode);

public:
  void OnNewRecord();
  void OnSaveRecord();
  void OnDeleteRecord();
  void OnNextRecord();
  void OnPrevRecord();
  void OnFirstRecord();
  void OnLastRecord();
  void OnSaveNextRecord();
  void OnEditRecord();

public:
  void UpdateConvChar();
  int  getIndexEncoding(Str35 langName);
  void setDataReclams();
  void searchReclam(const Str35 prefix);

};

#endif
