#include "DoraEditString.h"

DoraRuntimeClass DoraEditString::classDoraEditString = {"DoraEditString", DoraEditString::CreateView, NULL};

DoraClassObject *DoraEditString::CreateView(QWidget *parent) 
{
  return new DoraEditString(parent);
}

DoraClassObject *DoraEditString::CreateDocument()
{
  return NULL;
}

void DoraEditString::OnDraw(QPainter *p)
{
  p->setFont(font);
  setPixmap();
  int x1 = clientRect.x();
  int y1 = clientRect.y();
  int x2 = x1 + clientRect.width();
  int y2 = y1 + clientRect.height();
  bitBlt(this, x1, y1, &pixmap, x1, y1, x2 - x1, y2 - y1);
}

void DoraEditString::OnSize(int cx, int cy)
{
  clientRect.setX(0);
  clientRect.setY(0);
  clientRect.setWidth(cx);
  clientRect.setHeight(cy);
}

void DoraEditString::OnCreate(DoraClassObject *pObject, DoraBaseView *pView, const int Index)
{
  m_pView   = pView;
  m_pObject = pObject;
  indexEdit = Index;
  strValue = "";
  xPos = 1;
  cursorPos = 0;
  BlinkOn = false;
  insertOn = true;
  isFocus = false;
  setFont(font);
}

void DoraEditString::KeyChar(int keyCode)
{
  CString ss;
  ss = "";ss = strValue;
  char *s;
  s = new char[2];
  s[0] ='\0';
  int len = (int)(strlen(ss.p));
  
  switch(keyCode) {
    case Key_End       :
      cursorPos = len;
      xPos = len + 1;
      break;
    case Key_Home      :
      cursorPos = 0;
      xPos = 1;
      break;
    case Key_Up        :
      KeyMessage(keyCode);
      break;
    case Key_Down      :
      KeyMessage(keyCode);
      break;
    case Key_Left      :
      if(xPos > 1) {
	cursorPos--;
	xPos--;
      }
      break;
    case Key_Right     :
      if(xPos <= len) {
	cursorPos++;
	xPos++;
      }
      break;
    case Key_Return    :
    case Key_Enter     :
    case Key_PageUp    :
    case Key_PageDown  :
    case Key_F1        :
    case Key_F2        :
    case Key_F3        :
    case Key_F4        :
    case Key_F5        :
    case Key_F6        :
    case Key_F7        :
    case Key_F8        :
    case Key_F9        :
    case Key_F10       :
      KeyMessage(keyCode);
      ss = "";ss = strValue;
      break;
    case Key_Tab       :
      printf("DoraEditString ->    Tab\n");
      KeyMessage(keyCode);
      break;
    case Key_Delete    :
      deleteStr(ss, xPos, 1);
      len = (int)(strlen(ss.p));
      break;
    case Key_Insert    :
      insertOn = !insertOn;
      break;
    case Key_Backspace :
      if(xPos >= 2) {
	deleteStr(ss, xPos - 1, 1);
	cursorPos--;
	xPos--;
      }
      break;
    default :
      if((keyCode >= 32) && (keyCode <= 255) && (keyCode != 127)) {
	sprintf(s, "%c\0", keyCode);
	Str80 s1;
	s1 = "";s1 = s;
	if((strchr(legal.p, s1.p[0]) != 0) || (legal == "")) {
	  if(xPos <= lenStr) {
	    if(insertOn == TRUE)
	      insertStr(ss, s1.p, xPos);
	    else {
	      deleteStr(ss, xPos, 1);
	      insertStr(ss, s1.p, xPos);
	    }
	    cursorPos++;
	    xPos++;
	  }
	}
      }
  }
  delete s;
  strValue = "";strValue = ss.p;
  repaint();
}

void DoraEditString::KeyStat(int stat, int keyCode)
{
  printf("stat = %4d, key = %5d\n", stat, keyCode);
  if(m_pView != NULL)
    m_pView->PostKeyStatMessage(stat, keyCode);
}

void DoraEditString::MouseLeftButton(int xLocPos, int yLocPos, int xPosGlb, int yPosGlb)
{
  if(strValue != "") {
    int len = (int)(strlen(strValue.p));
    QFontMetrics fm(font);
    QSize sizeFont = fm.size(SingleLine, "H", 1);
    int w = sizeFont.width();
    int x = 0;
    cursorPos = 0;
    for(int i = 0; i <= len - 1; i++) {
      int x1 = x * w;
      int x2 = x1 + w;
      if((xLocPos >= x1) && (xLocPos <= x2)) {
	break;
      } else {
	cursorPos++;
      }
      x++;
    }
  } else {
    cursorPos = 0;
  }
  if(m_pView != NULL)
    m_pView->PostEditMessage(indexEdit);
  setOnFocus();
}

void DoraEditString::setOnFocus()
{
  printf("DoraEditString -> setOnFocus -> index = %4d\n", indexEdit);
  xPos = cursorPos + 1;
  isFocus = true;
  repaint(false);
}

void DoraEditString::setNoFocus()
{
  printf("DoraEditString ->setNoFocus -> index = %4d\n", indexEdit);
  xPos = cursorPos + 1;
  isFocus = false;
  repaint(false);
}

void DoraEditString::KeyMessage(int keyCode)
{
  if(m_pView != NULL)
    m_pView->PostKeyPressMessage(indexEdit, keyCode);
}

void DoraEditString::setEditString(Str35 value)
{
  strValue = "";strValue = value.p;
  cursorPos = 0;
  int len = (int)strlen(strValue.p);
  for(int i = 0; i <= len - 1; i++)
    cursorPos++;
  xPos = cursorPos + 1;
}
/*
Str35 DoraEditString::getEditString()
{
  Str35 value;
  value = "";value = copyStr(strValue, 1, lenStr);
  return value;
}
*/
void DoraEditString::setEditString(CString value)
{
  strValue = "";strValue = value.p;
  cursorPos = 0;
  int len = (int)strlen(strValue.p);
  for(int i = 0; i <= len - 1; i++)
    cursorPos++;
}

CString DoraEditString::getEditString()
{
  CString value;
  value = "";value = copyStr(strValue, 1, lenStr);
  return value;
}

void DoraEditString::setPixmap()
{
  QPainter p;
  pixmap.resize(clientRect.width(), clientRect.height());
  pixmap.fill(QColor(255, 255, 255));
  p.begin(&pixmap);
  {
    p.setFont(font);
    p.setPen(QPen(QColor(0, 0, 0), 1));
    if(status == ID_STATUS_NOTREADONLY)
      p.setBrush(QBrush(QColor(255, 255, 255)));
    if(status == ID_STATUS_READONLY)
      p.setBrush(QBrush(QColor(192, 192, 192)));
    p.drawRect(clientRect);
    QFontMetrics fm(font);
    QSize sFont = fm.size(SingleLine, "H", 1);
    int h = (fm.height() - fm.descent()) + 1;
    int w = sFont.width();
    int x = 1;
    int y = 1;
    if(strValue != "") {
      int len = (int)(strlen(strValue.p));
      for(int i = 0; i <= len - 1; i++) {
	QRect rect;
	rect.setX(x);
	rect.setY(y);
	rect.setWidth(w);
	rect.setHeight(h);
	char *s;
	s = new char[2];
	s[0] = '\0';
	sprintf(s, "%c\0", strValue.p[i]);
	QString qStr;
	qStr = "";qStr = convChar.getCharCodec(s);
	if(status == ID_STATUS_NOTREADONLY) {
	  p.setPen(QPen(QColor(255, 255, 255), 1));
	  p.setBrush(QBrush(QColor(255, 255, 255)));
	}
	if(status == ID_STATUS_READONLY) {
	  p.setPen(QPen(QColor(192, 192, 192), 1));
	  p.setBrush(QBrush(QColor(192, 192, 192)));
	}
	p.drawRect(rect);
	p.setPen(QPen(QColor(0, 0, 0), 1));
	p.drawText(rect, Qt::AlignCenter, qStr);
	x += w;
	delete s;
      }
    }
    x = 1;y = 2;
    printf("cursorPos = %4d, xPos = %4d\n", cursorPos, xPos);
    QRect cursorRect;
    int xCur = x + ((xPos - 1) * w);
    int yCur = y;
    int wCur = w;
    int hCur = h;
    cursorRect.setX(xCur);
    cursorRect.setY(yCur);
    cursorRect.setWidth(w);
    cursorRect.setHeight(h);
    if((isFocus) && (status == ID_STATUS_NOTREADONLY)) {
      p.setPen(QPen(QColor(0, 0, 0), 1));
      p.setBrush(QBrush(QColor(0, 0, 0)));
      p.drawRect(cursorRect);
      int len = (int)(strlen(strValue.p));
      if((cursorPos >= 0) && (cursorPos <= len - 1)) {
	p.setPen(QPen(QColor(255, 255, 255), 1));
	CString ss;
	ss = "";ss = copyStr(strValue, cursorPos + 1, 1);
	printf("strValue = %s, ss = %s\n", strValue.p, ss.p);
	QString qStr;
	qStr = "";qStr = convChar.getCharCodec(ss);
	p.drawText(cursorRect, Qt::AlignCenter, qStr);
      }
    }
  }
  p.end();
}
