#if !defined(_DORAEDITSTRING_H)
#define _DORAEDITSTRING_H

#include <qapplication.h>
#include <qevent.h>
#include <qwidget.h>
#include <qpixmap.h>
#include <qcolor.h>
#include <qbrush.h>
#include <qrect.h>
#include <qpainter.h>
#include <qtimer.h>
#include <qfont.h>
#include <qfontmetrics.h>

#include "Typedef.h"
#include "Dynacolect.h"
#include "DoraClassObject.h"
#include "DoraBaseCtrl.h"
#include "DoraBaseView.h"

class DoraEditString : public DoraBaseCtrl
{
public:
  DoraRuntimeClass *GetRuntimeClass() const {
    return &classDoraEditString;
  }
  static DoraRuntimeClass classDoraEditString;
  static DoraClassObject *CreateView(QWidget *parent);
  static DoraClassObject *CreateDocument();

public:
  DoraEditString(QWidget *parent, const char *name = 0) : DoraBaseCtrl(parent, name) {
    printf("   DoraEditString\n");
    m_pView   = NULL;
    m_pObject = NULL;
    strValue = "";
    xPos = 1;
    cursorPos = 0;
    BlinkOn = false;
    insertOn = true;
    isFocus = false;
    status = ID_STATUS_NOTREADONLY;
  }

  ~DoraEditString() {
    printf("   DoraEditString\n");
  }

public:
  void OnDraw(QPainter *p);
  void OnSize(int cx, int cy);
  void setOnFocus();
  void setNoFocus();
  void MouseLeftButton(int xLocPos, int yLocPos, int xPosGlb, int yPosGlb);
  
public:
  void  OnCreate(DoraClassObject *pObject, DoraBaseView *pView, const int Index);

public:
  DoraBaseView    *m_pView;
  DoraClassObject *m_pObject;

public:
  int     indexEdit;
  int     lenStr;
  Str35   legal;
  Str80   strValue;
  QRect   clientRect;
  QRect   bRect;
  int     xPos;
  bool    BlinkOn;
  bool    insertOn;
  bool    isFocus;
  int     cursorPos;
  int     status;
  QPixmap pixmap;

public:
  void    KeyChar(int keyCode);
  void    KeyStat(int stat, int keyCode);
  void    KeyMessage(int keyCode);
  void    setEditString(Str35 value);
  void    setEditString(CString value);
  // Str35   getEditString();
  CString getEditString();

public:
  void setPixmap();

};

#endif









