#include "DoraFileSystem.h"

void DoraFileSystem::saveRecord(Str35 fileName, int rec, int rmax, DataRecord Data)
{
  long lrec = (rec - 1) * sizeRecord;
  int  file;
  CString nameFile;
  nameFile = "";nameFile = nameFile + defaultLocalDir + fileName;
  if(access(nameFile.p, 0) == -1)
  {
    file = open(nameFile.p, O_CREAT | O_RDWR, S_IREAD | S_IWRITE | S_IRUSR | S_IWUSR | S_IRGRP | S_IROTH | S_IWOTH);
    write(file, &Data, sizeRecord);
    close(file);
  } else {
    if(rec > rmax) {
      file = open(nameFile.p, O_APPEND | O_RDWR,S_IREAD | S_IWRITE | S_IRUSR | S_IWUSR | S_IRGRP | S_IROTH | S_IWOTH);
      write(file, &Data, sizeRecord);
      close(file);
    }
    if(rec <= rmax) {
      file = open(nameFile.p, O_RDWR, S_IREAD | S_IWRITE | S_IRUSR | S_IWUSR | S_IRGRP | S_IROTH | S_IWOTH);
      lseek(file, lrec, SEEK_SET);
      write(file, &Data, sizeRecord);
      close(file);
    }
  }
}

void DoraFileSystem::loadRecord(Str35 fileName, int rec, int rmax, DataRecord *Data)
{
  long lrec = (rec - 1) * sizeRecord;
  int  file;
  CString nameFile;
  nameFile = "";nameFile =  nameFile + defaultLocalDir + fileName;
  if((access(nameFile.p, 0) != -1) && (rec <= rmax))
  {
    file = open(nameFile.p, O_RDONLY, S_IREAD | S_IRUSR | S_IRGRP | S_IROTH);
    lseek(file, lrec, SEEK_SET);
    read(file, Data, sizeRecord);
    close(file);
  }
}

int DoraFileSystem::maxRecord(Str35 fileName)
{
  int maxRec;
  struct stat st;
  CString nameFile;
  nameFile = "";nameFile = nameFile+defaultLocalDir+fileName;

  if(access(nameFile.p, 0) == -1)
    maxRec = 0;
  if(access(nameFile.p, 0) != -1)
  {
    stat(nameFile.p, &st);
    maxRec = (int)(st.st_size/sizeRecord);
  }
  
  return maxRec;
}

void DoraFileSystem::createDir(Str35 dirName)
{
  CString nameDir;
  nameDir = "";
  nameDir = nameDir+defaultLocalDir + dirName;
  if(access(defaultLocalDir.p, 0) == -1) {
    mkdir(defaultLocalDir.p, S_IREAD | S_IWRITE | S_IRWXU | S_IRWXG | S_IRWXO);
  }
  if(access(nameDir.p, 0) == -1) {
    mkdir(nameDir.p, S_IREAD | S_IWRITE | S_IRWXU | S_IRWXG | S_IRWXO);
  }
}

void DoraFileSystem::createLocalDir()
{
  if(access(defaultLocalDir.p, 0) == -1) {
    mkdir(defaultLocalDir.p, S_IREAD | S_IWRITE | S_IRWXU | S_IRWXG | S_IRWXO);
  }
}

bool DoraFileSystem::isFileName(Str35 FileName)
{
  bool ok;
  CString nameFile;
  nameFile = "";
  nameFile = nameFile+defaultLocalDir +  FileName;
  if(access(nameFile.p, 0) == -1)
    ok = FALSE;
  else
    ok = TRUE;
  
  return ok;
}

bool DoraFileSystem::isDirName(Str35 dirName)
{
  bool ok;
  CString name;
  name = "";name = name + defaultLocalDir + dirName;
  if(access(name.p, 0) == -1)
    ok = false;
  else
    ok = true;
  return ok;
}

void DoraFileSystem::initDataRecord(const int imin, const int imax, DataRecord *Data)
{
  for(int i = imin; i <= imax; i++) {
    Data->Pole[i] = "";
  }
}

int DoraFileSystem::deleteRecord(Str35 fileName, int rec)
{
  Str35 nameFile, nameFileBak;
  nameFile = "";nameFile = fileName;
  int maxrec = maxRecord(fileName);
  int p = pos(nameFile, ".");
  nameFileBak = "";nameFileBak = nameFileBak+copyStr(nameFile, 1, p)+".BAK";
  DataRecord data;
  int imin = 0;
  int imax = 19;
  int r = 1;
  int r1 = 1;
  int maxr = 0;
  do {
    initDataRecord(imin, imax, &data);loadRecord(fileName, r, maxrec, &data);
    if(r != rec) {
      saveRecord(nameFileBak, r1, maxr, data);
      r1++;maxr++;
    }
    r++;
  } while(r <= maxrec);
  if(maxr >= 1) {
    deleteFile(fileName);
    renameFile(nameFileBak, fileName);
  }
  if(maxr <= 0) {
    maxr = 0;
    deleteFile(fileName);
  }
  return maxr;
}

void DoraFileSystem::deleteFile(Str35 fileName)
{
  CString nameFile;
  nameFile = "";nameFile =  nameFile+defaultLocalDir +  fileName;
  unlink(nameFile.p);
}

void DoraFileSystem::renameFile(Str35 fileNameOld, Str35 fileNameNew)
{
  CString oldFile, newFile;
  oldFile = "";oldFile =  oldFile + defaultLocalDir +  fileNameOld;
  newFile = "";newFile =  newFile + defaultLocalDir +  fileNameNew;

  rename(oldFile.p, newFile.p);
}

int DoraFileSystem::locateSinglRecord(Str35 fileName, Str35 cmdStr, int index)
{
  int maxrec = maxRecord(fileName);
  int lrec = -1;
  if(maxrec >= 1) {
    int rec = 1;
    DataRecord data;
    do {
      initDataRecord(0, 19, &data);loadRecord(fileName, rec, maxrec, &data);
      CString str1, str2;
      str1 = "";str1 = copyStr(data.Pole[index-1], 1, strlen(cmdStr.p));
      str2 = "";str2 = cmdStr;
      if(str1 == str2) {
	lrec = rec;
	break;
      }
      rec++;
    } while(rec <= maxrec);
  }
  return lrec;
}

int DoraFileSystem::locateOtherRecord(Str35 fileName, Str35 cmdStr, int index, int oldRec)
{
  int maxrec = maxRecord(fileName);
  int lrec = -1;
  if(maxrec >= 1) {
    if((oldRec >= 1) && (oldRec <= maxrec)) {
      int rec = oldRec;
      DataRecord data;
      do {
	initDataRecord(1, 19, &data);loadRecord(fileName, rec, maxrec, &data);
	CString str1, str2;
	str1 = "";str1 = copyStr(data.Pole[index-1], 1, strlen(cmdStr.p));
	str2 = "";str2 = cmdStr;
	if(str1 == str2) {
	  lrec = rec;
	  break;
	}
	rec++;
      } while(rec <= maxrec);
    }
  }
  return lrec;
}

int DoraFileSystem::locateSDateRecord(Str35 fileName, Str35 cmdStr, int index)
{
  int maxrec = maxRecord(fileName);
  int lrec = -1;
  if(maxrec >= 1) {
    int rec = 1;
    DataRecord data;
    CompareDate d1(cmdStr);
    do {
      initDataRecord(0, 19, &data);loadRecord(fileName, rec, maxrec, &data);
      CompareDate d2(data.Pole[index-1]);
      if(d2 == d1) {
	lrec = rec;
	break;
      }
      rec++;
    } while(rec <= maxrec);
  }
  return lrec;
}

int DoraFileSystem::locateODateRecord(Str35 fileName, Str35 cmdStr, int index, int oldRec)
{
  int maxrec = maxRecord(fileName);
  int lrec = -1;
  if(maxrec >= 1) {
    if((oldRec >= 1) && (oldRec <= maxrec)) {
      int rec = oldRec;
      DataRecord data;
      CompareDate d1(cmdStr);
      do {
	initDataRecord(0, 19, &data);loadRecord(fileName, rec, maxrec, &data);
	CompareDate d2(data.Pole[index-1]);
	if(d2 == d1) {
	  lrec = rec;
	  break;
	}
	rec++;
      } while(rec <= maxrec);
    }
  }
  return lrec;
}

void DoraFileSystem::setDefaultDir()
{
  uid_t me;
  struct passwd *my_passwd;
  CString workDir;

  me = getuid();
  my_passwd = getpwuid(me);
  workDir = "";workDir = my_passwd->pw_dir;
  defaultLocalDir = "";
  defaultLocalDir = defaultLocalDir + workDir;
  defaultDir = "";defaultDir = defaultDir + workDir;
}

void DoraFileSystem::setWorkDir(Str35 workDir)
{
  createDir(workDir);
  CString nameDir;
  nameDir = "";nameDir = nameDir + defaultDir + workDir;
  defaultLocalDir = "";defaultLocalDir = nameDir;
}

void DoraFileSystem::saveTextString(Str35 fileName, Str80 str)
{
  CString nameFile;
  nameFile = "";nameFile = nameFile + defaultLocalDir + fileName;
  FILE *fp;
  fp = fopen(nameFile.p, "a+");
  fputs(str.p, fp);
  fclose(fp);
}

Str80 DoraFileSystem::loadTextString(Str35 fileName, int offset)
{
  Str80 str;
  CString nameFile;
  int maxSize;
  struct stat st;
  nameFile = "";nameFile = nameFile + defaultLocalDir + fileName;
  str = "";
  if(access(nameFile.p, 0) != -1) {
    stat(nameFile.p, &st);
    maxSize = st.st_size;
    if(offset < maxSize) {
      FILE *fp;
      fp = fopen(nameFile.p, "r+");
      if(fseek(fp, offset, SEEK_SET) != EOF) {
	bool ok = true;
	do {
	  char *s = new char[2];
	  s[0] = '\0';
	  s[0] = fgetc(fp);
	  if((s[0] != '\0') && (s[0] != '\n')) {
	    s[1] = '\0';
	    str = str + s;
	  } else {
	    ok = false;
	  }
	  delete s;
	} while(ok != false);
      }
      fclose(fp);
    } else {
      str = "";
    }
  }
  return str;
}
