#if !defined(_DORAFILESYSTEM_H)
#define _DORAFILESYSTEM_H

#include <qwidget.h>

#include <grp.h>
#include <pwd.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <ctype.h>
#include <fcntl.h>
#include <typeinfo>
#include <sys/types.h>
#include <sys/stat.h>

#include "Typedef.h"
#include "Dynacolect.h"
#include "DoraClassObject.h"
#include "CompareDate.h"

class DoraFileSystem
{
public:
  DoraFileSystem() {
    printf("   DoraFileSystem\n");
    DataRecord Data;
    sizeRecord = sizeof(Data.RecNo) + sizeof(Data.DelNo) + (20 * sizeof(Data.Pole[0]));
    localDir = "";
    subDir = "";
    defaultLocalDir = "";
    defaultDir = "";
  }

  ~DoraFileSystem() {
    printf("   DoraFileSystem\n");
  }

public:
  int  maxRecord(Str35 fileName);
  void saveRecord(Str35 fileName, int rec, int rmax, DataRecord Data);
  void loadRecord(Str35 fileName, int rec, int rmax, DataRecord *Data);
  int  deleteRecord(Str35 fileName, int rec); 
  void createDir(Str35 dirName);
  void createLocalDir();
  bool isFileName(Str35 fileName);
  bool isDirName(Str35 dirName);
  void initDataRecord(const int imin, const int imax, DataRecord *Data);
  
public:
  void renameFile(Str35 fileNameOld, Str35 fileNameNew);
  void deleteFile(Str35 fileName);

public:
  void setDefaultDir();
  void setWorkDir(Str35 workDir);

public:
  int locateSinglRecord(Str35 fileName, Str35 cmdStr, int index);
  int locateOtherRecord(Str35 fileName, Str35 cmdStr, int index, int oldRec);
  int locateSDateRecord(Str35 fileName, Str35 cmdStr, int index);
  int locateODateRecord(Str35 fileName, Str35 cmdStr, int index, int oldRec);

public:
  bool   indexRecord;
  size_t sizeRecord;

public:
  Str35 localDir;
  Str35 subDir;

public:
  CString defaultLocalDir;
  CString defaultDir;

public:
  void saveTextString(Str35 fileName, Str80 str);
  Str80 loadTextString(Str35 fileName, int offset);


};

#endif


