#if !defined(_DORAGLOBMENUVIEW_H)
#define _DORAGLOBMENUVIEW_H

#include <qapplication.h>
#include <qwidget.h>
#include <qevent.h>
#include <qfont.h>
#include <qfontmetrics.h>
#include <qpainter.h>
#include <qcolor.h>
#include <qrect.h>
#include <qfontdialog.h>

#include "Typedef.h"
#include "Dynacolect.h"
#include "DoraFileSystem.h"
#include "DoraClassObject.h"
#include "DoraBaseView.h"
#include "DoraComboBox.h"
#include "DoraBaseDocument.h"
#include "DoraPopupMenu.h"
#include "DoraMenuButton.h"
#include "AttrMenu.h"

class DoraGlobMenuView : public DoraBaseView
{
public:
  struct strItem {
    DoraMenuButton *itemButton;
    int            nID;
    int            xPos;
    strItem(strItem *x = NULL) {
      itemButton = NULL;
      nID        = 0;
      xPos       = 0;
    }
    strItem(const strItem &x) {
      itemButton = x.itemButton;
      nID = x.nID;
      xPos = x.xPos;
    }
    strItem &operator=(strItem x) {
      itemButton = x.itemButton;
      nID = x.nID;
      xPos = x.xPos;
      return *this;
    }
  };
  typedef DoraArray<strItem> TypeStrItem;

public:
  DoraRuntimeClass *GetRuntimeClass() const {
    return &classDoraGlobMenuView;
  }
  static DoraRuntimeClass classDoraGlobMenuView;
  static DoraClassObject *CreateView(QWidget *parent);
  static DoraClassObject *CreateDocument();

public:
  DoraGlobMenuView(QWidget *parent, const char *name = 0) : DoraBaseView(parent, name) {
    printf("   DoraGlobMenuView\n");
    itemMenu.removeAllElement();
    m_pPopupMenu = NULL;
    m_pComboBoxE = NULL;
    m_pComboBoxL = NULL;
    oldIndex = 1;
    ctrlID = ID_SIGNAL_OTHERSIGNAL;
    isExpand = false;
  }
  ~DoraGlobMenuView() {
    printf("   DoraGlobMenuView\n");
  }

public:
  void OnDraw(QPainter *p);
  void OnSize(int cx, int cy);

public:
  void OnCreate(DoraClassObject *pObject);
  DoraCentralDocument *GetDocument();

public:
  QRect clientRect;
  int   oldIndex;
  QFont comboFont;
  
public:
  DoraClassObject *m_pObject;
  TypeStrItem     itemMenu;
  DoraPopupMenu   *m_pPopupMenu;
  DoraComboBox    *m_pComboBoxE;
  DoraComboBox    *m_pComboBoxL;
  AttrMenu        attr;
  int             ctrlID;
  bool            isExpand;

public:
  void setGlobalMenu();
  void setPopupMenu(const int index);

public:
  void PostMouseMove(int index);
  void PostMouseMessage(int ctrl, int index);
  void OnFocus();
  void MouseMove();
  void PostMouseClick(int index);

public:
  void setNewLang(Str35 langPrefix);

};

#endif

