#include "DoraHScrollBar.h"

DoraRuntimeClass DoraHScrollBar::classDoraHScrollBar = {"DoraHScrollBar", DoraHScrollBar::CreateView, NULL};

DoraClassObject *DoraHScrollBar::CreateView(QWidget *parent)
{
  return new DoraHScrollBar(parent);
}

DoraClassObject *DoraHScrollBar::CreateDocument()
{
  return NULL;
}

void DoraHScrollBar::OnDraw(QPainter *p)
{
  p->setPen(QColor(0, 0, 0));
  p->drawRect(clientRect);
  m_pButtonLeft->show();
  m_pButtonRight1->show();
  m_pButtonRight2->show();
}

void DoraHScrollBar::OnSize(int cx, int cy)
{
  clientRect.setX(0);
  clientRect.setY(0);
  clientRect.setWidth(cx);
  clientRect.setHeight(cy);

  QRect rect;
  rect.setX(0);
  rect.setY(0);
  rect.setWidth(cy);
  rect.setHeight(cy);
  m_pButtonLeft->setGeometry(rect);
  m_pButtonLeft->hide();

  rect.setX(cx - cy);
  rect.setY(0);
  rect.setWidth(cy);
  rect.setHeight(cy);
  m_pButtonRight1->setGeometry(rect);
  m_pButtonRight1->hide();

  rect.setX((cx - (2 * cy)) - 1);
  rect.setY(0);
  rect.setWidth(cy);
  rect.setHeight(cy);
  m_pButtonRight2->setGeometry(rect);
  m_pButtonRight2->hide();


}

void DoraHScrollBar::OnCreate(DoraClassObject *pObject, DoraBaseView *pView)
{
  m_pObject = pObject;
  m_pView   = pView;

  DoraRuntimeClass *runtimeButtonLeft = RUNTIME_CLASS(DoraScrBarButton);
  DoraClassObject  *objectButtonLeft  = runtimeButtonLeft->CreateView(this);
  m_pButtonLeft = dynamic_cast<DoraScrBarButton *>(objectButtonLeft);
  m_pButtonLeft->OnCreate(m_pObject, this, ID_SCROLLBARBUTTON_LEFT);
  m_pButtonLeft->hide();

  DoraRuntimeClass *runtimeButtonRight1 = RUNTIME_CLASS(DoraScrBarButton);
  DoraClassObject  *objectButtonRight1  = runtimeButtonRight1->CreateView(this);
  m_pButtonRight1 = dynamic_cast<DoraScrBarButton *>(objectButtonRight1);
  m_pButtonRight1->OnCreate(m_pObject, this, ID_SCROLLBARBUTTON_RIGHT);
  m_pButtonRight1->hide();

  DoraRuntimeClass *runtimeButtonRight2 = RUNTIME_CLASS(DoraScrBarButton);
  DoraClassObject  *objectButtonRight2  = runtimeButtonRight2->CreateView(this);
  m_pButtonRight2 = dynamic_cast<DoraScrBarButton *>(objectButtonRight2);
  m_pButtonRight2->OnCreate(m_pObject, this, ID_SCROLLBARBUTTON_LEFT);
  m_pButtonRight2->hide();

}

void DoraHScrollBar::PostMouseMessage(int ctrl, int index)
{
  if(m_pView != NULL) {
    switch(ctrl) {
    case POST_SCROLLBARBUTTON_LEFT :
      printf("DoraVScrollBar -> PostMouseMessage ->  \n");
      break;
    case POST_SCROLLBARBUTTON_RIGHT :
      printf("DoraVScrollBar -> PostMouseMessage ->  \n");
      break;
    }
    m_pView->PostMouseMessage(ctrl, index);
  }
}

  


