#if !defined(_DORAHSCROLLBAR_H)
#define _DORAHSCROLLBAR_H

#include <qapplication.h>
#include <qwidget.h>
#include <qevent.h>
#include <qrect.h>
#include <qcolor.h>
#include <qbrush.h>
#include <qfont.h>
#include <qfontmetrics.h>
#include <qpainter.h>

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <ctype.h>
#include <typeinfo>

#include "Typedef.h"
#include "Dynacolect.h"
#include "DoraClassObject.h"
#include "DoraBaseCtrl.h"
#include "DoraBaseView.h"
#include "DoraScrBarButton.h"

class DoraHScrollBar : public DoraBaseView
{
public:
  DoraRuntimeClass *GetClassObject() const {
    return &classDoraHScrollBar;
  }

  static DoraRuntimeClass classDoraHScrollBar;
  static DoraClassObject *CreateView(QWidget *parent);
  static DoraClassObject *CreateDocument();

public:
  DoraHScrollBar(QWidget *parent, const char *name = 0) : DoraBaseView(parent, name) {
    printf("   DoraHScrollBar\n");
  }

  ~DoraHScrollBar() {
    printf("   DoraHScrollBar\n");
  }

public:
  void OnDraw(QPainter *p);
  void OnSize(int cx, int cy);

public:
  void OnCreate(DoraClassObject *pObject, DoraBaseView *pView);
  void PostMouseMessage(int ctrl, int index);

public:  
  QRect clientRect;

public:
  DoraClassObject *m_pObject;
  DoraBaseView    *m_pView;

public:
  DoraScrBarButton *m_pButtonLeft;
  DoraScrBarButton *m_pButtonRight1;
  DoraScrBarButton *m_pButtonRight2;

};

#endif

