#if !defined(_DORAINFOGROUP_H)
#define _DORAINFOGROUP_H

#include <qapplication.h>
#include <qwidget.h>
#include <qevent.h>
#include <qfont.h>
#include <qfontmetrics.h>
#include <qpainter.h>
#include <qcolor.h>
#include <qrect.h>
#include <qfontdialog.h>

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <ctype.h>
#include <typeinfo>

#include "Typedef.h"
#include "Dynacolect.h"
#include "DoraClassObject.h"
#include "DoraBaseView.h"
#include "DoraPushButton.h"
#include "DoraStaticCtrl.h"

class DoraInfoGroup : public DoraBaseView
{
public:
  struct strRect {
    QRect rect;
    strRect(strRect *x = NULL) {
      rect.setX(0);
      rect.setY(0);
      rect.setWidth(0);
      rect.setHeight(0);
    }
    strRect(const strRect &x) {
      rect.setX(x.rect.x());
      rect.setY(x.rect.y());
      rect.setWidth(x.rect.width());
      rect.setHeight(x.rect.height());
    }
    strRect &operator=(strRect x) {
      rect.setX(x.rect.x());
      rect.setY(x.rect.y());
      rect.setWidth(x.rect.width());
      rect.setHeight(x.rect.height());
      return *this;
    }
  };
  typedef DoraArray<strRect> TypeRect;
public:
  DoraRuntimeClass *GetRuntimeClass() const {
    return &classDoraInfoGroup;
  }
  static DoraRuntimeClass classDoraInfoGroup;
  static DoraClassObject *CreateView(QWidget *parent);
  static DoraClassObject *CreateDocument();

public:
  DoraInfoGroup(QWidget *parent, const char *name = 0) : DoraBaseView(parent, name) {
    printf("   DoraInfoGroup\n");
    itemRect.removeAllElement();
  }
  ~DoraInfoGroup() {
    printf("   DoraInfoGroup\n");
  }

public:
  void OnDraw(QPainter *p);
  void OnSize(int cx, int cy);
  void UpdateConvChar();

public:
  void OnCreate(DoraClassObject *pObject, DoraBaseView *pView);
  DoraCentralDocument *GetDocument();

public:
  DoraClassObject *m_pObject;
  DoraBaseView    *m_pView;
  DoraPushButton  *m_pPushButton;
  DoraStaticCtrl  *m_pStaticCtrl1;
  DoraStaticCtrl  *m_pStaticCtrl2;
  DoraStaticCtrl  *m_pStaticCtrl3;

public:
  QRect clientRect;
  CString infoStr[3];

public:
  TypeRect itemRect;

public:
  void PostMouseMessage(int ctrl, int index);
  void updateView();

};

#endif
