#if !defined(_DORAINSTALLCLASS_H)
#define _DORAINSTALLCLASS_H

#include <qwidget.h>
#include <qfont.h>
#include <qfontmetrics.h>

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <ctype.h>
#include <typeinfo>

#include "Typedef.h"
#include "Dynacolect.h"
#include "DoraClassObject.h"
#include "DoraBaseDocument.h"
#include "CompareDate.h"
#include "DoraConvChar.h"
#include "DoraFileSystem.h"

class DoraInstallClass : public DoraBaseDocument
{
public:
  struct saveStruct {
    Str35 name;
    saveStruct(saveStruct *x = NULL) {
      name = "";
    }
    saveStruct(const saveStruct &x) {
      name = x.name;
    }
    saveStruct &operator=(saveStruct x) {
      name = x.name;
      return *this;
    }
  };
  struct saveLangStruct {
    Str35 name, encoding, prefix;
    saveLangStruct(saveLangStruct *x = NULL) {
      name = "";
      encoding = "";
      prefix = "";
    }
    saveLangStruct(const saveLangStruct &x) {
      name = x.name;
      encoding = x.encoding;
      prefix = x.prefix;
    }
    saveLangStruct &operator=(saveLangStruct x) {
      name = x.name;
      encoding = x.encoding;
      prefix = x.prefix;
      return *this;
    }
  };
  struct saveMenagmentStruct {
    Str35 cap1, cap2;
    saveMenagmentStruct(saveMenagmentStruct *x = NULL) {
      cap1 = "";
      cap2 = "";
    }
    saveMenagmentStruct(const saveMenagmentStruct &x) {
      cap1 = "";cap1 = x.cap1;
      cap2 = "";cap2 = x.cap2;
    }
    saveMenagmentStruct &operator=(saveMenagmentStruct x) {
      cap1 = "";cap1 = x.cap1;
      cap2 = "";cap2 = x.cap2;
      return *this;
    }
  };

  typedef DoraArray<saveStruct>          TypeSaveStruct;  
  typedef DoraArray<saveLangStruct>      TypeSaveLangStruct;
  typedef DoraArray<saveMenagmentStruct> TypeSaveMenagmentStruct;
public:
  DoraRuntimeClass *GetRuntimeClass() const {
    return &classDoraInstallClass;
  }
  static DoraRuntimeClass classDoraInstallClass;
  static DoraClassObject *CreateView(QWidget *parent);
  static DoraClassObject *CreateDocument();

public:
  DoraInstallClass() : DoraBaseDocument() {
    printf("   DoraInstallClass\n");
    itemSaveStruct.removeAllElement();
    itemSaveLangStruct.removeAllElement();
    itemSaveMenagmentStruct.removeAllElement();
  }
  ~DoraInstallClass() {
    printf("   DoraInstallClass\n");
  }

public:
  void initDocument();

public:
  DoraFileSystem          fs;
  TypeSaveStruct          itemSaveStruct;
  TypeSaveLangStruct      itemSaveLangStruct;
  TypeSaveMenagmentStruct itemSaveMenagmentStruct;
public:
  void addGlobMenuBG();
  void addGlobMenuEN();
  void addGlobMenuRU();
  void addGlobMenuFR();
  void saveGlobMenu();

public:
  void addLangItemBG();
  void addLangItemEN();
  void addLangItemFR();
  void addLangItemRU();
  void saveLangItem();

public:
  void addDaysNameBG();
  void addDaysNameRU();
  void addDaysNameEN();
  void addDaysNameFR();
  void saveDaysName();

public:
  void addMonthsNameBG();
  void addMonthsNameRU();
  void addMonthsNameEN();
  void addMonthsNameFR();
  void saveMonthsName();

public:
  void addPopMenu100BG();
  void addPopMenu100EN();
  void addPopMenu100RU();
  void addPopMenu100FR();
  void savePopMenu100();

public:
  void addPopMenu200BG();
  void addPopMenu200EN();
  void addPopMenu200RU();
  void addPopMenu200FR();
  void savePopMenu200();

public:
  void addPopMenu300BG();
  void addPopMenu300EN();
  void addPopMenu300RU();
  void addPopMenu300FR();
  void savePopMenu300();

public:
  void addPopMenu400BG();
  void addPopMenu400EN();
  void addPopMenu400RU();
  void addPopMenu400FR();
  void savePopMenu400();

public:
  void addOtherCaptionBG();
  void addOtherCaptionEN();
  void addOtherCaptionRU();
  void addOtherCaptionFR();
  void saveOtherCaption();

public:
  void addMenagmentBG();
  void addMenagmentEN();
  void addMenagmentRU();
  void addMenagmentFR();
  void saveMenagment();

public:
  void addDateDialogBG();
  void addDateDialogEN();
  void addDateDialogRU();
  void addDateDialogFR();
  void saveDateDialog();

public:
  void addToolDialogBG();
  void addToolDialogEN();
  void addToolDialogFR();
  void addToolDialogRU();
  void saveToolDialog();


};

#endif
