#include "DoraCentralDocument.h"
#include "DoraCentralView.h"
#include "DoraMainFrame.h"
#include "DoraIntrGroup.h"

DoraRuntimeClass DoraIntrGroup::classDoraIntrGroup={"DoraIntrGroup", DoraIntrGroup::CreateView, NULL};

DoraClassObject *DoraIntrGroup::CreateView(QWidget *parent)
{
  return new DoraIntrGroup(parent);
}

DoraClassObject *DoraIntrGroup::CreateDocument()
{
  return NULL;
}

void DoraIntrGroup::OnDraw(QPainter *p)
{
  p->setFont(font);
  p->setPen(QPen(QColor(0, 0, 0), 1));
  p->setBrush(QBrush(QColor(192, 192, 192)));
  p->drawRect(clientRect);

  p->setPen(QPen(QColor(0, 0, 0), 1));
  p->setBrush(QBrush(QColor(255, 255, 255)));
  
  m_pPushButtonDate1->show();
  m_pPushButtonDate2->show();

  m_pStaticDate1->show();
  m_pStaticDate2->show();
}

void DoraIntrGroup::OnSize(int cx, int cy)
{
  clientRect.setX(0);
  clientRect.setY(0);
  clientRect.setWidth(cx);
  clientRect.setHeight(cy);

  QFontMetrics fm(font);
  QSize sizeFont = fm.size(SingleLine, "H", 1);
  int wFont = sizeFont.width();
  int hFont = fm.height() - fm.descent();
  int w = (wFont * 12) + 5;
  int h = hFont + 8;
  int x = 10;
  int y = 5;
  int maxElement = itemRect.maxElement();
  for(int i = 0; i <= maxElement - 1; i++) {
    int m = (i + 1) % 2;
    x = 10;
    if(m == 0)
      x = (w + 40);
    if((m != 0) && ((i + 1) >= 3))
      y = (h + 10);
    strRect item;
    item.rect.setX(x);
    item.rect.setY(y);
    item.rect.setWidth(w);
    item.rect.setHeight(h);
    itemRect.setElement(item, i + 1);
  }
  m_pPushButtonDate1->setGeometry(itemRect[0].rect);
  m_pPushButtonDate1->hide();
  m_pPushButtonDate2->setGeometry(itemRect[1].rect);
  m_pPushButtonDate2->hide();

  m_pStaticDate1->setGeometry(itemRect[2].rect);
  m_pStaticDate1->hide();
  m_pStaticDate2->setGeometry(itemRect[3].rect);
  m_pStaticDate2->hide();

}

void DoraIntrGroup::OnCreate(DoraClassObject *pObject, DoraBaseView *pView)
{
  m_pObject = pObject;
  m_pView   = pView;
  setFont(font);

  DoraCentralDocument *pDoc = GetDocument();

  strRect item;
  item.rect.setX(0);
  item.rect.setY(0);
  item.rect.setWidth(0);
  item.rect.setHeight(0);
  for(int i = 0; i <= 3; i++) {
    itemRect.setElement(item, i + 1);
  }

  DoraRuntimeClass *runtimePushButtonDate1 = RUNTIME_CLASS(DoraPushButton);
  DoraClassObject *objectPushButtonDate1 = runtimePushButtonDate1->CreateView(this);
  m_pPushButtonDate1 = dynamic_cast<DoraPushButton *>(objectPushButtonDate1);
  m_pPushButtonDate1->convChar = pDoc->convChar;
  m_pPushButtonDate1->selectNewFont(font);
  m_pPushButtonDate1->OnCreate(m_pObject, this);
  m_pPushButtonDate1->ctrlID = DM_PUSHBUTTON;
  m_pPushButtonDate1->nID = ID_PUSHBUTTON_DATE1;
  Str35 cap1, cap2;
  cap1 = "";cap2 = "";
  cap1 = pDoc->capIntr1;;
  m_pPushButtonDate1->setCaption(cap1, cap2);
  m_pPushButtonDate1->hide();

  DoraRuntimeClass *runtimePushButtonDate2 = RUNTIME_CLASS(DoraPushButton);
  DoraClassObject *objectPushButtonDate2 = runtimePushButtonDate2->CreateView(this);
  m_pPushButtonDate2 = dynamic_cast<DoraPushButton *>(objectPushButtonDate2);
  m_pPushButtonDate2->convChar = pDoc->convChar;
  m_pPushButtonDate2->selectNewFont(font);
  m_pPushButtonDate2->OnCreate(m_pObject, this);
  m_pPushButtonDate2->ctrlID = DM_PUSHBUTTON;
  m_pPushButtonDate2->nID = ID_PUSHBUTTON_DATE2;
  cap1 = "";cap1 = pDoc->capIntr2;;
  m_pPushButtonDate2->setCaption(cap1, cap2);
  m_pPushButtonDate2->hide();

  DoraRuntimeClass *runtimeStaticDate1 = RUNTIME_CLASS(DoraStaticCtrl);
  DoraClassObject *objectStaticDate1 = runtimeStaticDate1->CreateView(this);
  m_pStaticDate1 = dynamic_cast<DoraStaticCtrl *>(objectStaticDate1);
  m_pStaticDate1->convChar = pDoc->convChar;
  m_pStaticDate1->selectNewFont(font);
  m_pStaticDate1->OnCreate(m_pObject, this);
  m_pStaticDate1->setColor(QColor(0, 0, 0), QColor(0, 0, 0), QColor(255, 255, 255));
  m_pStaticDate1->hide();

  DoraRuntimeClass *runtimeStaticDate2 = RUNTIME_CLASS(DoraStaticCtrl);
  DoraClassObject *objectStaticDate2 = runtimeStaticDate2->CreateView(this);
  m_pStaticDate2 = dynamic_cast<DoraStaticCtrl *>(objectStaticDate2);
  m_pStaticDate2->convChar = pDoc->convChar;
  m_pStaticDate2->selectNewFont(font);
  m_pStaticDate2->OnCreate(m_pObject, this);
  m_pStaticDate2->setColor(QColor(0, 0, 0), QColor(0, 0, 0), QColor(255, 255, 255));
  m_pStaticDate2->hide();
}

DoraCentralDocument *DoraIntrGroup::GetDocument()
{
  DoraMainFrame *m_pMainFrame = dynamic_cast<DoraMainFrame *>(m_pObject);
  DoraCentralView *m_pCentralView = m_pMainFrame->GetCentralView();
  DoraCentralDocument *pDoc = m_pCentralView->GetDocument();
  return pDoc;
}

void DoraIntrGroup::PostMouseMessage(int ctrl, int index)
{
  DoraCentralDocument *pDoc = GetDocument();
  if(index == ID_PUSHBUTTON_DATE1) {
    Str35 caption;
    caption = "";caption = pDoc->itemCurentMonth[pDoc->curentIndex-1].dateStr;
    m_pStaticDate1->setCaption(caption);
    m_pStaticDate1->repaint(false);
    minDate = "";minDate = caption;
  }
  if(index == ID_PUSHBUTTON_DATE2) {
    Str35 caption;
    caption = "";caption = pDoc->itemCurentMonth[pDoc->curentIndex-1].dateStr;
    m_pStaticDate2->setCaption(caption);
    m_pStaticDate2->repaint(false);
    maxDate = "";maxDate = caption;
  }
  swapInterval();
}

void DoraIntrGroup::swapInterval()
{
  DoraCentralDocument *pDoc = GetDocument();

  Str35 tmp;
  tmp = "";
  if((minDate.p[0] != '\0') && (maxDate.p[0] != '\0')) {
    CompareDate date1(minDate);
    CompareDate date2(maxDate);
    if(date1 >= date2) {
      tmp = "";tmp = minDate;
      minDate = "";minDate = maxDate;
      maxDate = "";maxDate = tmp;
    }
    m_pStaticDate1->setCaption(minDate);
    m_pStaticDate1->repaint(false);
    m_pStaticDate2->setCaption(maxDate);
    m_pStaticDate2->repaint(false);
  }
  pDoc->minDate = "";pDoc->minDate = minDate;
  pDoc->maxDate = "";pDoc->maxDate = maxDate;
}

void DoraIntrGroup::UpdateConvChar()
{
  DoraMainFrame *m_pMainFrame = dynamic_cast<DoraMainFrame *>(m_pObject);
  DoraCentralDocument *pDoc = m_pMainFrame->GetDocument();
  Str35 cap;
  cap = "";
  m_pPushButtonDate1->convChar = convChar;
  m_pPushButtonDate1->setCaption(pDoc->capIntr1, cap);
  m_pPushButtonDate1->repaint(false);
  m_pPushButtonDate2->convChar = convChar;
  m_pPushButtonDate2->setCaption(pDoc->capIntr2, cap);
  m_pPushButtonDate2->repaint(false);
  m_pStaticDate1->convChar = convChar;
  m_pStaticDate1->repaint(false);
  m_pStaticDate2->convChar = convChar;
  m_pStaticDate2->repaint(false);
}
