#if !defined(_DORAINTRGROUP_H)
#define _DORAINTRGROUP_H

#include <qapplication.h>
#include <qwidget.h>
#include <qevent.h>
#include <qfont.h>
#include <qfontmetrics.h>
#include <qpainter.h>
#include <qcolor.h>
#include <qrect.h>
#include <qfontdialog.h>

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <ctype.h>
#include <typeinfo>

#include "Typedef.h"
#include "Dynacolect.h"
#include "CompareDate.h"
#include "DoraClassObject.h"
#include "DoraBaseView.h"
#include "DoraPushButton.h"
#include "DoraStaticCtrl.h"

class DoraIntrGroup : public DoraBaseView
{
public:
  struct strRect {
    QRect rect;
    strRect(strRect *x = NULL) {
      rect.setX(0);
      rect.setY(0);
      rect.setWidth(0);
      rect.setHeight(0);
    }
    strRect(const strRect &x) {
      rect.setX(x.rect.x());
      rect.setY(x.rect.y());
      rect.setWidth(x.rect.width());
      rect.setHeight(x.rect.height());
    }
    strRect &operator=(strRect x) {
      rect.setX(x.rect.x());
      rect.setY(x.rect.y());
      rect.setWidth(x.rect.width());
      rect.setHeight(x.rect.height());
      return *this;
    }
  };
  typedef DoraArray<strRect> TypeRect;

public:
  DoraRuntimeClass *GetRuntimeClass() const {
    return &classDoraIntrGroup;
  }
  static DoraRuntimeClass classDoraIntrGroup;
  static DoraClassObject *CreateView(QWidget *parent);
  static DoraClassObject *CreateDocument();

public:
  DoraIntrGroup(QWidget *parent, const char *name = 0) : DoraBaseView(parent, name) {
    printf("   DoraIntrGroup\n");
    itemRect.removeAllElement();
    minDate = "";
    maxDate = "";
  }
  ~DoraIntrGroup() {
    printf("   DoraIntrGroup\n");
  }

public:
  void OnDraw(QPainter *p);
  void OnSize(int cx, int cy);
  void swapInterval();
  void UpdateConvChar();

public:
  void OnCreate(DoraClassObject *pObject, DoraBaseView *pView);
  DoraCentralDocument *GetDocument();
  
public:
  DoraClassObject *m_pObject;
  DoraBaseView    *m_pView;
  DoraPushButton  *m_pPushButtonDate1;
  DoraPushButton  *m_pPushButtonDate2;
  DoraStaticCtrl  *m_pStaticDate1;
  DoraStaticCtrl  *m_pStaticDate2;
  
public:
  QRect clientRect;
  Str35 minDate;
  Str35 maxDate;

public:
  TypeRect itemRect;

public:
  void PostMouseMessage(int ctrl, int index);

};

#endif
