#if !defined(_DORALEFTVIEW_H)
#define _DORALEFTVIEW_H

#include <qapplication.h>
#include <qwidget.h>
#include <qevent.h>
#include <qfont.h>
#include <qfontmetrics.h>
#include <qpainter.h>
#include <qcolor.h>
#include <qrect.h>
#include <qfontdialog.h>

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <ctype.h>
#include <typeinfo>

#include "Typedef.h"
#include "Dynacolect.h"
#include "DoraClassObject.h"
#include "DoraBaseView.h"
#include "DoraClockView.h"
#include "DoraSpinGroup.h"
#include "DoraIntrGroup.h"
#include "DoraInfoGroup.h"

class DoraLeftView : public DoraBaseView
{
public:
  DoraRuntimeClass *GetRuntimeClass() const {
    return &classDoraLeftView;
  }
  static DoraRuntimeClass classDoraLeftView;
  static DoraClassObject *CreateView(QWidget *parent);
  static DoraClassObject *CreateDocument();

public:
  DoraLeftView(QWidget *parent, const char *name = 0) : DoraBaseView(parent, name) {
    printf("   DoraLeftView\n");
  }
  ~DoraLeftView() {
    printf("   DoraLeftView\n");
  }

public:
  void OnDraw(QPainter *p);
  void OnSize(int cx, int cy);

public:
  void OnCreate(DoraClassObject *pObject, DoraBaseView *pView);
  DoraCentralDocument *GetDocument();

public:
  DoraClassObject *m_pObject;
  DoraBaseView    *m_pView;
  DoraClockView   *m_pClockView;
  DoraSpinGroup   *m_pSpinGroup;
  DoraIntrGroup   *m_pIntrGroup;
  DoraInfoGroup   *m_pInfoGroup;

public:
  QRect clientRect;
  QRect clockRect;
  QRect groupRect;
  QRect grInfoRect;
  QRect grIntrRect;

public:
  void UpdateTimeView();
  void stopClock();
  void startClock();
  void UpdateConvChar();

};

#endif
