#include "DoraMainApp.h"

DoraRuntimeClass DoraMainApp::classDoraMainApp = {"DoraMainApp", NULL, NULL, DoraMainApp::CreateApp};

DoraClassObject *DoraMainApp::CreateView(QWidget *parent)
{
  return NULL;
}

DoraClassObject *DoraMainApp::CreateDocument()
{
  return NULL;
}

DoraClassObject *DoraMainApp::CreateApp(int argc, char **argv)
{
  return new DoraMainApp(argc, argv);
}

int DoraMainApp::RunApp()
{
  QWidget *wid = QApplication::desktop();
  int width  = wid->width();
  int height = wid->height();
  int cWidth  = 565;
  int cHeight = 400;
  int cXpos = (int)((width  - cWidth)/2);
  int cYpos = (int)((height - cHeight)/2);


  DoraConvChar conv;
  setDefaultCodec(conv.getCodec());

  DoraRuntimeClass *mainFrameRuntime = RUNTIME_CLASS(DoraMainFrame);
  DoraClassObject  *mainFrameObject  = mainFrameRuntime->CreateView(wid);
  mainFrame = dynamic_cast<DoraMainFrame *>(mainFrameObject);
  
  mainFrame->OnCreate(this);

  setMainWidget(mainFrame);
  mainFrame->setGeometry(cXpos, cYpos, cWidth, cHeight);
  mainFrame->show();  
  int result = exec();

  return result;
}

void DoraMainApp::Destroy()
{
  mainFrame->OnDestroy();
}

void DoraMainApp::OnInitialUpdate()
{
  printf(" OnInitialUpdate()   DoraMainApp\n");
}

DoraMainFrame *DoraMainApp::GetMainFrame()
{
  return mainFrame;
}
