#if !defined(_DORAMAINAPP_H)
#define _DORAMAINAPP_H

#include <qapplication.h>
#include <qwidget.h>
#include <qevent.h>
#include <qfont.h>
#include <qtextcodec.h>
#include <qstring.h>

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <ctype.h>
#include <typeinfo>

#include "Typedef.h"
#include "Dynacolect.h"
#include "DoraClassObject.h"
#include "DoraConvChar.h"
#include "DoraMainFrame.h"

class DoraMainApp : public QApplication, public DoraClassObject
{
public:
  DoraRuntimeClass *GetRuntimeClass() const {
    return &classDoraMainApp;
  }
  static DoraRuntimeClass classDoraMainApp;
  static DoraClassObject *CreateView(QWidget *parent);
  static DoraClassObject *CreateDocument();
  static DoraClassObject *CreateApp(int argc, char **argv);

public:
  DoraMainApp(int argc, char **argv) : QApplication(argc, argv), DoraClassObject(){
    printf("   DoraMainApp\n");
  }

  ~DoraMainApp() {
    printf("   DoraMainApp\n");
  }

public:
  DoraMainFrame *GetMainFrame();
  int            RunApp();
  void           Destroy();
  void           OnInitialUpdate();

public:
  DoraMainFrame *mainFrame;
};


#endif





