#if !defined(_DORAMAINFRAME_H)
#define _DORAMAINFRAME_H

#include <qapplication.h>
#include <qwidget.h>
#include <qevent.h>
#include <qpainter.h>
#include <qfont.h>
#include <qfontmetrics.h>
#include <qfontdialog.h>

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <ctype.h>
#include <typeinfo>

#include "Typedef.h"
#include "Dynacolect.h"
#include "DoraConvChar.h"
#include "DoraClassObject.h"
#include "DoraBaseDocument.h"
#include "DoraBaseView.h"
#include "DoraCentralDocument.h"
#include "DoraCentralView.h"
#include "DoraReklView.h"
#include "DoraGlobMenuView.h"
#include "DoraAbautView.h"
#include "DoraEditDialog.h"
#include "DoraInstallClass.h"

class DoraMainFrame : public DoraBaseView
{
public:
  DoraRuntimeClass *GetClassObject() const {
    printf(" GetClassObject,  DoraMainFrame\n");
    return &classDoraMainFrame;
  }
  static DoraRuntimeClass classDoraMainFrame;
  static DoraClassObject *CreateView(QWidget *parent);
  static DoraClassObject *CreateDocument();

public:
  DoraMainFrame(QWidget *parent, const char *name = 0) : DoraBaseView(parent, name) {
    printf("   DoraMainFrame\n");
    m_pAbautView = NULL;
    m_pEditDialog = NULL;
  }
  ~DoraMainFrame() {
    printf("   DoraMainFrame\n");
  }

public:
  void OnCreate(DoraClassObject *pObject);
  void OnDestroy();
  void OnDraw(QPainter *p);
  void OnCloseView();
  void OnAbautView();
  void OnReklDialog();
  void OnBioritms();
  void closeAbautView();
  void closeEditDialog();

public:
  DoraCentralView   *m_pCentralView;
  DoraReklView      *m_pReklView;
  DoraGlobMenuView  *m_pGlobMenuView;
  DoraBaseDocument  *baseDocument;
  DoraAbautView     *m_pAbautView;
  DoraEditDialog    *m_pEditDialog;
  QRect             clientRect;
  QFont             font;
  DoraClassObject   *m_pObject;
  DoraInstallClass  *m_pInstallClass;

public:
  void OnSize(int cx, int cy);
  DoraCentralDocument *GetDocument();
  DoraCentralView     *GetCentralView();

public:
  int xGMenu, yGMenu, wGMenu, hGMenu;
  int xCView, yCView, wCView, hCView;
  int xSView, ySView, wSView, hSView;

public:
  void PostMouseMessage(int ctrl, int index);

public:
  void UpdateConvChar();

};

#endif

