#include "DoraMenuButton.h"

DoraRuntimeClass DoraMenuButton::classDoraMenuButton={"DoraMenuButton", DoraMenuButton::CreateView, NULL};

DoraClassObject *DoraMenuButton::CreateView(QWidget *parent)
{
  return new DoraMenuButton(parent);
}

DoraClassObject *DoraMenuButton::CreateDocument()
{
  return NULL;
}

void DoraMenuButton::OnCreate(DoraClassObject *pObject, DoraBaseView *pView)
{
  m_pObject = pObject;
  m_pView = pView;
  setMouseTracking(true);
}

void DoraMenuButton::OnSize(int cx, int cy)
{
  clientRect.setX(0);
  clientRect.setY(0);
  clientRect.setWidth(cx);
  clientRect.setHeight(cy);
}

void DoraMenuButton::OnDraw(QPainter *p)
{
  p->setFont(font);
  p->setPen(QPen(QColor(192, 192, 192), 1));
  p->setBrush(QBrush(QColor(192, 192, 192)));
  p->drawRect(clientRect);

  int x1 = clientRect.x() + 1;
  int y1 = clientRect.y() + 1;
  int x2 = clientRect.width() - 2;
  int y2 = clientRect.height() - 2;
  if(status == ID_STATUS_BUTTON_NORMAL) {
     p->setPen(QPen(QColor(192, 192, 192), 1));
     p->setBrush(QBrush(QColor(192, 192, 192)));
     p->drawRect(clientRect);
  }
  if(status == ID_STATUS_BUTTON_MOVE) {
    p->setPen(QPen(QColor(0, 0, 0), 1));
    p->setBrush(QBrush(QColor(192, 192, 192)));
    p->drawRect(clientRect);
    p->setPen(QPen(QColor(255, 255, 255), 1));
    p->drawLine(x1, y2, x1, y1);
    p->drawLine(x1, y1, x2, y1);
    p->setPen(QPen(QColor(0, 0, 0), 1));
    p->drawLine(x1, y2, x2, y2);
    p->drawLine(x2, y2, x2, y1);
  }
  if(status == ID_STATUS_BUTTON_PUSHED) {
    p->setPen(QPen(QColor(0, 0, 0), 1));
    p->setBrush(QBrush(QColor(192, 192, 192)));
    p->drawRect(clientRect);
    p->setPen(QPen(QColor(0, 0, 0), 1));
    p->drawLine(x1, y2, x1, y1);
    p->drawLine(x1, y1, x2, y1);
    p->setPen(QPen(QColor(255, 255, 255), 1));
    p->drawLine(x1, y2, x2, y2);
    p->drawLine(x2, y2, x2, y1);
  }
  QFontMetrics fm(font);
  QSize sizeFont = fm.size(SingleLine, "H", 1);
  int wf = sizeFont.width();
  int hf = fm.height() - fm.descent();
  if(caption != "") {
    int x = clientRect.x() + wf;
    int y = (int)((clientRect.height() - hf) / 2) + (hf - 2);
    int len = strlen(caption.p);
    for(int i = 0; i <= len - 1; i++) {
      char *s = new char[2];
      s[0] = '\0';
      sprintf(s, "%c\0", caption.p[i]);
      QString qStr;
      qStr = "";qStr = convChar.getCharCodec(s);
      p->setPen(QPen(QColor(0, 0, 0), 1));
      p->setBrush(QBrush(QColor(192, 192, 192)));      
      p->drawText(x, y, qStr);
      x += wf;
      delete s;
    }
  }
}

void DoraMenuButton::setStatus(const int st)
{
  status = st;
}

void DoraMenuButton::setCaption(Str35 cap)
{
  caption = "";
  caption = cap;
}

void DoraMenuButton::MouseLeftButton(int xLocPos, int yLocPos, int xPosGlb, int yPosGlb)
{
  if(statusID == ID_STATUS_CHECK) {
    setStatus(ID_STATUS_BUTTON_PUSHED);
    repaint(false);
    m_pView->PostMouseMessage(ctrlID, nID);
  }
}

void DoraMenuButton::MouseMove()
{
  if(statusID == ID_STATUS_CHECK) {
    setStatus(ID_STATUS_BUTTON_MOVE);
    repaint(false);
    m_pView->PostMouseMove(nID);
  }
}

void DoraMenuButton::MouseRelease()
{

}

void DoraMenuButton::setNoFocus()
{
  setStatus(ID_STATUS_BUTTON_NORMAL);
  repaint(false);
}

void DoraMenuButton::setOnFocus()
{
}
