#if !defined(_DORAMENUBUTTON_H)
#define _DORAMENUBUTTON_H

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <ctype.h>
#include <typeinfo>

#include <qwidget.h>
#include <qrect.h>
#include <qfont.h>
#include <qfontmetrics.h>
#include <qpainter.h>
#include <qevent.h>

#include "Typedef.h"
#include "DoraClassObject.h"
#include "DoraBaseCtrl.h"
#include "DoraBaseView.h"

class DoraMenuButton : public DoraBaseCtrl
{
public:
  DoraRuntimeClass *GetClassObject() const {
    return &classDoraMenuButton;
  }
  static DoraRuntimeClass classDoraMenuButton;
  static DoraClassObject *CreateView(QWidget *parent);
  static DoraClassObject *CreateDocument();

public:
  DoraMenuButton(QWidget *parent, const char *name = 0) : DoraBaseCtrl(parent, name) {
    printf("   DoraMenuButton\n");
    status = ID_STATUS_BUTTON_NORMAL;
    caption = "";
  }
  ~DoraMenuButton() {
    printf("   DoraMenuButton\n");
  }

public:
  void OnCreate(DoraClassObject *pObject, DoraBaseView *pView);
  
public:
  void OnSize(int cx, int cy);
  void OnDraw(QPainter *p);

public:
  DoraClassObject *m_pObject;
  DoraBaseView    *m_pView;
  QRect           clientRect;
  int             nID;
  int             status;
  int             ctrlID;
  int             statusID;
  Str35           caption;

public:
  void setStatus(const int st = ID_STATUS_BUTTON_NORMAL);
  void setCaption(Str35 cap);

public:
  void MouseLeftButton(int xLocPos, int yLocPos, int xPosGlb, int yPosGlb);
  void MouseMove();
  void MouseRelease();
  void setOnFocus();
  void setNoFocus();

};

#endif
