#if !defined(_DORAPOPUPMENU_H)
#define _DORAPOPUPMENU_H

#include <qapplication.h>
#include <qwidget.h>
#include <qevent.h>
#include <qfont.h>
#include <qfontmetrics.h>
#include <qpainter.h>
#include <qcolor.h>
#include <qrect.h>
#include <qfontdialog.h>

#include "Typedef.h"
#include "Dynacolect.h"
#include "DoraClassObject.h"
#include "DoraBaseView.h"
#include "DoraBaseDocument.h"
#include "DoraStaticCtrl.h"
#include "AttrMenu.h"

class DoraPopupMenu : public DoraBaseView
{
public:
  struct strItem {
    DoraStaticCtrl *staticCtrl;
    int            nID;
    strItem(strItem *x = NULL) {
      nID = 0;
    }
    strItem(const strItem &x) {
      staticCtrl = x.staticCtrl;
      nID        = x.nID;
    }
    strItem &operator=(strItem x) {
      staticCtrl = x.staticCtrl;
      nID        = x.nID;
      return *this;
    }
  };
  typedef DoraArray<strItem> TypeStrItem;
      
public:
  DoraRuntimeClass *GetRuntimeClass() const {
    return &classDoraPopupMenu;
  }
  static DoraRuntimeClass classDoraPopupMenu;
  static DoraClassObject *CreateView(QWidget *parent);
  static DoraClassObject *CreateDocument();

public:
  DoraPopupMenu(QWidget *parent, const char *name = 0) : DoraBaseView(parent, name) {
    printf("   DoraPopupMenu\n");
    itemPopup.removeAllElement();
    oldIndex = 1;
  }
  ~DoraPopupMenu() {
    printf("   DoraPopupMenu\n");
  }

public:
  void OnCreate(DoraClassObject *pObject, DoraBaseView *pView);

public:
  DoraClassObject *m_pObject;
  DoraBaseView    *m_pView;
  QRect           clientRect;
  TypeStrItem     itemPopup;
  AttrMenu        attr;
  int             oldIndex;

public:
  void OnSize(int cx, int cy);
  void OnDraw(QPainter *p);

public:
  void setPopupItem(const int index);

public:
  void PostMouseMove(int index);
  void PostMouseMessage(int ctrl, int index);

};

#endif
