#include "DoraPushButton.h"

DoraRuntimeClass DoraPushButton::classDoraPushButton={"DoraPushButton", DoraPushButton::CreateView, NULL};

DoraClassObject *DoraPushButton::CreateView(QWidget *parent)
{
  return new DoraPushButton(parent);
}

DoraClassObject *DoraPushButton::CreateDoacument()
{
  return NULL;
}

void DoraPushButton::OnSize(int cx, int cy)
{
  clientRect.setX(0);
  clientRect.setY(0);
  clientRect.setWidth(cx);
  clientRect.setHeight(cy);
}

void DoraPushButton::OnDraw(QPainter *p)
{
  p->setFont(font);
  p->setPen(QPen(QColor(0, 0, 0), 1));
  p->setBrush(QBrush(QColor(192, 192, 192)));
  p->drawRect(clientRect);

  QFontMetrics fm(font);
  QSize sizeFont = fm.size(SingleLine, "H", 1);
  int h = fm.height() - fm.descent();
  int w = sizeFont.width();

  int yPos1, yPos2;
  int x1 = clientRect.x() + 1;
  int y1 = clientRect.y() + 1;
  int x2 = clientRect.width() - 2;
  int y2 = clientRect.height() - 2;
  if(multiCap) {
    yPos1 = (y1 + h) + 2;
    yPos2 = (y1 + (2 * h)) + 2;
  }
  if(!multiCap) {
    int strPos = (int)((((y2 - y1)) - h) / 2);    
    yPos1 = ((y1 + strPos) + h) - 2;
  }
  if(okPushed) {
    p->setPen(QPen(QColor(0, 0, 0), 1));
    p->drawLine(x1, y2, x1, y1);
    p->drawLine(x1, y1, x2, y1);
    p->setPen(QPen(QColor(255, 255, 255), 1));
    p->drawLine(x1, y2, x2, y2);
    p->drawLine(x2, y2, x2, y1);
    if(caption1 != "") {
      int len = strlen(caption1.p);
      int x = x1 + w;
      int y = yPos1;
      for(int i = 0; i <= len - 1; i++) {
	char *s = new char[2];
	s[0] = '\0';
	sprintf(s, "%c\0", caption1.p[i]);
	QString qStr;
	qStr = "";qStr = convChar.getCharCodec(s);
	p->setPen(QPen(QColor(0, 0, 0), 1));
	p->drawText(x, y+1, qStr);
	p->drawText(x+1, y+1, qStr);
	x += w;
	delete s;
      }
    }
    if(multiCap) {
      if(caption2 != "") {
	int len = strlen(caption2.p);
	int x = x1 + w;
	int y = yPos2;
	for(int i = 0; i <= len - 1; i++) {
	  char *s = new char[2];
	  s[0] = '\0';
	  sprintf(s, "%c\0", caption2.p[i]);
	  p->setPen(QPen(QColor(0, 0, 0), 1));
	  QString qStr;
	  qStr = "";qStr = convChar.getCharCodec(s);
	  p->drawText(x, y+1, qStr);
	  p->drawText(x+1, y+1, qStr);
	  x += w;
	  delete s;
	}
      }
    }
  }
  if(!okPushed) {
    p->setPen(QPen(QColor(255, 255, 255), 1));
    p->drawLine(x1, y2, x1, y1);
    p->drawLine(x1, y1, x2, y1);
    p->setPen(QPen(QColor(0, 0, 0), 1));
    p->drawLine(x1, y2, x2, y2);
    p->drawLine(x2, y2, x2, y1);
    if(caption1 != "") {
      int len = strlen(caption1.p);
      int x = x1 + w;
      int y = yPos1;
      for(int i = 0; i <= len - 1; i++) {
	char *s = new char[2];
	s[0] = '\0';
	sprintf(s, "%c\0", caption1.p[i]);
	p->setPen(QPen(QColor(0, 0, 0), 1));
	QString qStr;
	qStr = "";qStr = convChar.getCharCodec(s);
	p->drawText(x, y, qStr);
	p->drawText(x+1, y, qStr);
	x += w;
	delete s;
      }
    }
    if(multiCap) {
      if(caption2 != "") {
	int len = strlen(caption2.p);
	int x = x1 + w;
	int y = yPos2;
	for(int i = 0; i <= len - 1; i++) {
	  char *s = new char[2];
	  s[0] = '\0';
	  sprintf(s, "%c\0", caption2.p[i]);
	  p->setPen(QPen(QColor(0, 0, 0), 1));
	  QString qStr;
	  qStr = "";qStr = convChar.getCharCodec(s);
	  p->drawText(x, y, qStr);
	  p->drawText(x+1, y, qStr);
	  x += w;
	  delete s;
	}
      }
    }
  }
}

void DoraPushButton::OnCreate(DoraClassObject *pObject, DoraBaseView *pView)
{
  m_pObject = pObject;
  m_pView   = pView;
  m_pDialog = NULL;
  setFont(font);
  setMouseTracking(true);
}

void DoraPushButton::OnCreate(DoraClassObject *pObject, DoraBaseDialog *pDialog)
{
  m_pObject = pObject;
  m_pView   = NULL;
  m_pDialog = pDialog;
  setFont(font);
  setMouseTracking(true);
}

void DoraPushButton::MouseLeftButton(int xLocPos, int yLocPos, int xPosGlb, int yPosGlb)
{
  okPushed = TRUE;
  repaint();
  if(m_pView != NULL)
    m_pView->PostMouseMessage(ctrlID, nID);
  if(m_pDialog != NULL)
    m_pDialog->PostMouseMessage(ctrlID, nID);
}

void DoraPushButton::MouseRelease()
{
  okPushed = FALSE;
  repaint();
}

void DoraPushButton::setCaption(Str35 strCap1, Str35 strCap2)
{
  caption1 = "";
  caption2 = "";
  if(strCap1.p[0] != '\0')
    caption1 = strCap1;
  if(strCap2.p[0] != '\0') {
    caption2 = strCap2;
    multiCap = TRUE;
  }
  if(strCap2.p[0] == '\0') {
    multiCap = FALSE;
  }
}
