#if !defined(_DORAPUSHBUTTON_H)
#define _DORAPUSHBUTTON_H

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <ctype.h>
#include <typeinfo>

#include <qapplication.h>
#include <qwidget.h>
#include <qevent.h>
#include <qpainter.h>
#include <qrect.h>
#include <qcolor.h>
#include <qfont.h>
#include <qfontmetrics.h>

#include "Typedef.h"
#include "DoraClassObject.h"
#include "DoraBaseView.h"
#include "DoraBaseCtrl.h"
#include "DoraBaseDialog.h"

class DoraPushButton : public DoraBaseCtrl
{
public:
  DoraRuntimeClass *GetRuntimeClass() const {
    return &classDoraPushButton;
  }
  static DoraRuntimeClass classDoraPushButton;
  static DoraClassObject *CreateView(QWidget *parent);
  static DoraClassObject *CreateDoacument();

public:
  DoraPushButton(QWidget *parent, const char *name = 0) : DoraBaseCtrl(parent, name) {
    printf("   DoraPushButton\n");
    okPushed = FALSE;
    caption1 = "";
    caption2 = "";
    multiCap = TRUE;
  }
  ~DoraPushButton() {
    printf("   DoraPushButton\n");
  }

public:
  void OnDraw(QPainter *p);
  void OnSize(int cx, int cy);
  void setCaption(Str35 strCap1, Str35 strCap2);

public:
  void OnCreate(DoraClassObject *pObject, DoraBaseView *pView);
  void OnCreate(DoraClassObject *pObject, DoraBaseDialog *pDialog);

public:
  DoraClassObject *m_pObject;
  DoraBaseView    *m_pView;
  DoraBaseDialog  *m_pDialog;

public:
  QRect   clientRect;
  bool    okPushed;
  bool    multiCap;
  CString caption1;
  CString caption2;
  int     nID;
  int     ctrlID;

public:
   void MouseLeftButton(int xLocPos, int yLocPos, int xPosGlb, int yPosGlb);
   void MouseRelease();
};

#endif

