#if !defined(_DORAREKLVIEW_H)
#define _DORAREKLVIEW_H

#include <qapplication.h>
#include <qwidget.h>
#include <qevent.h>
#include <qfont.h>
#include <qfontmetrics.h>
#include <qpainter.h>
#include <qcolor.h>
#include <qrect.h>
#include <qfontdialog.h>

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <ctype.h>
#include <typeinfo>

#include "Typedef.h"
#include "Dynacolect.h"
#include "DoraClassObject.h"
#include "DoraBaseView.h"
#include "DoraConvChar.h"

class DoraReklView : public DoraBaseView
{
public:
  DoraRuntimeClass *GetRuntimeClass() const {
    return &classDoraReklView;
  }
  static DoraRuntimeClass classDoraReklView;
  static DoraClassObject *CreateView(QWidget *parent);
  static DoraClassObject *CreateDocument();

public:
  DoraReklView(QWidget *parent, const char *name = 0) : DoraBaseView(parent, name) {
    printf("   DoraReklView\n");
    col = 1;
  }
  ~DoraReklView() {
    printf("   DoraReklView\n");
  }

private:
  void timerEvent(QTimerEvent *e);

public:
  void OnDraw(QPainter *p);
  void OnSize(int cx, int cy);
  void setPixmap();
  void OnClock();
  CString getVisualStr();
  void reloadReclams();
  void stopTimer();

public:
  void OnCreate(DoraClassObject *pObject);

public:
  DoraCentralDocument *GetDocument();
  DoraDialogDoc       *GetDialogDoc();

public:
  DoraClassObject *m_pObject;

public:
  QRect   clientRect;
  QPixmap pixmap;
  int     timID, col, maxCol;
  bool    killedTimer;
};

#endif

