#if !defined(_DORASCRBARBUTTON_H)
#define _DORASCRBARBUTTON_H

#include <qapplication.h>
#include <qwidget.h>
#include <qevent.h>
#include <qrect.h>
#include <qcolor.h>
#include <qbrush.h>
#include <qfont.h>
#include <qfontmetrics.h>
#include <qpainter.h>
#include <qpixmap.h>

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <ctype.h>
#include <typeinfo>

#include "Typedef.h"
#include "Dynacolect.h"
#include "DoraClassObject.h"
#include "DoraBaseView.h"
#include "DoraBaseDocument.h"
#include "DoraBaseCtrl.h"


class DoraScrBarButton : public DoraBaseCtrl
{
public:
  DoraRuntimeClass *GetRuntimeClass() const {
    return &classDoraScrBarButton;
  }

  static DoraRuntimeClass classDoraScrBarButton;
  static DoraClassObject *CreateView(QWidget *parent);
  static DoraClassObject *CreateDocument();

public:
  DoraScrBarButton(QWidget *parent, const char *name = 0) : DoraBaseCtrl(parent, name) {
    printf("   DoraScrBarButton\n");
  }

  ~DoraScrBarButton() {
    printf("   DoraScrBarButton\n");
  }

public:
  void OnDraw(QPainter *p);
  void OnSize(int cx, int cy);

public:
  void OnCreate(DoraClassObject *pObject, DoraBaseView *pView, const int style);

public:
  DoraClassObject *m_pObject;
  DoraBaseView    *m_pView;

public:
  void setPixmap();
  void DrawLeftButton(QPainter *p);
  void DrawRightButton(QPainter *p);
  void DrawUpButton(QPainter *p);
  void DrawDownButton(QPainter *p);

public:
  void MouseLeftButton(int xLocPos, int yLocPos, int xPosGlb, int yPosGlb);
  void MouseRelease();

public:
  QRect   clientRect;
  QPixmap pm;
  int     styleButton;
  bool    OkPushed;
  int     postButton;
};


#endif
