#if !defined(_DORASCROLLBOX_H)
#define _DORASCROLLBOX_H

#include <qapplication.h>
#include <qwidget.h>
#include <qpainter.h>
#include <qevent.h>
#include <qcolor.h>
#include <qrect.h>
#include <qfont.h>
#include <qfontmetrics.h>
#include <qpixmap.h>

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <ctype.h>
#include <typeinfo>

#include "Typedef.h"
#include "Dynacolect.h"
#include "DoraClassObject.h"
#include "DoraBaseDocument.h"
#include "DoraBaseView.h"

class DoraScrollBox : public DoraBaseView
{
public:
  struct ItemRectStruct {
    QRect rect;
    bool  isSelected;
    int   index;
    Str35 name;

    ItemRectStruct(ItemRectStruct *x = NULL) {
      isSelected = false;
      rect.setX(0);
      rect.setY(0);
      rect.setWidth(0);
      rect.setHeight(0);
      index = 0;
      name = "";
    }
    ItemRectStruct(const ItemRectStruct &x) {
      isSelected = x.isSelected;
      rect.setX(x.rect.x());
      rect.setY(x.rect.y());
      rect.setWidth(x.rect.width());
      rect.setHeight(x.rect.height());
      index = x.index;
      name = x.name;
    }
    ItemRectStruct &operator=(ItemRectStruct x) {
      isSelected = x.isSelected;
      rect.setX(x.rect.x());
      rect.setY(x.rect.y());
      rect.setWidth(x.rect.width());
      rect.setHeight(x.rect.height());
      index = x.index;
      name = x.name;
      return *this;
    }
  };

  struct ItemDataStruct {
    Str35 name;
    int   index;
    ItemDataStruct(ItemDataStruct *x = NULL) {
      name = "";
      index = 0;
    }
    ItemDataStruct(const ItemDataStruct &x) {
      name = "";name = x.name;
      index = x.index;
    }
    ItemDataStruct &operator=(ItemDataStruct x) {
      name = "";name = x.name;
      index = x.index;
      return *this;
    }
  };
  typedef DoraArray<ItemDataStruct> TypeItemData;
  typedef DoraArray<ItemRectStruct> TypeRectData;

public:
  DoraRuntimeClass *GetRuntimeClass() const {
    return &classDoraScrollBox;
  }
  static DoraRuntimeClass classDoraScrollBox;
  static DoraClassObject *CreateView(QWidget *parent);
  static DoraClassObject *CreateDocument();

public:
  DoraScrollBox(QWidget *parent, const char *name = 0) : DoraBaseView(parent, name) {
    printf("   DoraScrollBox\n");
    itemData.removeAllElement();
    itemRect.removeAllElement();
  }
  ~DoraScrollBox() {
    printf("   DoraScrollBox\n");
  }

public:
  void OnDraw(QPainter *p);
  void OnSize(int cx, int cy);
  void setDataElement(Str35 name, const int index);
  void setRectElement(const int index);
  void setCheckElement(const int index);
  void setPixmap();
  void scrollUp();
  void scrollDown();
  void reloadData();

public:
  void OnCreate(DoraClassObject *pObject, DoraBaseView *pView);

public:
  DoraClassObject  *m_pObject;
  DoraBaseView     *m_pView;
  TypeItemData     itemData;
  TypeRectData     itemRect;

public:
  QRect   clientRect;
  QPixmap pmap;
  int     oldIndex, curentIndex;
  int     maxRow, row, iMin, iMax, iPos;

public:
  void MouseMove();
  void PostMouseClick(int index);
  void UpdateConvChar();

};

#endif

