#if !defined(_DORASCROLLVIEW_H)
#define _DORASCROLLVIEW_H

#include <qapplication.h>
#include <qwidget.h>
#include <qpainter.h>
#include <qevent.h>
#include <qcolor.h>
#include <qrect.h>
#include <qfont.h>
#include <qfontmetrics.h>

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <ctype.h>
#include <typeinfo>

#include "Typedef.h"
#include "Dynacolect.h"
#include "DoraClassObject.h"
#include "DoraBaseDocument.h"
#include "DoraBaseView.h"
#include "DoraBaseDialog.h"
#include "DoraScrollBox.h"
#include "DoraVScrollBar.h"
#include "DoraHScrollBar.h"

class DoraScrollView : public DoraBaseView
{
public:
  DoraRuntimeClass *GetRuntimeClass() const {
    return &classDoraScrollView;
  }
  static DoraRuntimeClass classDoraScrollView;
  static DoraClassObject *CreateView(QWidget *parent);
  static DoraClassObject *CreateDocument();

public:
  DoraScrollView(QWidget *parent, const char *name = 0) : DoraBaseView(parent, name) {
    printf("   DoraScrollView\n");
    okScrollBar = TRUE;
  }
  ~DoraScrollView() {
    printf("   DoraScrollView\n");
  }

public:
  void OnDraw(QPainter *p);
  void OnSize(int cx, int cy);
  void addExpand(Str35 name, const int index);

public:
  void OnCreate(DoraClassObject *pObject, DoraBaseView *pView);
  void OnCreate(DoraClassObject *pObject, DoraBaseDialog *pDialog);
  DoraCentralDocument *GetDocument();

public:
  DoraClassObject *m_pObject;
  DoraBaseView    *m_pView;
  DoraBaseDialog  *m_pDialog;
  DoraVScrollBar  *m_pVScrollBar;
  DoraHScrollBar  *m_pHScrollBar;
  DoraScrollBox   *m_pScrollBox;

public:
  QRect   clientRect;
  QRect   scrollBoxRect;
  QRect   vRectScrollBar;
  QRect   hRectScrollBar;
  bool    okScrollBar;
  int     maxRow;
  int     nID;

public:
  void PostMouseMessage(int ctrl, int index);

};

#endif
