#include "DoraSpinBox.h"

DoraRuntimeClass DoraSpinBox::classDoraSpinBox={"DoraSpinBox", DoraSpinBox::CreateView, NULL};

DoraClassObject *DoraSpinBox::CreateView(QWidget *parent)
{
  return new DoraSpinBox(parent);
}

DoraClassObject *DoraSpinBox::CreateDocument()
{
  return NULL;
}

void DoraSpinBox::OnDraw(QPainter *p)
{
  p->setPen(QColor(0, 0, 0));
  p->setBrush(QColor(192, 192, 192));
  p->drawRect(clientRect);
  p->setFont(font);
  m_pScrButton1->show();
  m_pScrButton2->show();
  m_pStaticCtrl->show();
}

void DoraSpinBox::OnSize(int cx, int cy)
{
  clientRect.setX(0);
  clientRect.setY(0);
  clientRect.setWidth(cx);
  clientRect.setHeight(cy);

  QFontMetrics fm(font);
  QSize sizeFont = fm.size(SingleLine, "H", 1);
  int wFont = sizeFont.width();
  int hFont = fm.height() - fm.descent();
  int w = maxLen * wFont;
  int h = hFont + 3;
  int wButton = cy;
  int hButton = cy;

  QRect rectButton1;
  rectButton1.setX(0);
  rectButton1.setY(0);
  rectButton1.setWidth(wButton);
  rectButton1.setHeight(hButton);
  m_pScrButton1->setGeometry(rectButton1);
  m_pScrButton1->hide();

  int xe = rectButton1.width() + 1;
  int ye = 0;
  int we = w + 3;
  int he = h;
  
  QRect editRect;
  editRect.setX(xe);
  editRect.setY(ye);
  editRect.setWidth(we);
  editRect.setHeight(he);
  m_pStaticCtrl->setGeometry(editRect);
  m_pStaticCtrl->hide();

  int xb = rectButton1.width() + editRect.width() + 2;
  int yb = 0;
  int wb = wButton;
  int hb = hButton;

  QRect rectButton2;
  rectButton2.setX(xb);
  rectButton2.setY(yb);
  rectButton2.setWidth(wb);
  rectButton2.setHeight(hb);
  m_pScrButton2->setGeometry(rectButton2);
  m_pScrButton2->hide();

}

void DoraSpinBox::OnCreate(DoraClassObject *pObject, DoraBaseView *pView, const int lenEdit)
{
  m_pObject = pObject;
  m_pView   = pView;
  maxLen = lenEdit;
  setFont(font);
  DoraRuntimeClass *runtimeScrBarButton1 = RUNTIME_CLASS(DoraScrBarButton);
  DoraClassObject  *objectScrBarButton1  = runtimeScrBarButton1->CreateView(this);
  m_pScrButton1 = dynamic_cast<DoraScrBarButton *>(objectScrBarButton1);
  m_pScrButton1->OnCreate(m_pObject, this, ID_SCROLLBARBUTTON_LEFT);
  m_pScrButton1->hide();

  DoraRuntimeClass *runtimeScrBarButton2 = RUNTIME_CLASS(DoraScrBarButton);
  DoraClassObject *objectScrBarButton2 = runtimeScrBarButton2->CreateView(this);
  m_pScrButton2 = dynamic_cast<DoraScrBarButton *>(objectScrBarButton2);
  m_pScrButton2->OnCreate(m_pObject, this, ID_SCROLLBARBUTTON_RIGHT);
  m_pScrButton2->hide();

  DoraRuntimeClass *runtimeStaticCtrl = RUNTIME_CLASS(DoraStaticCtrl);
  DoraClassObject  *objectStaticCtrl = runtimeStaticCtrl->CreateView(this);
  m_pStaticCtrl = dynamic_cast<DoraStaticCtrl *>(objectStaticCtrl);
  m_pStaticCtrl->convChar = convChar;
  m_pStaticCtrl->selectNewFont(font);
  m_pStaticCtrl->OnCreate(m_pObject, this);
  Str35 caption;
  caption = "";
  m_pStaticCtrl->setCaption(caption);
  m_pStaticCtrl->setColor(QColor(0, 0, 0), QColor(0, 0, 0), QColor(255, 255, 255));
  m_pStaticCtrl->hide();
}

void DoraSpinBox::setSpin(const int minVal, const int maxVal, const int stepVal)
{
  min = minVal;
  max = maxVal;
  nVal = minVal;
  step = stepVal;

  Str35 sMinVal;
  sMinVal = "";sprintf(sMinVal.p, "%d\0", nVal);
  m_pStaticCtrl->setCaption(sMinVal);
  m_pStaticCtrl->repaint();
}

void DoraSpinBox::PostMouseMessage(int ctrl, int index)
{
  printf(" DoraSpinBox\n");
  if(ctrl == POST_SCROLLBARBUTTON_RIGHT) {
    printf("     !\n");
    setPlus();
  }
  if(ctrl == POST_SCROLLBARBUTTON_LEFT) {
    printf("     !\n");
    setMinus();
  }

  CString value;
  value = "";value = getValue();
  int val = atoi(value.p);
  if(m_pView != NULL)
    m_pView->PostMouseMessage(POST_SPINBOX, val);
}

void DoraSpinBox::setPlus()
{
  Str35 strValue;
  nVal += step;
  if((nVal > max) && (max != 0))
    nVal = min;
  strValue = "";sprintf(strValue.p, "%d\0", nVal);
  m_pStaticCtrl->setCaption(strValue);
  m_pStaticCtrl->repaint();
}

void DoraSpinBox::setMinus()
{
  Str35 strValue;
  nVal -= step;
  if((nVal < min) && (min != 0))
    nVal = max;
  if(nVal < 0)
    nVal = max;
  strValue = "";sprintf(strValue.p, "%d\0", nVal);
  m_pStaticCtrl->setCaption(strValue);
  m_pStaticCtrl->repaint();
}

CString DoraSpinBox::getValue()
{
  Str35 value;
  value = "";value = m_pStaticCtrl->getValue();
  CString sValue;
  sValue = "";sprintf(sValue.p, "%s\0", value.p);

  return sValue;
}

void DoraSpinBox::setDefaultValue(const int valDefault)
{
  nVal = valDefault;
  Str35 sMinVal;
  sMinVal = "";sprintf(sMinVal.p, "%d\0", nVal);
  m_pStaticCtrl->setCaption(sMinVal);
  m_pStaticCtrl->repaint();
}
