#if !defined(_DORASPINBOX_H)
#define _DORASPINBOX_H

#include <qapplication.h>
#include <qwidget.h>
#include <qevent.h>
#include <qpainter.h>
#include <qcolor.h>
#include <qbrush.h>
#include <qrect.h>
#include <qfont.h>
#include <qfontmetrics.h>

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <ctype.h>
#include <typeinfo>

#include "Typedef.h"
#include "Dynacolect.h"
#include "DoraClassObject.h"
#include "DoraBaseView.h"
#include "DoraStaticCtrl.h"
#include "DoraScrBarButton.h"

class DoraSpinBox : public DoraBaseView
{
public:
  DoraRuntimeClass *GetRuntimeClass() const {
    return &classDoraSpinBox;
  }
  static DoraRuntimeClass classDoraSpinBox;
  static DoraClassObject *CreateView(QWidget *parent);
  static DoraClassObject *CreateDocument();

public:
  DoraSpinBox(QWidget *parent, const char *name = 0) : DoraBaseView(parent, name) {
    printf("   DoraSpinBox\n");
  }

  ~DoraSpinBox() {
    printf("   DoraSpinBox\n");
  }

public:
  void OnDraw(QPainter *p);
  void OnSize(int cx, int cy);
  void setSpin(const int minVal, const int maxVal, const int stepVal);
  void setDefaultValue(const int valDefault);

public:
  DoraClassObject  *m_pObject;
  DoraBaseView     *m_pView;
  DoraStaticCtrl   *m_pStaticCtrl;
  DoraScrBarButton *m_pScrButton1;
  DoraScrBarButton *m_pScrButton2;

public:
  void OnCreate(DoraClassObject *pObject, DoraBaseView *pView, const int lenEdit);

public:
  QRect clientRect;
  int   maxLen;
  int   min;
  int   max;
  int   nVal;
  int   step;
  int   ctrlID;
  int   nID;

public:
  void PostMouseMessage(int ctrl, int index);
  void setPlus();
  void setMinus();
  CString getValue();

};

#endif
