#if !defined(_DORASPINGROUP_H)
#define _DORASPINGROUP_H

#include <qapplication.h>
#include <qwidget.h>
#include <qevent.h>
#include <qfont.h>
#include <qfontmetrics.h>
#include <qpainter.h>
#include <qcolor.h>
#include <qrect.h>
#include <qfontdialog.h>

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <ctype.h>
#include <typeinfo>

#include "Typedef.h"
#include "Dynacolect.h"
#include "DoraClassObject.h"
#include "DoraBaseView.h"
#include "DoraSpinBox.h"

class DoraSpinGroup : public DoraBaseView
{
public:
  struct strSpin {
    DoraSpinBox *spinBox;
    QRect rect;
    strSpin(strSpin *x = NULL) {
      spinBox = NULL;
      rect.setX(0);
      rect.setY(0);
      rect.setWidth(0);
      rect.setHeight(0);
    }
    strSpin(const strSpin &x) {
      spinBox = x.spinBox;
      rect.setX(x.rect.x());
      rect.setY(x.rect.y());
      rect.setWidth(x.rect.width());
      rect.setHeight(x.rect.height());
    }
    strSpin &operator=(strSpin x) {
      spinBox = x.spinBox;
      rect.setX(x.rect.x());
      rect.setY(x.rect.y());
      rect.setWidth(x.rect.width());
      rect.setHeight(x.rect.height());
      return *this;
    }
  };

  typedef DoraArray<strSpin> TypeSpinArray;

public:
  DoraRuntimeClass *GetRuntimeClass() const {
    return &classDoraSpinGroup;
  }
  static DoraRuntimeClass classDoraSpinGroup;
  static DoraClassObject *CreateView(QWidget *parent);
  static DoraClassObject *CreateDocument();

public:
  DoraSpinGroup(QWidget *parent, const char *name = 0) : DoraBaseView(parent, name) {
    printf("   DoraSpinGroup\n");
  }
  ~DoraSpinGroup() {
    printf("   DoraSpinGroup\n");
  }

public:
  void OnDraw(QPainter *p);
  void OnSize(int cx, int cy);

public:
  void OnCreate(DoraClassObject *pObject, DoraBaseView *pView);
  DoraCentralDocument *GetDocument();

public:
  DoraClassObject *m_pObject;
  DoraBaseView    *m_pView;

public:
  QRect clientRect;
  Str35 caption[3];

public:
  TypeSpinArray itemSpin;

public:
  void UpdateTimeView();
  void PostMouseMessage(int ctrl, int index);
  void UpdateConvChar();

};

#endif

