#include "DoraStaticCtrl.h"

DoraRuntimeClass DoraStaticCtrl::classDoraStaticCtrl = {"DoraStaticCtrl", DoraStaticCtrl::CreateView, NULL};

DoraClassObject *DoraStaticCtrl::CreateView(QWidget *parent)
{
  return new DoraStaticCtrl(parent);
}

DoraClassObject *DoraStaticCtrl::CreateDocument()
{
  return NULL;
}

void DoraStaticCtrl::OnDraw(QPainter *p)
{
  QFontMetrics fm(font);
  QSize sizeFont = fm.size(SingleLine, "H", 1);
  int hFnt = fm.height() - fm.descent();
  int wFnt = sizeFont.width();

  if(isSelected) {
     p->setPen(QPen(sBordColor, 1));
     p->setBrush(QColor(sBackColor));
  } else {
    p->setPen(QPen(nBordColor, 1));
    p->setBrush(QColor(nBackColor));
  }
  p->drawRect(clientRect);
  p->setFont(font);

  if(nID == ID_STATUS_SEPARATOR) {
    int yc = (int)(clientRect.y() + (clientRect.height() / 2));
    int xs1 = clientRect.x();
    int ys1 = yc - 1;
    int xs2 = clientRect.width();
    int ys2 = yc + 1;
    p->setPen(QPen(QColor(0, 0, 0), 1));
    p->drawLine(xs1, ys2, xs1, ys1);
    p->drawLine(xs1, ys1, xs2, ys1);
    p->setPen(QPen(QColor(255, 255, 255), 1));
    p->drawLine(xs1, ys2, xs2, ys2);
    p->drawLine(xs2, ys2, xs2, ys1);
  }

  if((caption != "") && (nID != ID_STATUS_SEPARATOR)) {
    int xPos = clientRect.x() + 2;
    int yPos = (int)((clientRect.height() - hFnt) / 2) + (hFnt - 2);
    int len = strlen(caption.p);
    for(int i = 0; i <= len - 1; i++) {
      char *s = new char[2];
      s[0] = '\0';
      sprintf(s, "%c\0", caption.p[i]);
      QString qStr;
      qStr = "";qStr = convChar.getCharCodec(s);
      if(isSelected) {
	 p->setPen(QPen(sBordColor, 1));
	 p->setBrush(QBrush(sBackColor));
	 p->setPen(QPen(sTextColor, 1));
      } else {
	p->setPen(QPen(nBordColor, 1));
	p->setBrush(QBrush(nBackColor));
	p->setPen(QPen(nTextColor, 1));
      }
      p->drawText(xPos, yPos, qStr, 1);
      xPos += wFnt;
      delete s;
    }
  }
}

void DoraStaticCtrl::OnSize(int cx, int cy)
{
  clientRect.setX(0);
  clientRect.setY(0);
  clientRect.setWidth(cx);
  clientRect.setHeight(cy);
}

void DoraStaticCtrl::OnCreate(DoraClassObject *pObject, DoraBaseView *pView)
{
  setFont(font);
  m_pObject = pObject;
  m_pView   = pView;
  caption = "";
  nID = 1;
  setMouseTracking(TRUE);
}

void DoraStaticCtrl::MouseLeftButton(int xLocPos, int yLocPos, int xPosGlb, int yPosGlb)
{
  if(nID  != ID_STATUS_SEPARATOR) {
    if(status != ID_STATUS_EDIT) {
      enableSelected(true);
      repaint(false);
    }
    m_pView->PostMouseMessage(DM_STATICCTRL, nID);
  }
}

void DoraStaticCtrl::MouseMove()
{
  if((status != ID_STATUS_EDIT) && (nID != ID_STATUS_SEPARATOR)) {
    enableSelected(true);
    repaint(false);
    m_pView->PostMouseMove(nID);
  }
}

void DoraStaticCtrl::MouseRelease()
{
}

void DoraStaticCtrl::setCaption(Str35 nCaption)
{
  caption = "";
  caption = nCaption;
}

void DoraStaticCtrl::setCaption(CString nCaption)
{
  caption = "";
  caption = nCaption;
}

void DoraStaticCtrl::setCaption(char *nCaption)
{
  caption = "";
  caption = nCaption;
}

void DoraStaticCtrl::setColor(QColor txtColor, QColor brdColor, QColor bckColor)
{
  nTextColor = txtColor;
  nBordColor = brdColor;
  nBackColor = bckColor;
}

void DoraStaticCtrl::setSelectColor(QColor txtColor, QColor brdColor, QColor bckColor)
{
  sTextColor = txtColor;
  sBordColor = brdColor;
  sBackColor = bckColor;
}

Str35 DoraStaticCtrl::getValue()
{
  Str35 value;
  value = "";value = caption.p;
  return value;
}

void DoraStaticCtrl::enableSelected(const bool selected)
{
  isSelected = selected;
}
