#if !defined(_DORASTATICCTRL_H)
#define _DORASTATICCTRL_H

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <ctype.h>
#include <typeinfo>

#include <qwidget.h>
#include <qrect.h>
#include <qfont.h>
#include <qfontmetrics.h>
#include <qpainter.h>
#include <qevent.h>

#include "Typedef.h"
#include "DoraClassObject.h"
#include "DoraBaseCtrl.h"
#include "DoraBaseView.h"

class DoraStaticCtrl : public DoraBaseCtrl
{
public:
  DoraRuntimeClass *GetClassObject() const {
    return &classDoraStaticCtrl;
  }
  static DoraRuntimeClass classDoraStaticCtrl;
  static DoraClassObject  *CreateView(QWidget *parent);
  static DoraClassObject  *CreateDocument();

public:
  DoraStaticCtrl(QWidget *parent, const char *name = 0) : DoraBaseCtrl(parent, name) {
    printf("   DoraStaticCtrl\n");
    isSelected = false;
    status = ID_STATUS_EDIT;
  }
  ~DoraStaticCtrl() {
    printf("   DoraStaticCtrl\n");
  }

public:
  void OnDraw(QPainter *p);
  void OnSize(int cx, int cy);

public:
  QRect   clientRect;
  int     nID;
  CString caption;
  QColor  nTextColor;
  QColor  nBordColor;
  QColor  nBackColor;
  QColor  sTextColor;
  QColor  sBordColor;
  QColor  sBackColor;

public:
  void OnCreate(DoraClassObject *pObject, DoraBaseView *pView);
  void setCaption(Str35 nCaption);
  void setCaption(CString nCaption);
  void setCaption(char *nCaption);
  void setColor(QColor txtColor, QColor brdColor, QColor bckColor);
  void setSelectColor(QColor txtColor, QColor brdColor, QColor bckColor);
  void enableSelected(const bool selected);
  Str35 getValue();

public:
  DoraClassObject *m_pObject;
  DoraBaseView    *m_pView;
  bool            isSelected;
  int             status;

public:
  void MouseLeftButton(int xLocPos, int yLocPos, int xPosGlb, int yPosGlb);
  void MouseMove();
  void MouseRelease();

};

#endif
