#include "DoraToolButton.h"

DoraRuntimeClass DoraToolButton::classDoraToolButton={"DoraToolButton", DoraToolButton::CreateView, NULL};

DoraClassObject *DoraToolButton::CreateView(QWidget *parent)
{
  return new DoraToolButton(parent);
}

DoraClassObject *DoraToolButton::CreateDocument()
{
  return NULL;
}

void DoraToolButton::OnCreate(DoraClassObject *pObject, DoraBaseView *pView)
{
  m_pObject = pObject;
  m_pDialog = NULL;
  m_pView   = pView;

  if(nID == ID_TOOLBUTTON_NEW) {
    QPixmap pm(bmp_new);
    setPixmap(pm);
  }
  if(nID == ID_TOOLBUTTON_SAVE) {
    QPixmap pm(bmp_save);
    setPixmap(pm);
  }
  if(nID == ID_TOOLBUTTON_DELETE) {
    QPixmap pm(bmp_delete);
    setPixmap(pm);
  }
  if(nID == ID_TOOLBUTTON_SEARCH) {
    QPixmap pm(bmp_search);
    setPixmap(pm);
  }
  if(nID == ID_TOOLBUTTON_PREV) {
    QPixmap pm(bmp_button_prev);
    setPixmap(pm);
  }
  if(nID == ID_TOOLBUTTON_NEXT) {
    QPixmap pm(bmp_button_next);
    setPixmap(pm);
  }
  if(nID == ID_TOOLBUTTON_RECTOP) {
    QPixmap pm(bmp_button_top);
    setPixmap(pm);
  }
  if(nID == ID_TOOLBUTTON_RECEND) {
    QPixmap pm(bmp_button_bottom);
    setPixmap(pm);
  }
  if(nID == ID_TOOLBUTTON_SETBUFFER) {
    QPixmap pm(bmp_save_buffer);
    setPixmap(pm);
  }
  if(nID == ID_TOOLBUTTON_GETBUFFER) {
    QPixmap pm(bmp_load_buffer);
    setPixmap(pm);
  }
  if(nID == ID_TOOLBUTTON_DELBUFFER) {
    QPixmap pm(bmp_delete);
    setPixmap(pm);
  }
  if(nID == ID_TOOLBUTTON_EDIT) {
    QPixmap pm(bmp_button_cancel);
    setPixmap(pm);
  }
  if(nID == ID_TOOLBUTTON_TAXI) {
    QPixmap pm(bmp_button_cancel);
    setPixmap(pm);
  }
  if(nID == ID_TOOLBUTTON_NULLTAXI) {
    QPixmap pm(bmp_button_cancel);
    setPixmap(pm);
  }
}

void DoraToolButton::OnCreate(DoraClassObject *pObject, DoraBaseDialog *pDialog)
{
  m_pObject = pObject;
  m_pDialog = pDialog;
  m_pView   = NULL;

  if(nID == ID_TOOLBUTTON_NEW) {
    QPixmap pm(bmp_new);
    setPixmap(pm);
  }
  if(nID == ID_TOOLBUTTON_SAVE) {
    QPixmap pm(bmp_save);
    setPixmap(pm);
  }
  if(nID == ID_TOOLBUTTON_DELETE) {
    QPixmap pm(bmp_delete);
    setPixmap(pm);
  }
  if(nID == ID_TOOLBUTTON_SEARCH) {
    QPixmap pm(bmp_search);
    setPixmap(pm);
  }
  if(nID == ID_TOOLBUTTON_PREV) {
    QPixmap pm(bmp_button_prev);
    setPixmap(pm);
  }
  if(nID == ID_TOOLBUTTON_NEXT) {
    QPixmap pm(bmp_button_next);
    setPixmap(pm);
  }
  if(nID == ID_TOOLBUTTON_RECTOP) {
    QPixmap pm(bmp_button_top);
    setPixmap(pm);
  }
  if(nID == ID_TOOLBUTTON_RECEND) {
    QPixmap pm(bmp_button_bottom);
    setPixmap(pm);
  }
  if(nID == ID_TOOLBUTTON_SETBUFFER) {
    QPixmap pm(bmp_save_buffer);
    setPixmap(pm);
  }
  if(nID == ID_TOOLBUTTON_GETBUFFER) {
    QPixmap pm(bmp_load_buffer);
    setPixmap(pm);
  }
  if(nID == ID_TOOLBUTTON_DELBUFFER) {
    QPixmap pm(bmp_delete);
    setPixmap(pm);
  }
  if(nID == ID_TOOLBUTTON_EDIT) {
    QPixmap pm(bmp_button_cancel);
    setPixmap(pm);
  }
  if(nID == ID_TOOLBUTTON_TAXI) {
    QPixmap pm(bmp_button_cancel);
    setPixmap(pm);
  }
  if(nID == ID_TOOLBUTTON_NULLTAXI) {
    QPixmap pm(bmp_button_cancel);
    setPixmap(pm);
  }
}

void DoraToolButton::OnSize(int cx, int cy)
{
  clientRect.setX(0);
  clientRect.setY(0);
  clientRect.setWidth(cx);
  clientRect.setHeight(cy);
}

void DoraToolButton::OnDraw(QPainter *p)
{
  p->setFont(font);
  p->setPen(QPen(QColor(0, 0, 0), 1));
  p->setBrush(QBrush(QColor(192, 192, 192)));
  p->drawRect(clientRect);

  int x1 = clientRect.x();
  int y1 = clientRect.y();
  int x2 = clientRect.width() - 1;
  int y2 = clientRect.height() - 1;

  int xl1 = x1 + 1;
  int yl1 = y1 + 1;
  int xl2 = x2 - 1;
  int yl2 = y2 - 1;

  int wPmap = pixmap.width();
  int hPmap = pixmap.height();

  int xPmap = x1 + ((int)((clientRect.width() - wPmap) / 2));
  int yPmap = y1 + ((int)((clientRect.height() - hPmap) / 2));

  if(!okPushed) {
    p->setPen(QPen(QColor(255, 255, 255), 1));
    p->drawLine(xl1, yl2, xl1, yl1);
    p->drawLine(xl1, yl1, xl2, yl1);
    p->setPen(QPen(QColor(0, 0, 0), 1));
    p->drawLine(xl1, yl2, xl2, yl2);
    p->drawLine(xl2, yl2, xl2, yl1);
    p->drawPixmap(xPmap, yPmap, pixmap);
  }
  if(okPushed) {
    p->setPen(QPen(QColor(0, 0, 0), 1));
    p->drawLine(xl1, yl2, xl1, yl1);
    p->drawLine(xl1, yl1, xl2, yl1);
    p->setPen(QPen(QColor(255, 255, 255), 1));
    p->drawLine(xl1, yl2, xl2, yl2);
    p->drawLine(xl2, yl2, xl2, yl1);
    p->drawPixmap(xPmap + 1, yPmap + 1, pixmap);
  }
}

void DoraToolButton::MouseLeftButton(int xLocPos, int yLocPos, int xPosGlb, int yPosGlb)
{
  okPushed = true;
  repaint(false);
}

void DoraToolButton::setPushed(const bool pushed)
{
  okPushed = pushed;
  repaint(false);
}

void DoraToolButton::MouseRelease()
{
  if(m_pView != NULL)
    m_pView->PostMouseMessage(ctrlID, index);
  if(m_pDialog != NULL)
    m_pDialog->PostMouseMessage(ctrlID, index);
}

void DoraToolButton::setPixmap(QPixmap pm)
{
  pixmap = pm;
}
