#if !defined(_DORATOOLBUTTON_H)
#define _DORATOOLBUTTON_H

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <ctype.h>
#include <typeinfo>

#include <qapplication.h>
#include <qwidget.h>
#include <qevent.h>
#include <qpainter.h>
#include <qrect.h>
#include <qcolor.h>
#include <qfont.h>
#include <qfontmetrics.h>
#include <qpixmap.h>

#include "Typedef.h"
#include "resurce.h"
#include "DoraClassObject.h"
#include "DoraBaseView.h"
#include "DoraBaseCtrl.h"
#include "DoraBaseDialog.h"

class DoraToolButton : public DoraBaseCtrl
{
public:
  DoraRuntimeClass *GetRuntimeClass() const {
    return &classDoraToolButton;
  }
  static DoraRuntimeClass classDoraToolButton;
  static DoraClassObject *CreateView(QWidget *parent);
  static DoraClassObject *CreateDocument();

public:
  DoraToolButton(QWidget *parent, const char *name = 0) : DoraBaseCtrl(parent, name) {
    printf("   DoraToolButton\n");
    okPushed = false;
  }
  ~DoraToolButton() {
    printf("   DoraToolButton\n");
  }

public:
  void OnDraw(QPainter *p);
  void OnSize(int cx, int cy);
  void setPushed(const bool pushed);
  void setPixmap(QPixmap pm);

public:
  void OnCreate(DoraClassObject *pObject, DoraBaseView *pView);
  void OnCreate(DoraClassObject *pObject, DoraBaseDialog *pDialog);

public:
  DoraClassObject *m_pObject;
  DoraBaseView    *m_pView;
  DoraBaseDialog  *m_pDialog;

public:
  QRect   clientRect;
  bool    okPushed;
  int     ctrlID;
  int     nID;
  int     index;
  QPixmap pixmap;

public:
  void MouseLeftButton(int xLocPos, int yLocPos, int xPosGlb, int yPosGlb);
  void MouseRelease();
};

#endif
