#include "DoraCentralDocument.h"
#include "DoraCentralView.h"
#include "DoraMainFrame.h"
#include "DoraToolView.h"

DoraRuntimeClass DoraToolView::classDoraToolView={"DoraToolView", DoraToolView::CreateView, NULL};

DoraClassObject *DoraToolView::CreateView(QWidget *parent)
{
  return new DoraToolView(parent);
}

DoraClassObject *DoraToolView::CreateDocument()
{
  return NULL;
}

void DoraToolView::OnCreate(DoraClassObject *pObject, DoraBaseView *pView)
{
  m_pObject = pObject;
  m_pDialog = NULL;
  m_pView   = pView;

}

void DoraToolView::OnCreate(DoraClassObject *pObject, DoraBaseDialog *pDialog)
{
  m_pObject = pObject;
  m_pDialog = pDialog;
  m_pView   = NULL;
}

void DoraToolView::OnDraw(QPainter *p)
{
  p->setFont(font);
  p->setPen(QPen(QColor(0, 0, 0), 1));
  p->setBrush(QBrush(QColor(192, 192, 192)));
  p->drawRect(clientRect);


  int x1 = clientRect.x();
  int y1 = clientRect.y();
  int x2 = clientRect.width() - 1;
  int y2 = clientRect.height() - 1;

  int xl1 = x1 + 1;
  int yl1 = y1 + 1;
  int xl2 = x2 - 1;
  int yl2 = y2 - 1;

  p->setPen(QPen(QColor(255, 255, 255), 1));
  p->drawLine(xl1, yl2, xl1, yl1);
  p->drawLine(xl1, yl1, xl2, yl1);
  p->setPen(QPen(QColor(0, 0, 0), 1));
  p->drawLine(xl1, yl2, xl2, yl2);
  p->drawLine(xl2, yl2, xl2, yl1);

  xl1 = x1 + 3;
  yl1 = y1 + 3;
  xl2 = x2 - 3;
  yl2 = y2 - 3;
  
  p->setPen(QPen(QColor(0, 0, 0), 1));
  p->drawLine(xl1, yl2, xl1, yl1);
  p->drawLine(xl1, yl1, xl2, yl1);
  p->setPen(QPen(QColor(255, 255, 255), 1));
  p->drawLine(xl1, yl2, xl2, yl2);
  p->drawLine(xl2, yl2, xl2, yl1);

  int maxElement = itemToolButton.maxElement();
  for(int i = 0; i <= maxElement - 1; i++) {
    itemToolButton[i].button->show();
  }
  
  QFontMetrics fm(font);
  QSize fontSize = fm.size(SingleLine, "H", 1);
  int wf = fontSize.width();
  int hf = fm.height() - fm.descent();
  for(int i = 0; i <= maxElement - 1; i++) {
    int x = clientRect.x() + itemToolButton[i].xb + itemToolButton[i].wb + 6;
    int y = itemToolButton[i].yb + hf;
    CString cap1;
    cap1 = "";cap1 = itemToolButton[i].cap1;
    int len = strlen(cap1.p);
    for(int j = 0; j <= len - 1; j++) {
      char *s = new char[2];
      s[0] = '\0';
      sprintf(s, "%c\0", cap1.p[j]);
      QString qStr;
      qStr = "";qStr = convChar.getCharCodec(s);
      p->setPen(QPen(QColor(0, 0, 0), 1));
      p->setBrush(QBrush(QColor(192, 192, 192)));
      p->drawText(x, y, qStr);
      p->drawText(x + 1, y + 1, qStr);
      x += (wf + 1);
      delete s;
    }
    x = clientRect.x() + itemToolButton[i].xb + itemToolButton[i].wb + 6;
    y = itemToolButton[i].yb + (2 * hf) + 1;
    CString cap2;
    cap2 = "";cap2 = itemToolButton[i].cap2;
    len = strlen(cap2.p);
    for(int j = 0; j <= len - 1; j++) {
      char *s = new char[2];
      s[0] = '\0';
      sprintf(s, "%c\0", cap2.p[j]);
      QString qStr;
      qStr = "";qStr = convChar.getCharCodec(s);
      p->setPen(QPen(QColor(0, 0, 0), 1));
      p->setBrush(QBrush(QColor(192, 192, 192)));
      p->drawText(x, y, qStr);
      p->drawText(x + 1, y + 1, qStr);
      x += (wf + 1);
      delete s;
    }
  }

  if(caption != "") {
    int len = strlen(caption.p);
    int x = wf;
    int y = (x1 + 6) + hf;
    for(int i = 0; i <= len - 1; i++) {
      char *s = new char[2];
      s[0] = '\0';
      sprintf(s, "%c\0", caption.p[i]);
      QString qStr;
      qStr = "";qStr = convChar.getCharCodec(s);
      p->setPen(QPen(QColor(0, 0, 0), 1));
      p->setBrush(QBrush(QColor(0, 0, 255)));
      p->drawText(x, y, qStr);
      x += wf;
      delete s;
    }
  }
}

void DoraToolView::OnSize(int cx, int cy)
{
  clientRect.setX(0);
  clientRect.setY(0);
  clientRect.setWidth(cx);
  clientRect.setHeight(cy);

  QFontMetrics fm(font);
  QSize sizeFont = fm.size(SingleLine, "H", 1);
  int wf = sizeFont.width();
  int hf = fm.height() - fm.descent();

  int x = clientRect.x() + 8;
  int y = clientRect.y() + hf + 10;
  int w = wButton;
  int h = hButton;
  int maxElement = itemToolButton.maxElement();
  for(int i = 0; i <= maxElement - 1; i++) {
    QRect rect;
    rect.setX(x);
    rect.setY(y);
    rect.setWidth(w);
    rect.setHeight(h);
    itemToolButton[i].button->setGeometry(rect);
    itemToolButton[i].button->hide();
    strToolButton item;
    item = itemToolButton[i];
    item.xb = x;
    item.yb = y;
    item.wb = w;
    item.hb = h;
    itemToolButton.setElement(item, i + 1);
    y += (h + 1);
  }
  
}

DoraCentralDocument *DoraToolView::GetCentralDocument()
{
  DoraMainFrame *m_pMainFrame = dynamic_cast<DoraMainFrame *>(m_pObject);
  DoraCentralDocument *pDoc = m_pMainFrame->GetDocument();
  return pDoc;
}

void DoraToolView::setToolButton(const int index)
{
  DoraMainFrame *m_pMainFrame = dynamic_cast<DoraMainFrame *>(m_pObject);
  DoraCentralDocument *pDoc = m_pMainFrame->GetDocument();
  Str35 prefix;
  prefix = "";prefix = pDoc->itemLangName[pDoc->curentLang - 1].prefix;
  attr.setToolDialog(prefix);
  int maxElement = attr.itemAttr.maxElement();
  for(int i = 0; i <= maxElement - 1; i++) {
    strToolButton item;
    DoraRuntimeClass *runtimeToolButton = RUNTIME_CLASS(DoraToolButton);
    DoraClassObject *objectToolButton = runtimeToolButton->CreateView(this);
    item.button = dynamic_cast<DoraToolButton *>(objectToolButton);
    item.button->selectNewFont(font);
    item.button->convChar = convChar;
    item.button->ctrlID = attr.itemAttr[i].ctrlID;
    item.button->nID = attr.itemAttr[i].nID;
    item.button->OnCreate(m_pObject, this);
    item.button->hide();
    item.button->index = i + 1;
    item.cap1 = attr.itemAttr[i].cap1;
    item.cap2 = attr.itemAttr[i].cap2;
    itemToolButton.setElement(item, i + 1);
  }
}

void DoraToolView::PostMouseMessage(int ctrl, int index)
{
  itemToolButton[index-1].button->setPushed(false);
  DoraMainFrame *m_pMainFrame = dynamic_cast<DoraMainFrame *>(m_pObject);
  DoraCentralView *m_pCentralView = m_pMainFrame->GetCentralView();

  int idButton = itemToolButton[index-1].button->nID;
  if(m_pDialog != NULL)
    m_pDialog->PostMouseMessage(nID, idButton);
}

void DoraToolView::DestroyView()
{
  int maxElement = itemToolButton.maxElement();
  for(int i = 0; i <= maxElement - 1; i++) {
    DoraToolButton *button;
    button = itemToolButton[i].button;
    button->hide();
    delete button;
    button = NULL;
  }
  itemToolButton.removeAllElement();
}
