#if !defined(_DORATOOLVIEW_H)
#define _DORATOOLVIEW_H

#include <qapplication.h>
#include <qwidget.h>
#include <qevent.h>
#include <qfont.h>
#include <qfontmetrics.h>
#include <qpainter.h>
#include <qcolor.h>
#include <qrect.h>
#include <qfontdialog.h>

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <ctype.h>
#include <typeinfo>

#include "Typedef.h"
#include "Dynacolect.h"
#include "DoraClassObject.h"
#include "DoraBaseView.h"
#include "DoraBaseDialog.h"
#include "DoraToolButton.h"
#include "AttrToolView.h"

class DoraToolView : public DoraBaseView
{
public:
  struct strToolButton {
    DoraToolButton *button;
    Str35 cap1;
    Str35 cap2;
    int xb, yb, wb, hb;
    strToolButton(strToolButton *x = NULL) {
      button = NULL;
      cap1 = "";
      cap2 = "";
    }
    strToolButton(const strToolButton &x) {
      button = x.button;
      cap1 = x.cap1;
      cap2 = x.cap2;
      xb = x.xb;
      yb = x.yb;
      wb = x.wb;
      hb = x.hb;
    }
    strToolButton &operator=(strToolButton x) {
      button = x.button;
      cap1 = x.cap1;
      cap2 = x.cap2;
      xb = x.xb;
      yb = x.yb;
      wb = x.wb;
      hb = x.hb;
      return *this;
    }
  };
  typedef DoraArray<strToolButton> TypeToolButton;

public:
  DoraRuntimeClass *GetClassObject() const {
    return &classDoraToolView;
  }
  static DoraRuntimeClass classDoraToolView;
  static DoraClassObject *CreateView(QWidget *parent);
  static DoraClassObject *CreateDocument();

public:
  DoraToolView(QWidget *parent, const char *name = 0) : DoraBaseView(parent, name) {
    printf("   DoraToolView\n");
    itemToolButton.removeAllElement();
    caption = "";
  }
  ~DoraToolView() {
    printf("   DoraToolView\n");
  }

public:
  void OnCreate(DoraClassObject *pObject, DoraBaseView *pView);
  void OnCreate(DoraClassObject *pObject, DoraBaseDialog *pDialog);

public:
  void OnDraw(QPainter *p);
  void OnSize(int cx, int cy);
  void DestroyView();

public:
  DoraClassObject *m_pObject;
  DoraBaseView    *m_pView;
  DoraBaseDialog  *m_pDialog;
  AttrToolView    attr;

public:
  DoraCentralDocument *GetCentralDocument();

public:
  QRect          clientRect;
  TypeToolButton itemToolButton;
  int            nID, hButton, wButton;
  CString        caption;

public:
  void setToolButton(const int index);

public:
  void PostMouseMessage(int ctrl, int index);

};

#endif
