#include "DoraVScrollBar.h"

DoraRuntimeClass DoraVScrollBar::classDoraVScrollBar = {"DoraVScrollBar", DoraVScrollBar::CreateView, NULL};

DoraClassObject *DoraVScrollBar::CreateView(QWidget *parent)
{
  return new DoraVScrollBar(parent);
}

DoraClassObject *DoraVScrollBar::CreateDocument()
{
  return NULL;
}

void DoraVScrollBar::OnDraw(QPainter *p)
{
  p->setPen(QColor(0, 0, 0));
  p->drawRect(clientRect);
  m_pButtonUp->show();
  m_pButtonDown1->show();
  m_pButtonDown2->show();
}

void DoraVScrollBar::OnSize(int cx, int cy)
{
  clientRect.setX(0);
  clientRect.setY(0);
  clientRect.setWidth(cx);
  clientRect.setHeight(cy);

  QRect buttonUpRect;
  QRect buttonDownRect1;
  QRect buttonDownRect2;

  buttonUpRect.setX(0);
  buttonUpRect.setY(0);
  buttonUpRect.setWidth(cx);
  buttonUpRect.setHeight(cx);
  m_pButtonUp->setGeometry(buttonUpRect);
  m_pButtonUp->hide();

  buttonDownRect1.setX(0);
  buttonDownRect1.setY(cy - cx);
  buttonDownRect1.setWidth(cx);
  buttonDownRect1.setHeight(cx);
  m_pButtonDown1->setGeometry(buttonDownRect1);
  m_pButtonDown1->hide();

  buttonDownRect2.setX(0);
  buttonDownRect2.setY((cy - (2 * cx)) - 1);
  buttonDownRect2.setWidth(cx);
  buttonDownRect2.setHeight(cx);
  m_pButtonDown2->setGeometry(buttonDownRect2);
  m_pButtonDown2->hide();
  
}

void DoraVScrollBar::OnCreate(DoraClassObject *pObject, DoraBaseView *pView)
{
  m_pObject = pObject;
  m_pView   = pView;
  
  DoraRuntimeClass *runtimeButtonUp = RUNTIME_CLASS(DoraScrBarButton);
  DoraClassObject  *objectButtonUp  = runtimeButtonUp->CreateView(this);
  m_pButtonUp = dynamic_cast<DoraScrBarButton *>(objectButtonUp);
  m_pButtonUp->OnCreate(m_pObject, this, ID_SCROLLBARBUTTON_UP);
  m_pButtonUp->hide();

  DoraRuntimeClass *runtimeButtonDown1 = RUNTIME_CLASS(DoraScrBarButton);
  DoraClassObject  *objectButtonDown1  = runtimeButtonDown1->CreateView(this);
  m_pButtonDown1 = dynamic_cast<DoraScrBarButton *>(objectButtonDown1);
  m_pButtonDown1->OnCreate(m_pObject, this, ID_SCROLLBARBUTTON_DOWN);
  m_pButtonDown1->hide();

  DoraRuntimeClass *runtimeButtonDown2 = RUNTIME_CLASS(DoraScrBarButton);
  DoraClassObject  *objectButtonDown2  = runtimeButtonDown2->CreateView(this);
  m_pButtonDown2 = dynamic_cast<DoraScrBarButton *>(objectButtonDown2);
  m_pButtonDown2->OnCreate(m_pObject, this, ID_SCROLLBARBUTTON_UP);
  m_pButtonDown2->hide();  
}

void DoraVScrollBar::PostMouseMessage(int ctrl, int index)
{
  if(m_pView != NULL) {
    switch(ctrl) {
    case POST_SCROLLBARBUTTON_UP :
      printf("DoraVScrollBar -> PostMouseMessage ->  \n");
      break;
    case POST_SCROLLBARBUTTON_DOWN :
      printf("DoraVScrollBar -> PostMouseMessage ->  \n");
      break;
    }
    m_pView->PostMouseMessage(ctrl, index);
  }
}

  










