#if !defined(_DORAVSCROLLBAR_H)
#define _DORAVSCROLLBAR_H

#include <qapplication.h>
#include <qwidget.h>
#include <qevent.h>
#include <qrect.h>
#include <qcolor.h>
#include <qbrush.h>
#include <qfont.h>
#include <qfontmetrics.h>
#include <qpainter.h>

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <ctype.h>
#include <typeinfo>

#include "Typedef.h"
#include "Dynacolect.h"
#include "DoraClassObject.h"
#include "DoraBaseCtrl.h"
#include "DoraBaseView.h"
#include "DoraScrBarButton.h"

class DoraVScrollBar : public DoraBaseView
{
public:
  DoraRuntimeClass *GetClassObject() const {
    return &classDoraVScrollBar;
  }

  static DoraRuntimeClass classDoraVScrollBar;
  static DoraClassObject *CreateView(QWidget *parent);
  static DoraClassObject *CreateDocument();

public:
  DoraVScrollBar(QWidget *parent, const char *name = 0) : DoraBaseView(parent, name) {
    printf("   DoraVScrollBar\n");
    m_pButtonUp = NULL;
    m_pButtonDown1 = NULL;
    m_pButtonDown2 = NULL;
  }

  ~DoraVScrollBar() {
    printf("   DoraVScrollBar\n");
  }

public:
  void OnDraw(QPainter *p);
  void OnSize(int cx, int cy);
  void PostMouseMessage(int ctrl, int index);

public:
  void OnCreate(DoraClassObject *pObject, DoraBaseView *pView);

public:  
  QRect clientRect;

public:
  DoraClassObject *m_pObject;
  DoraBaseView    *m_pView;

public:
  DoraScrBarButton *m_pButtonUp;
  DoraScrBarButton *m_pButtonDown1;
  DoraScrBarButton *m_pButtonDown2;

};

#endif






