#include "Dynacolect.h"

ColsItem::ColsItem() 
{
  itemColl.removeAllElement();
  maxColumns = itemColl.maxElement();
}

ColsItem::~ColsItem() {
  itemColl.removeAllElement();
  maxColumns = 0;
}

void ColsItem::addColumn(const int count = 1) 
{
  if(count >= 1) {
    itemColl.setSize(count);
  }
  maxColumns = itemColl.maxElement();
}

void ColsItem::insertColumn(int index) 
{
  itemColl.insertElement(index);
  maxColumns = itemColl.maxElement();
}
  
void ColsItem::insertColumn(int index, const int count = 1) 
{
  for(int i = 0; i <= count; i++)
    itemColl.insertElement(index);
  maxColumns = itemColl.maxElement();
}

void ColsItem::removeColumn(int index) 
{
  itemColl.removeElement(index);
  maxColumns = itemColl.maxElement();
}

void ColsItem::removeAllColumn() 
{
  itemColl.removeAllElement();
  maxColumns = 0;
}

void ColsItem::setDataColumn(Cols x, int index) 
{
  itemColl.setElement(x, index);
  maxColumns = itemColl.maxElement();
}

void ColsItem::setDataColumn(CString s, int index) 
{
  Cols x;
  x.cell = "";
  x.cell = s;
  itemColl.setElement(x, index);
  maxColumns = itemColl.maxElement();
}

CString ColsItem::getDataColumn(int index) 
{
  CString s;
  s = "";
  if((index >= 0) && (index <= maxColumns - 1)) {
    s = "";
    s = itemColl[index].cell;
  } else {
    s = "";
  }
  return s;
}

int ColsItem::maxColumn() 
{
  return maxColumns;
}

DoraTable:: DoraTable() 
{
  rowItem.removeAllElement();
  maxRow = rowItem.maxElement();
}

DoraTable::~DoraTable() 
{
  rowItem.removeAllElement();
  maxRow = 0;
}

void DoraTable::addColumns(const int countCol = 1) 
{
   if(maxRow >= 1) {
     for(int i = 0; i <= maxRow - 1; i++) {
       ColsItem *coll = new ColsItem();
       coll->addColumn((countCol + rowItem[0].collItem->maxColumn()));
       DoraColumn cols;
       for(int j = 0; j <= rowItem[i].collItem->maxColumn() - 1; j++) {	  
	 CString s;
	 s = "";
	 s = rowItem[i].collItem->getDataColumn(j);
	 coll->setDataColumn(s, j + 1);
       }
       cols.collItem = coll;
       rowItem.setElement(cols, i + 1);
     }
   } else {
     rowItem.setSize(20);
     maxRow = rowItem.maxElement();
     ColsItem *coll = new ColsItem();
     coll->addColumn(countCol);
     DoraColumn cols;
     cols.collItem = coll;
     for(int i = 0; i <= maxRow - 1; i++) {
       rowItem.setElement(cols, i + 1);
     }
   }
   maxRow = rowItem.maxElement();
}

void DoraTable::addRow(const int countRow = 1) 
{
  if(maxRow >= 1) {
    ColsItem *coll = new ColsItem();
    coll->addColumn(rowItem[0].collItem->maxColumn());
    DoraColumn cols;
    cols.collItem = coll;
    for(int i = maxRow - 1; i <= (maxRow + countRow) - 1; i++) {
      rowItem.setElement(cols, i + 1);
    }
  } else {
    rowItem.setSize(countRow);
    ColsItem *coll = new ColsItem();
    coll->addColumn(20);
    DoraColumn cols;
    cols.collItem = coll;
    for(int i = 0; i <= countRow - 1; i++) {
      rowItem.setElement(cols, i + 1);
    }
  }
  maxRow = rowItem.maxElement();
}

int DoraTable::maxRows() {
  return rowItem.maxElement();
}

int DoraTable::maxCol() {
  return rowItem[0].collItem->maxColumn();
}

void DoraTable::setData(CString s, int rowIndex, int colIndex)
{
  if(maxRow >= 1) {
    if((rowIndex >= 1) && (rowIndex <= maxRow)) {
      ColsItem *coll = new ColsItem();
      coll->addColumn(rowItem[rowIndex-1].collItem->maxColumn());
      DoraColumn cols;
      for(int i = 0; i <= rowItem[rowIndex-1].collItem->maxColumn() - 1; i++) {
	CString x;
	if(i == colIndex - 1) {
	  x = "";
	  x = s;
	  coll->setDataColumn(x, colIndex);
	} else {
	  x = "";
	  x = rowItem[rowIndex-1].collItem->getDataColumn(i);
	  coll->setDataColumn(x, i + 1);
	}
      }
      cols.collItem = coll;
      rowItem.setElement(cols, rowIndex); 
    }
  }
}

CString DoraTable::getData(int rowIndex, int colIndex)
{
  CString s;
  s = "";
  if(maxRow >= 1) {
    if((rowIndex >= 1) && (rowIndex <= maxRow)) {
      s = "";
      s = rowItem[rowIndex-1].collItem->getDataColumn(colIndex - 1);
    } else {
      s = "";
    }
  } else {
    s = "";
  }
  
  return s;
}

void DoraTable::insertColumn(int index, const int countCol = 1)
{
  for(int i = 0; i <= maxRow - 1; i++) {
    rowItem[i].collItem->insertColumn(index, countCol);
  }
}

void DoraTable::insertRow(int index, int const countRow = 1)
{
  for(int i = 1; i <= countRow; i++) {
    ColsItem *coll = new ColsItem();
    coll->addColumn(rowItem[0].collItem->maxColumn());
    DoraColumn cols;
    cols.collItem = coll;
    rowItem.insertElement(cols, index);
  }
  maxRow = rowItem.maxElement();
}

void DoraTable::removeColumn(int index, const int countCol = 1)
{
  for(int i = 0; i <= maxRow - 1; i++) {
    for(int j = 0; j <= countCol - 1; j++) {
      rowItem[i].collItem->removeColumn(index);
    }
  }
}

void DoraTable::removeRow(int index, const int countRow = 1)
{
  for(int i = 0; i <= maxRow - 1; i++) {
    rowItem.removeElement(index);
  }
  maxRow = rowItem.maxElement();
}

void DoraTable::removeAllRow()
{
  rowItem.removeAllElement();
  maxRow = rowItem.maxElement();
}


