#if !defined(_TYPEDEF_H)
#define _TYPEDEF_H

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <ctype.h>
#include <string.h>
#include <math.h>
#include <time.h>
#include <typeinfo>
#include <qstring.h>

#include "resurce.h"

typedef unsigned char  uchar;
typedef unsigned short ushort;
typedef unsigned int   uint;
typedef unsigned long  ulong;

#define RUNTIME_CLASS(class_name)(&class_name::class##class_name)

#define DM_PUSHBUTTON     0
#define DM_TOOLBARBUTTON  1
#define DM_MENUBARBUTTON  2
#define DM_KEYBUTTON      3
#define DM_MOUSEBUTTON    4
#define DM_MENUDIALOG     5
#define DM_STATICCTRL     6
#define DM_SPINCTRL       7
#define DM_CALENDARBUTTON 8
#define DM_CHECKBUTTON    9
#define DM_TOOLBUTTON    10
#define DM_EDITDIALOG    11
#define DM_TABLEBOX      12

#define ID_TOOLBUTTON_NEW        600
#define ID_TOOLBUTTON_SAVE       601
#define ID_TOOLBUTTON_DELETE     602
#define ID_TOOLBUTTON_SEARCH     607
#define ID_TOOLBUTTON_PREV       603
#define ID_TOOLBUTTON_NEXT       604
#define ID_TOOLBUTTON_RECTOP     605
#define ID_TOOLBUTTON_RECEND     606
#define ID_TOOLBUTTON_SETBUFFER  608
#define ID_TOOLBUTTON_GETBUFFER  609
#define ID_TOOLBUTTON_DELBUFFER  610
#define ID_TOOLBUTTON_EDIT       611
#define ID_TOOLBUTTON_TAXI       612
#define ID_TOOLBUTTON_NULLTAXI   613

#define ID_DIALOG_MENU0000       100
#define ID_DIALOG_MENU0101       101
#define ID_DIALOG_MENU0102       102
#define ID_DIALOG_MENU0103       103
#define ID_DIALOG_MENU0104       104
#define ID_DIALOG_MENU0105       105
#define ID_DIALOG_MENU0106       106
#define ID_DIALOG_MENU0107       107
#define ID_DIALOG_MENU0108       108

#define ID_PUSHBUTTON_OK          500
#define ID_PUSHBUTTON_EXIT        501
#define ID_PUSHBUTTON_SAVE        502
#define ID_PUSHBUTTON_SEARCH      503
#define ID_PUSHBUTTON_DATE1       504
#define ID_PUSHBUTTON_DATE2       505

#define ID_CHECK_BUTTON_PLUSMINUS 300
#define ID_CHECK_BUTTON_PUSH      301
#define ID_CHECK_BUTTON_CHECKER   302 

#define ID_SCROLLBARBUTTON_UP     700
#define ID_SCROLLBARBUTTON_DOWN   701
#define ID_SCROLLBARBUTTON_LEFT   702
#define ID_SCROLLBARBUTTON_RIGHT  703

#define POST_CHECK_GROUP           800
#define POST_SCROLLBARBUTTON_UP    801
#define POST_SCROLLBARBUTTON_DOWN  802
#define POST_SCROLLBARBUTTON_LEFT  803
#define POST_SCROLLBARBUTTON_RIGHT 804
#define POST_COMBOBOX              805
#define POST_STATICCTRL            806
#define POST_HEAD_DIALOG           807
#define POST_OTHER_DIALOG          808
#define POST_SCROLLBOX             809
#define POST_SPINBOX               810

#define ID_SIGNAL_SAVERECORD       900
#define ID_SIGNAL_SAVENEXTRECORD   901
#define ID_SIGNAL_TOPRECORD        902
#define ID_SIGNAL_BOTRECORD        903
#define ID_SIGNAL_PREVRECORD       904
#define ID_SIGNAL_NEXTRECORD       905
#define ID_SIGNAL_DELETERECORD     906
#define ID_SIGNAL_OTHERSIGNAL      907
#define ID_SIGNAL_MENUBUTTON       908
#define ID_SIGNAL_POPUPMENU        909
#define ID_SIGNAL_CLOSE_ABAUTVIEW  910

#define ID_STATUS_CHECK           1001
#define ID_STATUS_SEPARATOR       1002
#define ID_STATUS_EDIT            1003
#define ID_STATUS_READONLY        1004
#define ID_STATUS_NOTREADONLY     1005
#define ID_STATUS_STATIC          1006

#define ID_STATUS_BUTTON_NORMAL   2001
#define ID_STATUS_BUTTON_MOVE     2002
#define ID_STATUS_BUTTON_PUSHED   2003

#define ID_TABBAR_MENU            1101
#define ID_TABBAR_ALPHA           1102
#define ID_TOOLVIEW_RECORD        1103
#define ID_TOOLVIEW_BUFFER        1104
#define ID_TOOLVIEW_DIALOG        1105
#define ID_TABBAR_CALENDAR        1106

#define ID_COMBOBOX_CALENDAR      1201
#define ID_COMBOBOX_ENCODING      1202
#define ID_COMBOBOX_DIALOG        1203
#define ID_COMBOBOX_LANG          1204
#define ID_COMBOBOX_MENU          1205
#define ID_COMBOBOX_OTHER         1206

#define ID_CHECKBUTTON_ALLCICLE   1301
#define ID_CHECKBUTTON_PHICICLE   1302
#define ID_CHECKBUTTON_SENCICLE   1303
#define ID_CHECKBUTTON_CONCICLE   1304

#define ID_SCROLLBOX_CALENDAR     2101
#define ID_SCROLLBOX_ENCODING     2102
#define ID_SCROLLBOX_LANG         2103

#define ID_PUSHGROUP              3100

template <int MAX_ELEMENT> class Str
{
public:
  char p[MAX_ELEMENT+1];
  
  operator char*() {
    return p;
  }

  char operator [](int index) {
    return p[index];
  }

  Str<MAX_ELEMENT> operator=(const Str<MAX_ELEMENT> x) {
    p[0] = '\0';    
    int len = (int)strlen(x.p);
    if(x.p[0] != '\0') {
      sprintf(p, "%s\0", x.p);
    }
    return *this;
  }

  Str<MAX_ELEMENT> operator=(const char *x) {
    p[0] = '\0';
    int len = (int)strlen(x);
    if(x[0] != '\0') {
      if(len >= MAX_ELEMENT) {
	for(int i = 0; i <= MAX_ELEMENT; i++) {
	  char *s = new char[2];
	  s[0] = '\0';sprintf(s, "%c\0", x[i]);
	  strcat(p, s);
	  delete s;
	}
      } else {
	sprintf(p, "%s\0", x);
      }
    }
    return *this;
  }

  /*
  Str<MAX_ELEMENT> operator=(CString x) {
    p[0] = '\0';
    int len = strlen(x.p);
    if(x.p[0] != '\0') {
      if(len >= MAX_ELEMENT) {
	CString s;
	s = "";s = copyStr(x, 1, MAX_ELEMENT);
	sprintf(p, "%s\0", s.p);
	len = MAX_ELEMENT;
      } else {
	sprintf(p, "%s\0", x.p);
      }
    }
    return *this;
  }    

  Str<MAX_ELEMENT> operator=(const QString x) {
    CString s, s1;
    int len = x.length() + 1;
    if(len >= MAX_ELEMENT) {
      s = "";s = (char *)x.latin1();
      s1 = "";s1 = copyStr(s, 1, MAX_ELEMENT);
    } else {
      s1 = "";s1 = (char *)x.latin1();
    }
    p[0] = '\0';
    sprintf(p, "%s\0", s1.p);
    return *this;
  }
  */

  Str<MAX_ELEMENT> operator+(const Str<MAX_ELEMENT> x) {
    strcat(p, x.p);
    return *this;
  }

  Str<MAX_ELEMENT> operator+(const char *x) {
    strcat(p, x);
    return *this;
  }

  bool operator==(const Str<MAX_ELEMENT> x) {
    if(strcmp(p, x.p) == 0)
      return true;
    else
      return false;
  }

  bool operator==(const char *x) {
    if(strcmp(p, x) == 0)
      return true;
    else
      return false;
  }
  /*
  bool operator==(const CString x) {
    if(strcmp(p, x.p) == 0)
      return true;
    else
      return false;
  }
  */

  bool operator!=(const Str<MAX_ELEMENT> x) {
    if(strcmp(p, x.p) != 0)
      return true;
    else
      return false;
  }

  bool operator!=(const char *x) {
    if(strcmp(p, x) != 0)
      return true;
    else
      return false;
  }

  bool operator>(const Str<MAX_ELEMENT> x) {
    if(strcmp(p, x.p) > 0)
      return true;
    else
      return false;
  }

  bool operator>(const char *x) {
    if(strcmp(p, x) > 0)
      return true;
    else
      return false;
  }

  bool operator>=(const Str<MAX_ELEMENT> x) {
    if((strcmp(p, x.p) == 0) || (strcmp(p, x.p) > 0))
      return true;
    else
      return false;
  }

  bool operator>=(const char *x) {
    if((strcmp(p, x) == 0) || (strcmp(p, x) > 0))
      return true;
    else
      return false;
  }

  bool operator<(const Str<MAX_ELEMENT> x) {
    if(strcmp(p, x.p) < 0)
      return true;
    else
      return false;
  }

  bool operator<(const char *x) {
    if(strcmp(p, x) < 0)
      return true;
    else
      return false;
  }

  bool operator<=(const Str<MAX_ELEMENT> x) {
    if((strcmp(p, x.p) <= 0) || (strcmp(p, x.p) < 0))
      return true;
    else
      return false;
  }

  bool operator<=(const char *x) {
    if((strcmp(p, x) == 0) || (strcmp(p, x) < 0))
      return true;
    else
      return false;
  }

};

typedef Str<1024> String;
typedef Str<35> Str35;
typedef Str<80> Str80;
typedef Str<50> Str50;
typedef Str<255> Str255;

const int MAX_CHAR = 2;

class CString
{
public:
  CString() {
    size = MAX_CHAR;
    p = new char[size];
    p[0] = '\0';
  }

  CString(const int MaxSize) {
    size = (size_t)MaxSize;
    p = new char[size];
    p[0] = '\0';
  }

  CString(const CString &x) {
    size = strlen((char *)x.p) + 1;
    p = new char[size];
    p[0] = '\0';
    sprintf(p, "%s\0", x.p);
  }

  CString(const char *x) {
    size = strlen(x) + 1;
    p = new char[size];
    p[0] = '\0';
    sprintf(p, "%s\0", x);
  }

  CString(const String x) {
    size = strlen(x.p) + 1;
    p = new char[size];
    p[0] = '\0';
    sprintf(p, "%s\0", x.p);
  }

  CString(const QString x) {
    size = x.length() + 1;
    p = new char[size];
    p[0] = '\0';
    sprintf(p, "%s\0", (char *)x.latin1());
  }
  
  CString(const Str35 x) {
    size = strlen(x.p) + 1;
    p = new char[size];
    p[0] = '\0';
    sprintf(p, "%s\0", x.p);
  }

  CString operator=(const CString &x) {
    if(x.p[0] == '\0') {
      p[0] = '\0';
      delete p;
    } else {
      if(p[0] != '\0') {
	p[0] = '\0';
	delete p;
      }
    }
    size = strlen(x.p) + 1;
    p = new char[size];
    p[0] = '\0';
    sprintf(p, "%s\0", x.p);

    return *this;
  }

  CString operator=(const char *x) {
    if(x[0] == '\0') {
      p[0] = '\0';
      delete p;
    } else {
      if(p[0] != '\0') {
	p[0] = '\0';
	delete p;
      }
    }
    size = strlen(x) + 1;
    p = new char[size];
    p[0] = '\0';
    sprintf(p, "%s\0", x);
    return *this;
  }

  CString operator=(const String x) {
    if(x.p[0] == '\0') {
      p[0] = '\0';
      delete p;
    } else {
      if(p[0] != '\0') {
	p[0] = '\0';
	delete p;
      }
    }
    size = strlen(x.p) + 1;
    p = new char[size];
    p[0] = '\0';
    sprintf(p, "%s\0", x.p);
    return *this;
  }

  CString operator=(const QString x) {
    size = x.length() + 1;
    char *s = new char[size];
    sprintf(s, "%s\0", (char *)x.latin1());
    if(s[0] == '\0') {
      p[0] = '\0';
      delete p;
    } else {
      if(p[0] != '\0') {
	p[0] = '\0';
	delete p;
      }
    }
    delete s;
    size = x.length() + 1;
    p = new char[size];
    sprintf(p, "%s\0", (char *)x.latin1());
    return *this;
  }

  CString operator=(const Str35 x) {
    if(x.p[0] == '\0') {
      p[0] = '\0';
      delete p;
    } else {
      if(p[0] != '\0') {
	p[0] = '\0';
	delete p;
      }
    }
    size = strlen(x.p) + 1;
    p = new char[size];
    p[0] = '\0';
    sprintf(p, "%s\0", x.p);
    return *this;
  }

  CString operator+(const CString &x) {
    char *s;
    size = (strlen(p) + strlen(x.p)) + 1;
    s = new char[size];
    s[0] = '\0';
    sprintf(s, "%s%s\0", p, x.p);
    if(p[0] != '\0') {
      p[0] = '\0';
      delete p;
    }
    p = new char[size];
    p[0] = '\0';
    sprintf(p, "%s\0", s);
    delete s;
    return *this;
  }

  CString operator+(const char *x) {
    char *s;
    size = (strlen(p) + strlen(x)) + 1;
    s = new char[size];
    s[0] = '\0';
    sprintf(s, "%s%s\0", p, x);
    if(p[0] != '\0') {
      p[0] = '\0';
      delete p;
    }
    p = new char[size];
    p[0] = '\0';
    sprintf(p, "%s\0", s);
    delete s;
    return *this;
  }

  CString operator+(const String x) {
    char *s;
    size = (strlen(p) + strlen(x.p)) + 1;
    s = new char[size];
    s[0] = '\0';
    sprintf(s, "%s%s\0", p, x.p);
    if(p[0] != '\0') {
      p[0] = '\0';
      delete p;
    }
    p = new char[size];
    p[0] = '\0';
    sprintf(p, "%s\0", s);
    delete s;
    return *this;
  }

  CString operator+(const QString x) {
    char *s;
    size = strlen(p) + x.length() + 1;
    s = new char[size];
    s[0] = '\0';
    sprintf(s, "%s%s\0", p, (char *)x.latin1());
    if(p[0] != '\0') {
      p[0] = '\0';
      delete p;
    }
    p = new char[size];
    p[0] = '\0';
    sprintf(p, "%s\0", s);
    delete s;
    return *this;
  }

  CString operator+(const Str35 x) {
    char *s;
    size = (strlen(p) + strlen(x.p)) + 1;
    s = new char[size];
    s[0] = '\0';
    sprintf(s, "%s%s\0", p, x.p);
    if(p[0] != '\0') {
      p[0] = '\0';
      delete p;
    }
    p = new char[size];
    p[0] = '\0';
    sprintf(p, "%s\0", s);
    delete s;
    return *this;
  }

  bool operator==(const CString x) {
    if(strcmp(p, x.p) == 0)
      return true;
    else
      return false;
  }

  bool operator==(const char *x) {
    if(strcmp(p, x) == 0)
      return true;
    else
      return false;
  }

  bool operator==(const String x) {
    if(strcmp(p, x.p) == 0)
      return true;
    else
      return false;
  }

  bool operator==(const QString x) {
    char *s;
    s = new char[x.length() + 1];
    s[0] = '\0';
    sprintf(s, "%s\0", (char *)x.latin1());
    if(strcmp(p, s) == 0) {
      delete s;
      return true;
    } else {
      delete s;
      return false;
    }
  }
      
  bool operator!=(const CString x) {
    if(x.p[0] == '\0') {
      if((x.p[0] == '\0') && (p[0] == '\0'))
	return false;
      else
	return true;
    } else {
      if(strcmp(p, x.p) != 0)
	return true;
      else
	return false;
    }
  }

  bool operator!=(const char *x) {
    if(x[0] == '\0') {
      if((x[0] == '\0') && (p[0] == '\0'))
	return false;
      else
	return true;
    } else {
      if(strcmp(p, x) != 0)
	return true;
      else
	return false;
    }
  }

  bool operator!=(const String x) {
    if(strcmp(p, x.p) != 0)
      return true;
    else
      return false;
  }

  bool operator!=(const QString x) {
    char *s;
    s = new char[x.length() + 1];
    s[0] = '\0';
    sprintf(s, "%s\0", (char *)x.latin1());
    if(strcmp(p, s) != 0) {
      delete s;
      return true;
    } else {
      delete s;
      return false;
    }
  }

  bool operator>(const CString x) {
    if(strcmp(p, x.p) > 0)
      return true;
    else
      return false;
  }

  bool operator>(const char *x) {
    if(strcmp(p, x) > 0)
      return true;
    else
      return false;
  }

  bool operator>(const QString x) {
    char *s;
    s = new char[x.length() + 1];
    s[0] = '\0';
    sprintf(s, "%s\0", (char *)x.latin1());
    if(strcmp(p, s) > 0) {
      delete s;
      return true;
    } else {
      delete s;
      return false;
    }
  }

  bool operator>=(const CString x) {
    if((strcmp(p, x.p) > 0) || (strcmp(p, x.p) == 0))
      return true;
    else
      return false;
  }

  bool operator>=(const char *x) {
    if((strcmp(p, x) > 0) || (strcmp(p, x) == 0))
      return true;
    else
      return false;
  }

  bool operator>=(const QString x) {
    char *s;
    s = new char[x.length() + 1];
    s[0] = '\0';
    sprintf(s, "%s\0", (char *)x.latin1());
    if((strcmp(p, s) > 0) || (strcmp(p, s) == 0)) {
      delete s;
      return true;
    } else {
      delete s;
      return false;
    }
  }   

  bool operator<(const CString x) {
    if(strcmp(p, x.p) < 0)
      return true;
    else
      return false;
  }

  bool operator<(const char *x) {
    if(strcmp(p, x) < 0)
      return true;
    else
      return false;
  }

  bool operator<(const QString x) {
    char *s;
    s = new char[x.length() + 1];
    s[0] = '\0';
    sprintf(s, "%s\0", (char *)x.latin1());
    if(strcmp(p, s) < 0) {
      delete s;
      return true;
    } else {
      delete s;
      return false;
    }
  }

  bool operator<=(const CString x) {
    if((strcmp(p, x.p) < 0) || (strcmp(p, x.p) == 0))
      return true;
    else
      return false;
  }

  bool operator<=(const char *x) {
    if((strcmp(p, x) < 0) || (strcmp(p, x) == 0))
      return true;
    else
      return false;
  }

  bool operator<=(const QString x) {
    char *s;
    s = new char[x.length() + 1];
    s[0] = '\0';
    sprintf(s, "%s\0", (char *)x.latin1());
    if((strcmp(p, s) < 0) || (strcmp(p, s) == 0)) {
      delete s;
      return true;
    } else {
      delete s;
      return false;
    }
  }
  
  int length() {
    len = (int)strlen(p);
    return len;
  }

  char operator [](int index) {
    return p[index];
  }

  ~CString() {
    delete p;
  }

public:    
    char *p;
    size_t size;
    int len;

};

struct DataRecord {
  short int RecNo;
  char  DelNo;
  Str35 Pole[20];

  DataRecord(DataRecord *x = NULL) {
    RecNo = 0;
    DelNo = '\0';
    for(int i = 0; i <= 19; i++)
      Pole[i] = "";
  }

  DataRecord(const DataRecord &x) {
    RecNo = x.RecNo;
    DelNo = x.DelNo;
    for(int i = 0; i <= 19; i++) {
      Pole[i] = "";
      Pole[i] = x.Pole[i];
    }
  }

  DataRecord &operator=(DataRecord x) {
    RecNo = x.RecNo;
    DelNo = x.DelNo;
    for(int i = 0; i <= 19; i++) {
      Pole[i] = "";
      Pole[i] = x.Pole[i];
    }
    return *this;
  }
};

struct DataReclams {
  Str35 langName, encodingName, prefix;
  Str50 pole[10];
  DataReclams(DataReclams *x = NULL) {
    langName = "";
    encodingName = "";
    prefix = "";
    for(int i = 0; i <= 9; i++)
      pole[i] = "";
  }
  DataReclams(const DataReclams &x) {
    langName = x.langName;
    encodingName = x.encodingName;
    prefix = x.prefix;
    for(int i = 0; i <= 9; i++) {
      pole[i] = "";pole[i] = x.pole[i];
    }
  }
  DataReclams &operator=(DataReclams x) {
    langName = x.langName;
    encodingName = x.encodingName;
    prefix = x.prefix;
    for(int i = 0; i <= 9; i++) {
      pole[i] = "";pole[i] = x.pole[i];
    }
    return *this;
  }
};

struct RecordAttr {
  Str35 legal;
  Str35 name;
  int   xPos;
  int   yPos;
  int   len;
  int   status;

  RecordAttr(RecordAttr *x = NULL) {
    legal = "";
    name  = "";
  }

  RecordAttr(const RecordAttr &x) {
    legal = "";
    legal = x.legal;
    name  = "";
    name  = x.name;
    xPos  = x.xPos;
    yPos  = x.yPos;
    len   = x.len;
    status = x.status;
  }

  RecordAttr &operator=(RecordAttr x) {
    legal = "";
    legal = x.legal;
    name  = "";
    name  = x.name;
    xPos  = x.xPos;
    yPos  = x.yPos;
    len   = x.len;
    status = x.status;
    return *this;
  }  
};

void insertStr(CString &src, CString dest, int pos);
void insertStr(CString &src, char   *dest, int pos);
void insertStr(CString &src, String  dest, int pos);
void insertStr(Str35   &src, Str35   dest, int pos);

void deleteStr(CString &src, int pos, int count);
void deleteStr(Str35   &src, int pos, int count);

CString copyStr(const CString src, const int pos, const int count);
CString copyStr(const char   *src, const int pos, const int count);
CString copyStr(const String  src, const int pos, const int count);
Str35   copyStr(const Str35   src, const int pos, const int count);

CString spaceNull(const int len, const CString src);
CString spaceNull(const int len, const char   *src);
CString spaceNull(const int len, const String  src);
Str35   spaceNull(const int len, const Str35   src);

int pos(const CString src, const char *dest);
int pos(const char   *src, const char *dest);
int pos(const String  src, const char *dest);
int pos(const Str35   src, const char *dest);

int posStr(const CString src, const char *dest);
int posStr(const char   *src, const char *dest);
int posStr(const String  src, const char *dest);
int posStr(const Str35   src, const char *dest);

CString upCase(const CString src);
CString upCase(const char   *src);
Str35   upCase(const Str35 src);

CString loCase(const CString src);
CString loCase(const char   *src);
Str35   loCase(const Str35 src);

Str35 clearNull(const Str35 src);




#endif




